<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.1
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Validate_functions_admin
 *
 * Функции валидации полей
 */
class Validate_functions_admin extends Diafan
{
	/**
	 * Валидация поля "Период действия"
	 *
	 * @return void
	 */
	public function validate_variable_date_start()
	{
		if($this->diafan->is_variable("created"))
		{
			$created = $this->diafan->unixdate($_POST["created"]);
		}
		if(! empty($_POST["date_start"]))
		{
			$date_start = $this->diafan->unixdate($_POST["date_start"]);
			if($this->diafan->variable("date_start") == 'date')
			{
				$mes = Validate::date($_POST["date_start"]);
			}
			else
			{
				$mes = Validate::datetime($_POST["date_start"]);
			}
			if(! empty($mes))
			{
				$this->diafan->set_error("date_start", $mes);
				return;
			}
			if(isset($created) && $created > $date_start)
			{
				$this->diafan->set_error("date_start", "Дата начала показа должна быть больше даты создания");
				return;
			}
		}
		if(! empty($_POST["date_finish"]))
		{
			$date_finish = $this->diafan->unixdate($_POST["date_finish"]);
			if($this->diafan->variable("date_finish") == 'date')
			{
				$mes = Validate::date($_POST["date_finish"]);
			}
			else
			{
				$mes = Validate::datetime($_POST["date_finish"]);
			}
			if(! empty($mes))
			{
				$this->diafan->set_error("date_start", $mes);
				return;
			}
			if(isset($created) && $created > $date_finish)
			{
				$this->diafan->set_error("date_start", "Дата окончания показа должна быть больше даты создания");
				return;
			}
		}
		if(isset($date_start) && isset($date_finish) && $date_start >= $date_finish)
		{
			$this->diafan->set_error("date_start", "Дата окончания показа должна быть больше даты начала показа");
			return;
		}
	}

	/**
	 * Валидация поля "Период действия"
	 *
	 * @return void
	 */
	public function validate_variable_date_finish(){}

	/**
	 * Редактирование поля "Дополнительные параметры"
	 * 
	 * @return void
	 */
	public function validate_variable_param()
	{
		$result = DB::query("SELECT id, type FROM {".$this->diafan->table."_param} WHERE trash='0'");
		while ($row = DB::fetch_array($result))
		{
			if($row["type"] == 'numtext')
			{
				$row["type"] = 'floattext';
			}
			$this->diafan->validate_variable("param".$row["id"], $row["type"]);
		}
	}
}