<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.1
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Ads_admin_config
 *
 * Конфигурация объявлений
 */
class Ads_admin_config extends Frame_admin
{
	/**
	 * @var array поля в базе данных для редактирования
	 */
	public $variables = array (
		'base' => array (
			'nastr' => array(
				'type' => 'numtext',
				'name' => 'Количество объявлений на странице',
			),
			'hr1' => 'hr',
			'format_date' => array(
				'type' => 'select',
				'name' => 'Формат даты',
			),
			'hr2' => 'hr',
			'cat' => array(
				'type' => 'checkbox',
				'name' => 'Использовать категории',
			),
			'count_list' => array(
				'type' => 'numtext',
				'name' => 'Количество объявлений в списке категорий',
				'help' => 'Для первой страницы модуля, где выходят по несколько объявлений из всех категорий.',
			),
			'childrens_elements' => array(
				'type' => 'checkbox',
				'name' => 'Показывать объявления подкатегорий',
				'help' => 'Для списков объявлений, если перейти в категорию имеющую подкатегории. Если не отмечена, в категории будет просто список подкатегорий. Если отмечена, в категории будут показаны объявления из вложенных подкатегорий.',
			),
			'hr3' => 'hr',
			'search_text' => array(
				'type' => 'checkbox',
				'name' => 'Искать по описанию',
			),
			'search_name' => array(
				'type' => 'checkbox',
				'name' => 'Искать по названию',
			),
			'hr4' => 'hr',
			'comments' => array(
				'type' => 'module',
				'name' => 'Подключить комментарии к объявлениям',
			),
			'tags' => array(
				'type' => 'module',
				'name' => 'Подключить теги',
			),
			'rating' => array(
				'type' => 'module',
				'name' => 'Показывать рейтинг объявлений',
			),
			'hr5' => 'hr',
			'rel_two_sided' => array(
				'type' => 'checkbox',
				'name' => 'В блоке похожих объявлений связь двусторонняя',
			),
			'format_date' => array(
				'type' => 'select',
				'name' => 'Формат даты',
			),
			'only_user' => array(
				'type' => 'checkbox',
				'name' => 'Добавлять объявления могут только зарегистрированные пользователи',
			),
			'hr6' => 'hr',
			'captcha' => array(
				'type' => 'checkbox',
				'name' => 'Использовать защитный код (каптчу)',
			),
			'add_message' => array(
				'type' => 'textarea',
				'name' => 'Сообщение после отправки',
				'multilang' => true,
			),
			'premoderation' => array(
				'type' => 'checkbox',
				'name' => 'Предмодерация объявлений',
			),
			'hr7' => 'hr',
			'themes' => array(
				'type' => 'function',
			),
			'theme_list' => array(
				'type' => 'none',
				'name' => 'Шаблон для списка элементов',
				'help' => 'Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_list' => array(
				'type' => 'none',
			),
			'theme_first_page' => array(
				'type' => 'none',
				'name' => 'Шаблон для первой страницы модуля (если подключены категории)',
				'help' => 'Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_first_page' => array(
				'type' => 'none',
			),
			'theme_id' => array(
				'type' => 'none',
				'name' => 'Шаблон для страницы элемента',
				'help' => 'Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_id' => array(
				'type' => 'none',
			),
			'theme_list_param' => array(
				'type' => 'none',
				'name' => 'Шаблон для списка элементов с одинаковой характеристикой',
				'help' => 'Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_list_param' => array(
				'type' => 'none',
			),
			'theme_list_search' => array(
				'type' => 'none',
				'name' => 'Шаблон для поиска элементов',
				'help' => 'Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_list_search' => array(
				'type' => 'none',
			),
			'theme_list_my' => array(
				'type' => 'none',
				'name' => 'Шаблон для объявлений пользователя',
				'help' => 'Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_list_my' => array(
				'type' => 'none',
			),
			'hr_admin_page' => 'hr',
			'admin_page'     => array(
				'type' => 'checkbox',
				'name' => 'Отдельный пункт в меню администрирования для каждого раздела сайта',
			),
		),
		'images' => array (
			'images' => array(
				'type' => 'module',
				'name' => 'Использовать изображения',
			),
		),
		'send_mails' => array (
			'emailconf' => array(
				'type' => 'function',
				'name' => 'E-mail, указываемый в обратном адресе пользователю',
			),
			'email' => array(
				'type' => 'none',
				'name' => 'впишите e-mail',
			),
			'hr7' => 'hr',
			'sendmailadmin' => array(
				'type' => 'checkbox',
				'name' => 'Уведомлять о поступлении новых объявлений на e-mail',
			),
			'emailconfadmin' => array(
				'type' => 'function',
				'name' => 'E-mail для уведомлений администратора',
			),
			'email_admin' => array(
				'type' => 'none',
				'name' => 'впишите e-mail',
			),
			'subject_admin' => array(
				'type' => 'text',
				'name' => 'Тема письма для уведомлений',
			),
			'message_admin' => array(
				'type' => 'textarea',
				'name' => 'Сообщение для уведомлений',
			),
		),
	);

	/**
	 * @var array названия табов
	 */
	public $tabs_name = array(
		'base' => 'Основные настройки',
		'images' => 'Изображения',
		'send_mails' => 'Сообщения и уведомления',
	);

	/**
	 * @var array настройки модуля
	 */
	public $config = array (
		'element_site', // делит элементы по разделам (страницы сайта, к которым прикреплен модуль)
		'config', // файл настроек модуля
	);

	/**
	 * @var array зависимости между полями
	 */
	public $show_tr_click_checkbox = array(
		'cat' => array(
			'count_list',
			'childrens_elements',
		),
	);

	/**
	 * @var array значения списков
	 */
	public $select_arr = array(
		'format_date' => array(
			0 => '1.05.2009',
			1 => '1 мая 2008 г.',
			2 => '1 мая',
			3 => '1 мая 2008, понедельник',
			4 => 'не отображать',
		),
	);

	/**
	 * Редактирование поля "Шаблон страницы для разных ситуаций"
	 * @return void
	 */
	public function edit_config_variable_themes()
	{
		$themes = array();
		if ($dir = opendir(ABSOLUTE_PATH."themes"))
		{
			while (($file = readdir($dir)) !== false)
			{
				if ($file != '.' && $file != '..' && $file != 'site.php')
				{
					$themes[] = $file;
				}
			}
		}
		arsort($themes);
		closedir($dir);

		$views = array();
		if ($dir = opendir(ABSOLUTE_PATH."modules/".$this->diafan->module."/views"))
		{
			while (($file = readdir($dir)) !== false)
			{
				if ($file != '.' && $file != '..')
				{
					if(! preg_match('/'.$this->diafan->module.'\.view\.([^\.]+)\.php/', $file, $match))
						continue;
					$views[$match[1]] = $file;
				}
			}
		}
		closedir($dir);

		echo '<tr>
			<td class="td_first">
				'.$this->diafan->variable_name("theme_list").'
			</td>
			<td>
				<select name="theme_list">
					<option value="">site.php</option>';
				foreach ($themes as $theme)
				{
					echo '<option value="'.$theme.'"'.($this->diafan->values["theme_list"] == $theme ? ' selected' : '').'>'.$theme.'</option>';
				}
				echo '
				</select>
				<select name="view_list">
					<option value="">'.$this->diafan->module.'.view.list.php</option>';
				foreach ($views as $key => $view)
				{
					if($view == $this->diafan->module.".view.list.php")
						continue;
					echo '<option value="'.$key.'"'.($this->diafan->values["view_list"] == $key ? ' selected' : '').'>'.$view.'</option>';
				}
				echo '
				</select>
				'.$this->diafan->help("theme_list").'
			</td>
		</tr>

		<tr>
			<td class="td_first">
				'.$this->diafan->variable_name("theme_first_page").'
			</td>
			<td>
				<select name="theme_first_page">
					<option value="">site.php</option>';
				foreach ($themes as $theme)
				{
					echo '<option value="'.$theme.'"'.($this->diafan->values["theme_first_page"] == $theme ? ' selected' : '').'>'.$theme.'</option>';
				}
				echo '
				</select>
				<select name="view_first_page">
					<option value="">'.$this->diafan->module.'.view.first_page.php</option>';
				foreach ($views as $key => $view)
				{
					if($view == $this->diafan->module.".view.first_page.php")
						continue;
					echo '<option value="'.$key.'"'.($this->diafan->values["view_first_page"] == $key ? ' selected' : '').'>'.$view.'</option>';
				}
				echo '
				</select>
				'.$this->diafan->help("theme_first_page").'
			</td>
		</tr>

		<tr>
			<td class="td_first">
				'.$this->diafan->variable_name("theme_id").'
			</td>
			<td>
				<select name="theme_id">
					<option value="">site.php</option>';
				foreach ($themes as $theme)
				{
					echo '<option value="'.$theme.'"'.($this->diafan->values["theme_id"] == $theme ? ' selected' : '').'>'.$theme.'</option>';
				}
				echo '
				</select>
				<select name="view_id">
					<option value="">'.$this->diafan->module.'.view.id.php</option>';
				foreach ($views as $key => $view)
				{
					if($view == $this->diafan->module.".view.id.php")
						continue;
					echo '<option value="'.$key.'"'.($this->diafan->values["view_id"] == $key ? ' selected' : '').'>'.$view.'</option>';
				}
				echo '
				</select>
				'.$this->diafan->help("theme_id").'
			</td>
		</tr>
		
		<tr>
			<td class="td_first">
				'.$this->diafan->variable_name("theme_list_param").'
			</td>
			<td>
				<select name="theme_list_param">
					<option value="">site.php</option>';
				foreach ($themes as $theme)
				{
					echo '<option value="'.$theme.'"'.($this->diafan->values["theme_list_param"] == $theme ? ' selected' : '').'>'.$theme.'</option>';
				}
				echo '
				</select>
				<select name="view_list_param">
					<option value="">'.$this->diafan->module.'.view.list.php</option>';
				foreach ($views as $key => $view)
				{
					if($view == $this->diafan->module.".view.list.php")
						continue;
					echo '<option value="'.$key.'"'.($this->diafan->values["view_list_param"] == $key ? ' selected' : '').'>'.$view.'</option>';
				}
				echo '
				</select>
				'.$this->diafan->help("theme_list_param").'
			</td>
		</tr>
		
		<tr>
			<td class="td_first">
				'.$this->diafan->variable_name("theme_list_search").'
			</td>
			<td>
				<select name="theme_list_search">
					<option value="">site.php</option>';
				foreach ($themes as $theme)
				{
					echo '<option value="'.$theme.'"'.($this->diafan->values["theme_list_search"] == $theme ? ' selected' : '').'>'.$theme.'</option>';
				}
				echo '
				</select>
				<select name="view_list_search">
					<option value="">'.$this->diafan->module.'.view.list.php</option>';
				foreach ($views as $key => $view)
				{
					if($view == $this->diafan->module.".view.list.php")
						continue;
					echo '<option value="'.$key.'"'.($this->diafan->values["view_list_search"] == $key ? ' selected' : '').'>'.$view.'</option>';
				}
				echo '
				</select>
				'.$this->diafan->help("theme_list_search").'
			</td>
		</tr>';
	}
}