<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.1
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if ( ! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Ads_model
 *
 * Модель модуля "Объявления"
 */
class Ads_model extends Model
{
	/**
	 * Генерирует данные для списка объявлений, если отключены категории
	 * 
	 * @return array
	 */
	public function list_()
	{
		if ($this->diafan->cat)
		{
			include ABSOLUTE_PATH . 'includes/404.php';
		}
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		$cache_meta = array(
			"name" => "list",
			"lang_id" => _LANG,
			"page" => $this->diafan->page > 1 ? $this->diafan->page : 1,
			"site_id" => $this->diafan->cid,
			"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0,
			"time" => $time,
			"year" => $this->diafan->year,
			"month" => $this->diafan->month,
			"day" => $this->diafan->day,
		);
		//кеширование
		if ( ! $this->result = $this->diafan->_cache->get($cache_meta, $this->diafan->module))
		{
			$this->result = array();

			if ($this->diafan->year || $this->diafan->month || $this->diafan->day)
			{
				if ($this->diafan->cat)
				{
					include ABSOLUTE_PATH . 'includes/404.php';
				}
				if (! $this->diafan->year || ! $this->diafan->month && $this->diafan->day)
				{
					include ABSOLUTE_PATH . 'includes/404.php';
				}
				if ($this->diafan->month)
				{
					$month_arr = array(
						'12' => $this->diafan->_('Декабрь', false),
						'11' => $this->diafan->_('Ноябрь', false),
						'10' => $this->diafan->_('Октябрь', false),
						'09' => $this->diafan->_('Сентябрь', false),
						'08' => $this->diafan->_('Август', false),
						'07' => $this->diafan->_('Июль', false),
						'06' => $this->diafan->_('Июнь', false),
						'05' => $this->diafan->_('Май', false),
						'04' => $this->diafan->_('Апрель', false),
						'03' => $this->diafan->_('Март', false),
						'02' => $this->diafan->_('Февраль', false),
						'01' => $this->diafan->_('Январь', false)
					);
					if ($this->diafan->day)
					{
						$this->result["titlemodule"] =
								sprintf(
								$this->diafan->_('Объявления за %s', false), $this->format_date(mktime(0, 0, 0, $this->diafan->month, $this->diafan->day, $this->diafan->year))
						);
					}
					else
					{
						$this->result["titlemodule"] =
								sprintf(
								$this->diafan->_('Объявления за %s %s года', false), $month_arr[$this->diafan->month], $this->diafan->year
						);
					}
				}
				else
				{
					$this->result["titlemodule"] =
							sprintf(
							$this->diafan->_('Объявления за %s год', false), $this->diafan->year
					);
				}

				$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));
				if($this->diafan->day)
				{
					$time1 = mktime(0, 0, 0, $this->diafan->month, $this->diafan->day, $this->diafan->year);
					$time2 = $time1 + 86400;
				}
				elseif($this->diafan->month)
				{
					$time1 = mktime(0, 0, 0, $this->diafan->month, 1, $this->diafan->year);
					$time2 = mktime(0, 0, 0, $this->diafan->month, date("t", $time1), $this->diafan->year) + 86400;
				}
				else
				{
					$time1 = mktime(0, 0, 0, 1, 1, $this->diafan->year);
					$time2 = mktime(0, 0, 0, 1, 1, $this->diafan->year + 1);
				}
				$time2 = $time2 < $time ? $time2 : $time;

				////navigation///
				$this->diafan->_paginator->page = $this->diafan->page;
				$this->diafan->_paginator->navlink = $this->diafan->_route->current_link("page");
				$this->diafan->_paginator->navlink_tpl = $this->diafan->_route->current_link("", array("page" => "%d"));
				$this->diafan->_paginator->nen = DB::query_result(
						"SELECT COUNT(DISTINCT e.id) FROM {ads} AS e"
						.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='ads'" : "")
						." WHERE e.[act]='1' AND e.trash='0'"
						." AND e.site_id=%d AND e.created>=%d AND e.created<%d"
						." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
						." AND (e.access='0'"
						.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
						.")",
						$this->diafan->cid, $time1, $time2, $time, $time
					);
				$links = $this->diafan->_paginator->get();
				////navigation///

				$result = DB::query_range(
						"SELECT e.id, e.created, e.[name], e.[anons], e.timeedit, e.cat_id, e.site_id FROM {ads} AS e"
						.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='ads'" : "")
						." WHERE e.[act]='1'"
						." AND e.trash='0' AND e.site_id=%d AND e.created>=%d AND e.created<%d"
						." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
						." AND (e.access='0'"
						.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
						.")"
						." GROUP BY e.id ORDER BY e.prior DESC, e.created DESC, e.id DESC",
						$this->diafan->cid, $time1, $time2, $time, $time,
						$this->diafan->_paginator->polog, $this->diafan->_paginator->nastr
					);
			}
			else
			{
				////navigation///
				$this->diafan->_paginator->page = $this->diafan->page;
				$this->diafan->_paginator->navlink = $this->diafan->_route->current_link("page");
				$this->diafan->_paginator->nen = DB::query_result(
						"SELECT COUNT(DISTINCT e.id) FROM {ads} AS e"
						.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='ads'" : "")
						." WHERE e.[act]='1' AND e.trash='0'"
						." AND e.site_id=%d AND e.created<%d"
						." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
						." AND (e.access='0'"
						.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
						.")",
						$this->diafan->cid, $time, $time, $time
					);
				$links = $this->diafan->_paginator->get();
				////navigation///

				$result = DB::query_range(
						"SELECT e.id, e.created, e.[name], e.[anons], e.timeedit, e.cat_id, e.site_id FROM {ads} AS e"
						.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='ads'" : "")
						." WHERE e.[act]='1' AND e.trash='0' AND e.site_id=%d AND e.created<%d"
						." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
						." AND (e.access='0'"
						.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
						.")"
						." GROUP BY e.id ORDER BY e.prior DESC, e.created DESC, e.id DESC",
						$this->diafan->cid, $time, $time, $time,
						$this->diafan->_paginator->polog, $this->diafan->_paginator->nastr
					);
			}
	
			$this->result["rows"] = $this->get_elements($result);

			$this->result["paginator"] = $links;

			//сохранение кеша
			$this->diafan->_cache->save($this->result, $cache_meta, $this->diafan->module);
		}

		if ($this->result["rows"])
		{
			foreach ($this->result["rows"] as $i => $row)
			{
				$this->result["rows"][$i]["tags"] = $this->diafan->_tags->get($row["id"]);

				$this->result["rows"][$i]["rating"] = $this->diafan->_rating->get($row["id"]);
			}
		}
		if($this->diafan->configmodules("theme_list"))
		{
			$this->result["theme"] = $this->diafan->configmodules("theme_list");
		}
		if($this->diafan->configmodules("view_list"))
		{
			$this->result["view"] = $this->diafan->configmodules("view_list");
		}
		else
		{
			$this->result["view"] = 'list';
		}

		$this->result["paginator"] = $this->diafan->_tpl->get('get', 'paginator', $this->result["paginator"]);

		return $this->result;
	}

	/**
	 * Генерирует данные для списка объявлений, найденных с помощью поиска
	 * 
	 * @return array
	 */
	public function list_search()
	{
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		$where_param = '';
		$where = '';
		$values = array();
		$getnav = '';
		$group = '';

		$this->get_where($where, $where_param, $values, $getnav, $group);

		$values[] = $time;
		$values[] = $time;

		////navigation//
		$this->diafan->_paginator->page = $this->diafan->page;
		$this->diafan->_paginator->get_nav = $getnav;
		$this->diafan->_paginator->navlink = $this->diafan->_route->current_link("page");
		$count_result = DB::query("SELECT DISTINCT s.id FROM {ads} AS s"
		. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=s.id AND a.module_name='ads'" : "")
		. $where_param
		. " WHERE s.[act]='1' AND s.trash='0'"
		. " AND (s.access='0'"
		. ($this->diafan->_user->id ? " OR s.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
		. ")"
		. $where
		." AND s.date_start<=%d AND (s.date_finish=0 OR s.date_finish>=%d)"
		." GROUP BY s.id".$group,
		$values);
		$this->diafan->_paginator->nen = DB::num_rows($count_result);

		$links = $this->diafan->_paginator->get();
		////navigation///

		$this->result["path"] = $this->get_path('ads');
		$this->result["titlemodule"] = $this->diafan->_('Поиск по объявлениям', false);
		if ( ! $this->diafan->_paginator->nen)
		{
			$this->result["err"] = $this->diafan->_('Извините, ничего не найдено.', false);
			if (! empty($_GET["module_ajax"]) && $_GET["module_ajax"] == "ads")
			{
				header('Content-Type: text/html; charset=utf-8');
				echo $this->result["err"];
				exit;
			}
			return $this->result;
		}

		$result = DB::query_range("SELECT DISTINCT s.id, s.[name], s.timeedit, s.[anons], s.cat_id, s.site_id, s.created FROM {ads} AS s"
		. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=s.id AND a.module_name='ads'" : "")
		. $where_param
		. " WHERE s.[act]='1' AND s.trash='0'"
		. " AND (s.access='0'"
		. ($this->diafan->_user->id ? " OR s.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
		. ")"
		. $where
		." AND s.date_start<=%d AND (s.date_finish=0 OR s.date_finish>=%d)"
		. " GROUP BY s.id".$group
		. " ORDER BY created DESC",
		$values, $this->diafan->_paginator->polog, $this->diafan->_paginator->nastr);

		$this->result["rows"] = $this->get_elements($result);

		$this->result["paginator"] = $this->diafan->_tpl->get('get', 'paginator', $links);

		if ($this->result["rows"])
		{
			foreach ($this->result["rows"] as $i => $row)
			{
				$this->useradmin($this->result["rows"][$i]);

				$this->result["rows"][$i]["tags"] = $this->diafan->_tags->get($row["id"]);

				$this->result["rows"][$i]["rating"] = $this->diafan->_rating->get($row["id"]);
			}
		}
		if($this->diafan->configmodules("theme_list_search"))
		{
			$this->result["theme"] = $this->diafan->configmodules("theme_list_search");
		}
		if($this->diafan->configmodules("view_list_search"))
		{
			$this->result["view"] = $this->diafan->configmodules("view_list_search");
		}
		else
		{
			$this->result["view"] = 'list';
		}

		if (! empty($_GET["module_ajax"]) && $_GET["module_ajax"] == "ads")
		{
			header('Content-Type: text/html; charset=utf-8');
			$this->result["ajax"] = true;
			$GLOBALS["include_ads_js"] = true;
			$this->result = $this->get_result();
			$this->diafan->_tpl->get($this->result["view"], 'ads', $this->result);
			exit;
		}

		return $this->result;
	}

	/**
	 * Генерирует данные для списка объявлений, соответствующих значению доп. характеристики
	 * 
	 * @return array
	 */
	public function list_param()
	{
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		$cache_meta = array(
			"name" => "list_param",
			"lang_id" => _LANG,
			"page" => $this->diafan->page > 1 ? $this->diafan->page : 1,
			"site_id" => $this->diafan->cid,
			"param" => $this->diafan->param,
			"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0,
			"time" => $time
		);
		//кеширование
		if ( ! $this->result = $this->diafan->_cache->get($cache_meta, $this->diafan->module))
		{
			$param_value = DB::fetch_array(DB::query("SELECT param_id, [name] FROM {ads_param_select} WHERE id=%d", $this->diafan->param));
			if ( ! $param_value = DB::fetch_array(DB::query("SELECT param_id, [name] FROM {ads_param_select} WHERE id=%d", $this->diafan->param)))
			{
				include ABSOLUTE_PATH . 'includes/404.php';
			}
			if ( ! $param = DB::fetch_array(DB::query("SELECT [name] FROM {ads_param} WHERE id=%d", $param_value["param_id"])))
			{
				include ABSOLUTE_PATH . 'includes/404.php';
			}
			////navigation//
			$this->diafan->_paginator->page = $this->diafan->page;
			$this->diafan->_paginator->navlink = $this->diafan->_route->current_link("page");

			$this->diafan->_paginator->nen =
			DB::query_result("SELECT COUNT(DISTINCT s.id) FROM {ads} AS s "
			. " INNER JOIN {ads_param_element} AS e ON e.element_id=s.id"
			. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=s.id AND a.module_name='ads'" : "")
			. " WHERE s.[act]='1' AND s.trash='0' AND e.param_id=%d AND e.value".$this->diafan->language_base_site."=%d"
			." AND s.date_start<=%d AND (s.date_finish=0 OR s.date_finish>=%d)",
			$param_value["param_id"], $this->diafan->param, $time, $time
			);
			$this->result["paginator"] = $this->diafan->_paginator->get();
			////navigation///

			$this->result["path"] = $this->get_path('ads');
			$this->result["titlemodule"] = $param["name"] . ': ' . $param_value["name"];

			$result = DB::query_range(
			"SELECT s.id, s.[name], s.timeedit, s.[anons], s.cat_id, s.site_id, s.created FROM {ads} AS s"
			. " INNER JOIN {ads_param_element} as e ON e.element_id=s.id"
			. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=s.id AND a.module_name='ads'" : "")
			. " WHERE s.[act]='1' AND s.trash='0' AND e.param_id=%d AND e.value".$this->diafan->language_base_site."=%d"
			." AND s.date_start<=%d AND (s.date_finish=0 OR s.date_finish>=%d)"
			. " AND (s.access='0'"
			. ($this->diafan->_user->id ? " OR s.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
			. ")"
			. " GROUP BY s.id"
			. " ORDER BY s.prior DESC, s.created DESC",
			$param_value["param_id"], $this->diafan->param, $time, $time,
			$this->diafan->_paginator->polog, $this->diafan->_paginator->nastr);

			$this->result["rows"] = $this->get_elements($result);

			//сохранение кеша
			$this->diafan->_cache->save($this->result, $cache_meta, $this->diafan->module);
		}

		if ($this->result["rows"])
		{
			foreach ($this->result["rows"] as $i => $row)
			{
				$this->useradmin($this->result["rows"][$i]);

				$this->result["rows"][$i]["tags"] = $this->diafan->_tags->get($row["id"]);

				$this->result["rows"][$i]["rating"] = $this->diafan->_rating->get($row["id"]);
			}
		}
		if($this->diafan->configmodules("theme_list_param"))
		{
			$this->result["theme"] = $this->diafan->configmodules("theme_list_param");
		}
		if($this->diafan->configmodules("view_list_param"))
		{
			$this->result["view"] = $this->diafan->configmodules("view_list_param");
		}
		else
		{
			$this->result["view"] = 'list';
		}

		$this->result["paginator"] = $this->diafan->_tpl->get('get', 'paginator', $this->result["paginator"]);

		return $this->result;
	}

	/**
	 * Генерирует данные для списка объявлений текущего пользователя
	 * 
	 * @return array
	 */
	public function list_my()
	{
		if(! $this->diafan->_user->id)
		{
			include_once(ABSOLUTE_PATH.'includes/404.php');
		}
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		////navigation//
		$this->diafan->_paginator->page = $this->diafan->page;
		$this->diafan->_paginator->get_nav = '?action=my';
		$this->diafan->_paginator->navlink = $this->diafan->_route->current_link("page");
		$count_result = DB::query("SELECT DISTINCT s.id FROM {ads} AS s"
		. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=s.id AND a.module_name='ads'" : "")
		. " WHERE s.[act]='1' AND s.trash='0'"
		. " AND (s.access='0'"
		. ($this->diafan->_user->id ? " OR s.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
		. ")"
		. " AND s.site_id=%d AND s.user_id=%d"
		." AND s.date_start<=%d AND (s.date_finish=0 OR s.date_finish>=%d)"
		." GROUP BY s.id",
		$this->diafan->cid, $this->diafan->_user->id);
		$this->diafan->_paginator->nen = DB::num_rows($count_result);

		$links = $this->diafan->_paginator->get();
		////navigation///

		$this->result["path"] = $this->get_path('ads');

		$result = DB::query_range("SELECT DISTINCT s.id, s.[name], s.timeedit, s.[anons], s.cat_id, s.site_id, s.created FROM {ads} AS s"
		. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=s.id AND a.module_name='ads'" : "")
		. " WHERE s.[act]='1' AND s.trash='0'"
		. " AND (s.access='0'"
		. ($this->diafan->_user->id ? " OR s.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
		. ")"
		. " AND s.site_id=%d AND s.user_id=%d"
		. " AND s.date_start<=%d AND (s.date_finish=0 OR s.date_finish>=%d)"
		. " GROUP BY s.id"
		. " ORDER BY s.prior DESC, s.created DESC",
		$this->diafan->cid, $this->diafan->_user->id,
		$this->diafan->_paginator->polog, $this->diafan->_paginator->nastr);

		$this->result["rows"] = $this->get_elements($result);

		$this->result["paginator"] = $this->diafan->_tpl->get('get', 'paginator', $links);

		if ($this->result["rows"])
		{
			foreach ($this->result["rows"] as $i => $row)
			{
				$this->useradmin($this->result["rows"][$i]);

				$this->result["rows"][$i]["tags"] = $this->diafan->_tags->get($row["id"]);

				$this->result["rows"][$i]["rating"] = $this->diafan->_rating->get($row["id"]);
			}
		}
		if($this->diafan->configmodules("theme_list_my"))
		{
			$this->result["theme"] = $this->diafan->configmodules("theme_list_my");
		}
		if($this->diafan->configmodules("view_list_my"))
		{
			$this->result["view"] = $this->diafan->configmodules("view_list_my");
		}
		else
		{
			$this->result["view"] = 'list';
		}

		return $this->result;
	}

	/**
	 * Генерирует данные для первой страницы модуля
	 * 
	 * @return boolean
	 */
	public function first_page()
	{
		if ($this->diafan->page)
		{
			include ABSOLUTE_PATH . 'includes/404.php';
		}
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		//кеширование
		$cache_meta = array(
			"name" => "first_page",
			"lang_id" => _LANG,
			"site_id" => $this->diafan->cid,
			"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0,
			"time" => $time
		);
		if ( ! $this->result = $this->diafan->_cache->get($cache_meta, $this->diafan->module))
		{
			$result = DB::query(
			"SELECT c.id, c.[name], c.[anons], c.timeedit, c.site_id FROM {ads_category} AS c"
			. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.cat_id=c.id AND a.module_name='ads'" : "")
			. " WHERE c.[act]='1' AND c.parent_id=0 AND c.trash='0' AND c.site_id=%d"
			. " AND (c.access='0'"
			. ($this->diafan->_user->id ? " OR c.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
			. ")"
			. " GROUP BY c.id ORDER by c.sort ASC, c.id ASC", $this->diafan->cid
			);
			while ($row = DB::fetch_array($result))
			{
				$cats = array();
				$cats["name"] = $row["name"];
				$cats["anons"] = $row["anons"];
				$cats["id"] = $row["id"];

				if (empty($this->result["timeedit"]) || $row["timeedit"] > $this->result["timeedit"])
				{
					$this->result["timeedit"] = $row["timeedit"];
				}

				$cats["children"] = array();
				$children = array();
				$result_children = DB::query(
				"SELECT c.id, c.[name], c.[anons], c.site_id FROM {ads_category} AS c"
				. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.cat_id=c.id AND a.module_name='ads'" : "")
				. " WHERE c.[act]='1' AND c.parent_id=%d AND c.trash='0' AND c.site_id=%d"
				. " AND (c.access='0'"
				. ($this->diafan->_user->id ? " OR c.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
				. ")"
				. " GROUP BY c.id ORDER BY c.sort ASC, c.id ASC", $row["id"], $this->diafan->cid);

				while ($child = DB::fetch_array($result_children))
				{
					$child["link"] = $this->diafan->_route->link($child["site_id"], 'ads', $child["id"]);
					if ($this->diafan->configmodules("images_cat") && $this->diafan->configmodules("list_img_cat"))
					{
						$child["img"] = $this->diafan->_images->get(
								'medium', $child["id"], $this->diafan->module, $child["site_id"],
								$child["name"], true, $this->diafan->configmodules("list_img_cat") == 1 ? 1 : 0,
						        $child["link"]);
					}
					unset($child["site_id"]);
					$cats["children"][] = $child;
					$children[] = $child["id"];
				}

				if (! $this->diafan->configmodules("childrens_elements"))
				{
					$children = array();
				}
				$children[] = $row["id"];

				$result_img = DB::query_range(
				"SELECT e.id, e.[name], e.cat_id, e.timeedit, e.[anons], e.site_id, e.created FROM {ads} AS e"
				. " INNER JOIN {ads_category_rel} AS r ON e.id=r.element_id"
				. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='ads'" : "")
				. " WHERE r.cat_id IN (%s) AND e.[act]='1' AND e.trash='0'"
				." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
				. " AND (e.access='0'"
				. ($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
				. ")"
				. " GROUP BY e.id ORDER BY e.prior DESC, e.created DESC",
				implode(',', $children), $time, $time,
				0, $this->diafan->configmodules("count_list")
				);
				$cats["rows"] = $this->get_elements($result_img);

				$cats["link_all"] = $this->diafan->_route->link($row["site_id"], 'ads', $row["id"]);

				if ($this->diafan->configmodules("images_cat") && $this->diafan->configmodules("list_img_cat"))
				{
					$cats["img"] =
					$this->diafan->_images->get(
							'medium', $row["id"], $this->diafan->module,
							$row["site_id"], $row["name"], true,
							$this->diafan->configmodules("list_img_cat") == 1 ? 1 : 0,
							$cats["link_all"]
						);
				}
				$this->result["categories"][] = $cats;
			}

			//сохранение кеша
			$this->diafan->_cache->save($this->result, $cache_meta, $this->diafan->module);
		}

		if ( ! empty($this->result["categories"]))
		{
			foreach ($this->result["categories"] as $cat => $rows)
			{
				if ( ! $rows)
					continue;

				$this->result["categories"][$cat]["name"] = $this->diafan->_useradmin->get($rows["name"], 'name', $rows["id"], 'ads_category', _LANG);
				$this->result["categories"][$cat]["anons"] = $this->diafan->_useradmin->get($rows["anons"], 'anons', $rows["id"], 'ads_category', _LANG);
				$this->result["categories"][$cat]["rating"] = $this->diafan->_rating->get($rows["id"], '', 0, true);
				foreach ($rows["children"] as $k => $row)
				{
					$this->result["categories"][$cat]["children"][$k]["name"] =
							$this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'ads_category', _LANG);

					$this->result["categories"][$cat]["children"][$k]["anons"] =
							$this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'ads_category', _LANG);
				}

				foreach ($rows["rows"] as $k => $row)
				{
					$this->useradmin($this->result["categories"][$cat]["rows"][$k]);

					$this->result["categories"][$cat]["rows"][$k]["tags"] =  $this->diafan->_tags->get($row["id"]);

					$this->result["categories"][$cat]["rows"][$k]["rating"] = $this->diafan->_rating->get($row["id"]);
				}
			}
		}
		if($this->diafan->configmodules("theme_first_page"))
		{
			$this->result["theme"] = $this->diafan->configmodules("theme_first_page");
		}
		if($this->diafan->configmodules("view_first_page"))
		{
			$this->result["view"] = $this->diafan->configmodules("view_first_page");
		}
		else
		{
			$this->result["view"] = 'first_page';
		}
		return $this->result;
	}

	/**
	 * Генерирует данные для списка объявлений в категории
	 * 
	 * @return boolean
	 */
	public function list_category()
	{
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		//кеширование
		$cache_meta = array(
			"name" => "list",
			"cat_id" => $this->diafan->cat,
			"lang_id" => _LANG,
			"page" => $this->diafan->page > 1 ? $this->diafan->page : 1,
			"site_id" => $this->diafan->cid,
			"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0,
			"time" => $time
		);
		if ( ! $this->result = $this->diafan->_cache->get($cache_meta, $this->diafan->module))
		{
			$this->result["level"] = count($this->diafan->get_parents($this->diafan->cat, 'ads_category'));

			$this->result["path"] = $this->get_path('ads');

			$result = DB::query("SELECT id, [name], timeedit, [descr], [keywords], sort, parent_id, [title_meta], access, theme, view FROM {ads_category}"
			. " WHERE [act]='1' and id=%d AND trash='0' AND site_id=%d"
			. " ORDER BY sort ASC, id ASC", $this->diafan->cat, $this->diafan->cid);

			if ( ! $row = DB::fetch_array($result))
			{
				include_once ABSOLUTE_PATH . 'includes/404.php';
			}
			if (empty($row) || (!empty($row['access']) && !$this->access(0, $row['id'])))
			{
				include_once(ABSOLUTE_PATH.'includes/403.php');
			}

			if($row["theme"])
			{
				$this->result["theme"] = $row["theme"];
			}
			elseif($this->diafan->configmodules("theme_list"))
			{
				$this->result["theme"] = $this->diafan->configmodules("theme_list");
			}

			if($row["view"])
			{
				$this->result["view"] = $row["view"];
			}
			elseif($this->diafan->configmodules("view_list"))
			{
				$this->result["view"] = $this->diafan->configmodules("view_list");
			}
			else
			{
				$this->result["view"] = 'list';
			}

			$this->result["id"] = $row["id"];
			if ($this->diafan->configmodules("images_cat"))
			{
				$this->result["img"] = $this->diafan->_images->get(
						'medium', $row["id"], $this->diafan->module,
						$this->diafan->cid, $row["name"], true, 0, 'large'
					);
			}

			$this->result["children"] = array();
			$children = array();
			$result_children = DB::query(
			"SELECT c.id, c.[name], c.[anons], c.site_id FROM {ads_category} AS c"
			. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.cat_id=c.id AND a.module_name='ads'" : "")
			. " WHERE c.[act]='1' AND c.parent_id=%d AND c.trash='0' AND c.site_id=%d"
			. " AND (c.access='0'"
			. ($this->diafan->_user->id ? " OR c.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
			. ")"
			. " GROUP BY c.id ORDER BY c.sort ASC, c.id ASC", $row["id"], $this->diafan->cid
			);

			while ($child = DB::fetch_array($result_children))
			{
				$child["link"] = $this->diafan->_route->link($child["site_id"], 'ads', $child["id"]);
				if ($this->diafan->configmodules("images_cat") && $this->diafan->configmodules("list_img_cat"))
				{
					$child["img"] = $this->diafan->_images->get(
							'medium', $child["id"], $this->diafan->module, $child["site_id"],
							$child["name"], true, $this->diafan->configmodules("list_img_cat") == 1 ? 1 : 0,
							$child["link"]);
				}
				unset($child["site_id"]);
				$this->result["children"][] = $child;
				$children[] = $child["id"];
			}

			if (! $this->diafan->configmodules("childrens_elements"))
			{
				$children = array();
			}
			$children[] = $this->diafan->cat;

			////navigation//
			$this->diafan->_paginator->page = $this->diafan->page;
			$this->diafan->_paginator->navlink = $this->diafan->_route->current_link("page");
			$this->diafan->_paginator->navlink_tpl = $this->diafan->_route->current_link("", array("page" => "%d"));
			$this->diafan->_paginator->nen = DB::query_result(
			"SELECT COUNT(DISTINCT e.id) FROM {ads} AS e"
			. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='ads'" : "")
			. " INNER JOIN {ads_category_rel} AS r ON e.id=r.element_id"
			. " WHERE e.[act]='1' AND e.trash='0'"
			. " AND r.cat_id IN (%s)"
			." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
			. " AND (e.access='0'"
			. ($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
			. ")", implode(',', $children), $time, $time
			);
			$links = $this->diafan->_paginator->get();
			////navigation///

			$result_img = DB::query_range(
			"SELECT s.id, s.[name], s.cat_id, s.timeedit, s.[anons], s.site_id, s.created FROM {ads} AS s"
			. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=s.id AND a.module_name='ads'" : "")
			. " INNER JOIN {ads_category_rel} AS r ON s.id=r.element_id AND r.cat_id IN (%s)"
			. " WHERE s.[act]='1' AND s.trash='0'"
			." AND s.date_start<=%d AND (s.date_finish=0 OR s.date_finish>=%d)"
			. " AND (s.access='0'"
			. ($this->diafan->_user->id ? " OR s.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
			. ")"
			. " GROUP BY s.id ORDER BY s.prior DESC, s.created DESC", implode(',', $children), $time, $time,
			$this->diafan->_paginator->polog, $this->diafan->_paginator->nastr
			);

			$this->result["rows"] = $this->get_elements($result_img);

			$this->result["paginator"] = $links;

			$this->result["titlemodule"] = $row["name"];
			$this->result["edit_meta"]   = array("id" => $row["id"], "table" => "ads_category");
			$this->result["title_meta"] = $row["title_meta"];
			$this->result["timeedit"] = $row["timeedit"];
			$this->result["keywords"] = $row["keywords"];
			$this->result["descr"] = $row["descr"];

			$previous = DB::fetch_array(DB::query(
			"SELECT c.[name], c.id FROM {ads_category} AS c"
			. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.cat_id=c.id AND a.module_name='ads'" : "")
			. " WHERE c.[act]='1' AND c.trash='0' AND c.site_id=%d"
			. " AND (c.sort<%d OR c.sort=%d AND c.id<%d) AND c.parent_id=%d"
			. " AND (c.access='0'"
			. ($this->diafan->_user->id ? " OR c.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
			. ")"
			. " ORDER BY c.sort DESC, c.id DESC LIMIT 1", $this->diafan->cid, $row["sort"], $row["sort"], $this->diafan->cat, $row["parent_id"]
							));
			if ($previous)
			{
				$this->result["previous"]["text"] = $previous["name"];
				$this->result["previous"]["id"] = $previous["id"];
				$this->result["previous"]["link"] = $this->diafan->_route->link($this->diafan->cid, "ads", $previous["id"]);
			}
			$next = DB::fetch_array(DB::query(
			"SELECT c.[name], c.id FROM {ads_category} AS c"
			. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.cat_id=c.id AND a.module_name='ads'" : "")
			. " WHERE c.[act]='1' AND c.trash='0' AND c.site_id=%d"
			. " AND (c.sort>%d OR c.sort=%d AND c.id>%d) AND c.parent_id=%d"
			. " AND (c.access='0'"
			. ($this->diafan->_user->id ? " OR c.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
			. ")"
			. " ORDER BY c.sort ASC, c.id ASC LIMIT 1", $this->diafan->cid, $row["sort"], $row["sort"], $this->diafan->cat, $row["parent_id"]
							));
			if ($next)
			{
				$this->result["next"]["text"] = $next["name"];
				$this->result["next"]["id"] = $next["id"];
				$this->result["next"]["link"] = $this->diafan->_route->link($this->diafan->cid, "ads", $next["id"]);
			}

			//сохранение кеша
			$this->diafan->_cache->save($this->result, $cache_meta, $this->diafan->module);
		}

		$text = DB::query_result("SELECT [text] FROM {ads_category} WHERE id=%d", $this->diafan->cat);
		$this->result["text"] = $this->diafan->_useradmin->get($text, 'text', $this->diafan->cat, 'ads_category', _LANG);

		$this->result["comments"] = $this->diafan->_comments->get($this->diafan->cat, $this->diafan->module, $this->diafan->cid, true);
		$this->result["rating"] = $this->diafan->_rating->get($this->diafan->cat, $this->diafan->module, $this->diafan->cid, true);

		if ($this->result["rows"])
		{
			foreach ($this->result["rows"] as $i => $row)
			{
				$this->useradmin($this->result["rows"][$i]);

				$this->result["rows"][$i]["tags"] = $this->diafan->_tags->get($row["id"]);

				$this->result["rows"][$i]["rating"] = $this->diafan->_rating->get($row["id"]);
			}
			if ( ! empty($this->result["previous"]["text"]))
			{
				$this->result["previous"]["text"] =
						$this->diafan->_useradmin->get($this->result["previous"]["text"], 'name', $this->result["previous"]["id"], 'ads_category', _LANG);
			}
			if ( ! empty($this->result["next"]["text"]))
			{
				$this->result["next"]["text"] =
						$this->diafan->_useradmin->get($this->result["next"]["text"], 'name', $this->result["next"]["id"], 'ads_category', _LANG);
			}
			foreach ($this->result["children"] as $id => $row)
			{
				$this->result["children"][$id]["name"] = $this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'ads_category', _LANG);
				$this->result["children"][$id]["anons"] = $this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'ads_category', _LANG);
			}
			foreach ($this->result["path"] as $k => $path)
			{
				if ($k == 0)
					continue;
				$this->result["path"][$k]["name"] = $this->diafan->_useradmin->get($path["name"], 'name', $path["id"], 'ads_category', _LANG);
			}
		}

		$this->result["paginator"] = $this->diafan->_tpl->get('get', 'paginator', $this->result["paginator"]);

		return $this->result;
	}

	/**
	 * Генерирует данные для страницы объявления
	 * 
	 * @return boolean
	 */
	public function id()
	{
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		//кеширование
		$cache_meta = array(
			"name" => "show",
			"cat_id" => $this->diafan->cat,
			"show" => $this->diafan->show,
			"lang_id" => _LANG,
			"site_id" => $this->diafan->cid,
			"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0,
			"time" => $time
		);
		if ( ! $this->result = $this->diafan->_cache->get($cache_meta, $this->diafan->module))
		{
			$row = DB::fetch_array(DB::query("SELECT id, [name], timeedit, cat_id, [keywords], [descr], [title_meta], access, theme, view, created  FROM {ads}"
			. " WHERE [act]='1' AND id = %d AND trash='0' AND site_id=%d"
			." AND date_start<=%d AND (date_finish=0 OR date_finish>=%d)",
			$this->diafan->show, $this->diafan->cid, $time, $time));
			if (empty($row))
			{
				include ABSOLUTE_PATH . 'includes/404.php';
			}

			if ( ! $this->diafan->rewrite_module && ($this->diafan->configmodules("cat") && $this->diafan->cat != $row["cat_id"]
					|| ! $this->diafan->configmodules("cat") && $this->diafan->cat))
			{
				include ABSOLUTE_PATH . 'includes/404.php';
			}
			if ( ! empty($row['access']) && ! $this->access($row['id']))
			{
				include ABSOLUTE_PATH . 'includes/403.php';
			}
			$this->diafan->cat = $this->diafan->configmodules("cat") ? $row["cat_id"] : 0;
			$row["cat_id"] = $this->diafan->configmodules("cat") ? $row["cat_id"] : 0;

			if ($this->diafan->configmodules("images"))
			{
				$this->result["img"] = $this->diafan->_images->get(
						'medium', $row["id"], $this->diafan->module,
						$this->diafan->cid, $row["name"], false, 0, 'large'
					);
			}

			foreach ($row as $id => $value)
			{
				$this->result[$id] = $value;
			}

			if(! $this->result["theme"] && $this->diafan->configmodules("theme_id"))
			{
				$this->result["theme"] = $this->diafan->configmodules("theme_id");
			}

			if(! $this->result["view"])
			{
				if($this->diafan->configmodules("view_id"))
				{
					$this->result["view"] = $this->diafan->configmodules("view_id");
				}
				else
				{
					$this->result["view"] = 'id';
				}
			}
			$this->result["date"] = $this->format_date($row['created']);
			$this->result["param"] = $this->get_param($row["id"], $this->diafan->cid);
			$this->result["titlemodule"] = $row["name"];
			$this->result["edit_meta"]   = array("id" => $row["id"], "table" => "ads");

			$previous = DB::fetch_array(DB::query(
			"SELECT e.[name], e.id, e.cat_id FROM {ads} AS e"
			. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='ads'" : "")
			. " WHERE e.[act]='1' AND e.trash='0' AND e.site_id=%d"
			. ($this->diafan->configmodules("cat") ? " AND e.cat_id='" . $this->diafan->cat . "'" : '')
			. " AND (e.created<%d OR e.created=%d AND e.id<%d)"
			." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
			. " AND (e.access='0'"
			. ($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
			. ")"
			. " ORDER BY e.prior DESC, e.created DESC LIMIT 1",
			$this->diafan->cid, $row["created"], $row["created"], $this->diafan->show, $time, $time
			));
			if ($previous)
			{
				$this->result["previous"]["text"] = $previous["name"];
				if ( ! $this->diafan->configmodules("cat"))
				{
					$previous["cat_id"] = 0;
				}
				$this->result["previous"]["id"] = $previous["id"];
				$this->result["previous"]["link"] = $this->diafan->_route->link($this->diafan->cid, "ads", $previous["cat_id"], $previous["id"]);
			}
			$next = DB::fetch_array(DB::query(
			"SELECT e.[name], e.id, e.cat_id FROM {ads} AS e"
			. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='ads'" : "")
			. " WHERE e.[act]='1' AND e.trash='0' AND e.site_id=%d"
			. ($this->diafan->configmodules("cat") ? " AND e.cat_id='" . $this->diafan->cat . "'" : '')
			. " AND (e.created>%d OR e.created=%d AND e.id>%d)"
			." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
			. " AND (e.access='0'"
			. ($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
			. ")"
			. " ORDER BY e.prior ASC, e.created ASC, e.id ASC LIMIT 1",
			$this->diafan->cid, $row["created"], $row["created"], $this->diafan->show, $time, $time
			));
			if ($next)
			{
				$this->result["next"]["text"] = $next["name"];
				if ( ! $this->diafan->configmodules("cat"))
				{
					$next["cat_id"] = 0;
				}
				$this->result["next"]["id"] = $next["id"];
				$this->result["next"]["link"] = $this->diafan->_route->link($this->diafan->cid, "ads", $next["cat_id"], $next["id"]);
			}

			$this->result["path"] = $this->get_path('ads');

			//сохранение кеша
			$this->diafan->_cache->save($this->result, $cache_meta, $this->diafan->module);
		}
		$this->diafan->cat = $this->result["cat_id"];

		// увеличиваем количество просморов товара
		if(empty($_SESSION["ads_view"][$this->diafan->show]))
		{
			$_SESSION["ads_view"][$this->diafan->show] = true;
			DB::query("UPDATE {ads} SET counter_view=counter_view+1 WHERE id=%d", $this->diafan->show);
		}

		$row = DB::fetch_array(DB::query("SELECT [text], [anons] FROM {ads} WHERE id=%d", $this->diafan->show));
		$this->result["text"] = $row["text"];
		$this->result["anons"] = $row["anons"];

		if ( ! empty($this->result["previous"]["text"]))
		{
			$this->result["previous"]["text"] =
					$this->diafan->_useradmin->get($this->result["previous"]["text"], 'name', $this->result["previous"]["id"], 'ads', _LANG);
		}
		if ( ! empty($this->result["next"]["text"]))
		{
			$this->result["next"]["text"] =
					$this->diafan->_useradmin->get($this->result["next"]["text"], 'name', $this->result["next"]["id"], 'ads', _LANG);
		}
		foreach ($this->result["path"] as $k => $path)
		{
			if ($k == 0)
				continue;
			$this->result["path"][$k]["name"] = $this->diafan->_useradmin->get($path["name"], 'name', $path["id"], 'ads_category', _LANG);
		}

		$this->useradmin($this->result);

		$this->result["rating"] = $this->diafan->_rating->get();
		$this->result["comments"] = $this->diafan->_comments->get();
		$this->result["tags"] = $this->diafan->_tags->get();

		return $this->result;
	}

	/**
	 * Генерирует данные для шаблонной функции: блок объявлений
	 * 
	 * @param integer $count количество объявлений
	 * @param integer $cat_id категория
	 * @param integer $site_id страница сайта
	 * @param string $sort сортировка default - по дате, rand - случайно
	 * @param integer $images количество изображений
	 * @param string $images_variation размер изображений
	 * @param string $param дополнительные параметры
	 * @return boolean
	 */
	public function show_block($count, $cat_id, $site_id, $sort, $images, $images_variation, $param)
	{
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		//кеширование
		$cache_meta = array(
			"name" => "block",
			"cat_id" => $cat_id,
			"count" => $count,
			"lang_id" => _LANG,
			"site_id" => $site_id,
			"images" => $images,
			"images_variation" => $images_variation,
			"param" => $param,
			"sort" => $sort,
			"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0,
			"time" => $time
		);

		if ($sort == "rand" || ! $this->result = $this->diafan->_cache->get($cache_meta, "ads"))
		{
			if ( ! $site_id && $cat_id)
			{
				$site_id = DB::query_result("SELECT site_id FROM {ads_category} WHERE id=%d", $cat_id);
			}

			if ( ! $site_id)
			{
				$site_id = DB::query_result(
				"SELECT s.id FROM {site} AS s"
				. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=s.id AND a.module_name='site'" : "")
				. " WHERE s.module_name='ads' AND s.trash='0' AND s.[act]='1' AND s.block='0'"
				. " AND (s.access='0'"
				. ($this->diafan->_user->id ? " OR s.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
				. ") LIMIT 1"
				);
			}
			else
			{
				if (DB::query_result("SELECT access FROM {site} WHERE id=%d", $site_id))
				{
					if ( ! $this->access($site_id, 0, "site"))
					{
						return false;
					}
				}
			}
			if ( ! $site_id)
			{
				return false;
			}
			if ($cat_id && $this->diafan->configmodules("cat", "ads", $site_id))
			{
				if (DB::query_result("SELECT access FROM {ads_category} WHERE id=%d", $cat_id))
				{
					if ( ! $this->access(0, $cat_id, "ads"))
					{
						return false;
					}
				}
				if ($this->diafan->configmodules("childrens_elements", "ads", $site_id))
				{
					$children = $this->diafan->get_children($cat_id, "ads_category");
				}
				$children[] = $cat_id;
			}
			$params = array();
			if ($param)
			{
				$param = explode('&', $param);
				foreach ($param as $p)
				{
					if(strstr($p, '>='))
					{
						$operator = '>=';
					}
					elseif(strstr($p, '<='))
					{
						$operator = '<=';
					}
					elseif(strstr($p, '<>'))
					{
						$operator = '<>';
					}
					elseif(strstr($p, '>'))
					{
						$operator = '>';
					}
					elseif(strstr($p, '<'))
					{
						$operator = '<';
					}
					else
					{
						$operator = '=';
					}
					list($id, $value) = explode($operator, $p, 2);
					$id = preg_replace('/[^0-9]+/', '', $id);
					if ( ! empty($params[$id]))
					{
						if (is_array($params[$id]))
						{
							$params[$id][] = $value;
							$operators[$id][] = $operator;
						}
						else
						{
							$params[$id] = array($params[$id], $value);
							$operators[$id] = array($operators[$id], $operator);
						}
					}
					else
					{
						$params[$id] = $value;
						$operators[$id] = $operator;
					}
				}
			}
			$where = '';
			$values = array();
			foreach ($params as $id => $value)
			{
				if (is_array($value))
				{
					$where .= "
					INNER JOIN {ads_param_element} AS pe" . $id . " ON pe" . $id . ".element_id=e.id AND pe" . $id . ".param_id='" . $id . "'"
							. " AND pe" . $id . ".trash='0' AND (";
					foreach ($value as $i => $val)
					{
						if ($value[0] != $val)
						{
							if(in_array($operators[$id][$i], array('>', '<', '>=', '<=')))
							{
								$where .= " AND ";
							}
							else
							{
								$where .= " OR ";
							}
						}
						$where .= "pe" . $id . ".value".$this->diafan->language_base_site.$operators[$id][$i]."'%h'";
						$values[] = $val;
					}
					$where .= ")";
				}
				else
				{
					$where .= "
					INNER JOIN {ads_param_element} AS pe" . $id . " ON pe" . $id . ".element_id=e.id AND pe" . $id . ".param_id='" . $id . "'"
					. " AND pe" . $id . ".trash='0' AND pe" . $id . ".value".$this->diafan->language_base_site.$operators[$id]."'%h'";
					$values[] = $value;
				}
			}
			$values[] = $time;
			$values[] = $time;

			if ($sort == "rand")
			{
				$max_count = DB::query_result("SELECT COUNT(DISTINCT e.id) FROM {ads} as e"
				. ($cat_id && $this->diafan->configmodules("cat", "ads", $site_id) ? " INNER JOIN {ads_category_rel} as c ON c.element_id=e.id"
						. " AND c.cat_id IN (" . implode(',', $children) . ")" : ''
				)
				. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='ads'" : "")
				. $where
				. " WHERE e.[act]='1' AND e.trash='0'"
				. ($site_id ? " AND e.site_id=" . $site_id : '')
				." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
				. " AND (e.access='0'"
				. ($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
				. ")", $values
				);
				$rands = array();
				for ($i = 1; $i <= min($max_count, $count); $i ++ )
				{
					do
					{
						$rand = mt_rand(0, $max_count - 1);
					}
					while (in_array($rand, $rands));
					$rands[] = $rand;
				}
			}
			else
			{
				$rands[0] = 1;
			}
			$this->result["rows"] = array();
			
			switch($sort)
			{
				case 'rand':
					$order = '';
					break;

				default :
					$order = ' ORDER BY e.prior, e.created ASC';
			}

			foreach ($rands as $rand)
			{
				$result = DB::query("SELECT e.id, e.[name], e.[anons], e.cat_id, e.timeedit, e.site_id, e.created FROM {ads} AS e"
				. ($cat_id && $this->diafan->configmodules("cat", "ads", $site_id) ? " INNER JOIN {ads_category_rel} as c ON c.element_id=e.id"
						. " AND c.cat_id IN (" . implode(',', $children) . ")" : ''
				)
				. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='ads'" : "")
				. $where
				. " WHERE e.[act]='1' AND e.trash='0'"
				. ($site_id ? " AND e.site_id=" . $site_id : '')
				." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
				. " AND (e.access='0'"
				. ($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
				. ")"
				. " GROUP BY e.id"
				. $order
				. ' LIMIT '
				. ($sort == "rand" ? $rand : 0) . ', '
				. ($sort == "rand" ? 1 : $count), $values);
				$rows = $this->get_elements($result, 'block', array("count" => $images, "variation" => $images_variation));
				$this->result["rows"] = array_merge($this->result["rows"], $rows);
			}

			if ( ! empty($this->result["rows"]) && $cat_id && $this->diafan->configmodules("cat", "ads", $site_id))
			{
				$cat = DB::fetch_array(DB::query("SELECT [name], site_id, id FROM {ads_category} WHERE id=%d", $cat_id));

				$this->result["name"] = $cat["name"];
				$this->result["link_all"] = $this->diafan->_route->link($cat["site_id"], 'ads', $cat["id"]);
				$this->result["category"] = true;
			}
			elseif ( ! empty($this->result["rows"]) && $site_id)
			{
				$this->result["name"] = DB::query_result("SELECT [name] FROM {site} WHERE id=%d", $site_id);
				$this->result["link_all"] = $this->diafan->_route->link($site_id);
				$this->result["category"] = false;
			}

			//сохранение кеша
			if ($sort != "rand")
			{
				$this->diafan->_cache->save($this->result, $cache_meta, "ads");
			}
		}

		if ($this->result["rows"])
		{
			foreach ($this->result["rows"] as $i => $row)
			{
				$this->useradmin($this->result["rows"][$i]);
			}
		}

		return $this->result;
	}

	/**
	 * Генерирует данные для шаблонной функции: блок связанных объявлений
	 * 
	 * @param integer $count количество объявлений
	 * @param integer $images количество изображений
	 * @param string $images_variation размер изображений
	 * @return void
	 */
	public function show_block_rel($count, $images, $images_variation)
	{
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		//кеширование
		$cache_meta = array(
			"name" => "block_rel",
			"count" => $count,
			"lang_id" => _LANG,
			"element_id" => $this->diafan->show,
			"images" => $images,
			"images_variation" => $images_variation,
			"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0,
			"time" => $time
		);

		if (! $this->result = $this->diafan->_cache->get($cache_meta, "ads"))
		{
			$this->result["rows"] = array();

			$result = DB::query_range(
			"SELECT e.id, e.[name], e.[anons], e.cat_id, e.timeedit, e.site_id, e.created FROM {ads} AS e"
			. " INNER JOIN {ads_rel} AS r ON e.id=r.rel_element_id AND r.element_id=%d"
			.($this->diafan->configmodules("rel_two_sided") ? " OR e.id=r.element_id AND r.rel_element_id=".$this->diafan->show : '')
			. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='ads'" : "")
			. " WHERE e.[act]='1' AND e.trash='0'"
			." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
			. " AND (e.access='0'"
			. ($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
			. ")"
			. " GROUP BY e.id"
			. ' ORDER BY e.prior DESC, e.created DESC',
			$this->diafan->show, $time, $time, 0, $count
			);
			$this->result["rows"] = $this->get_elements($result, 'block', array("count" => $images, "variation" => $images_variation));
			$this->diafan->_cache->save($this->result, $cache_meta, "ads");
		}

		if ($this->result["rows"])
		{
			foreach ($this->result["rows"] as $i => $row)
			{
				$this->useradmin($this->result["rows"][$i]);
			}
		}
		return $this->result;
	}


	/**
	 * Генерирует контент для шаблонной функции: форма поиска по объявлениям
	 *
	 * @param integer|string $cat_id номер категории, в которой осуществляется поиск
	 * @param integer $site_id страница сайта, к которой прикреплен модуль Объявления
	 * @param string $ajax подгружать результаты поиска Ajax-запросом
	 * @return array
	 */
	public function show_search($cat_id, $site_id, $ajax)
	{
		if ( ! $site_id)
		{
			if ($this->diafan->module == "ads")
			{
				$site_id = $this->diafan->cid;
			}
			else
			{
				$site_id = DB::query_result(
					"SELECT s.id FROM {site} AS s"
					. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=s.id AND a.module_name='site'" : "")
					. " WHERE s.module_name='ads' AND s.trash='0' AND s.[act]='1' AND s.block='0'"
					. " AND (s.access='0'"
					. ($this->diafan->_user->id ? " OR s.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
					. ") LIMIT 1"
				);
			}
		}
		if ( ! $site_id)
		{
			return false;
		}

		if ($cat_id === 'current')
		{
			if ($this->diafan->cat && $site_id == $this->diafan->cid)
			{
				$cat_id = $this->diafan->cat;
			}
			elseif ( ! empty($_GET["catid"]) && $site_id == $this->diafan->cid)
			{
				$this->diafan->cat = $this->diafan->get_param($_GET, 'catid', 0, 2);
				$cat_id = $this->diafan->cat;
			}
			else
			{
				$cat_id = 0;
			}
		}
		if ( ! $this->diafan->configmodules("cat", "ads", $site_id))
		{
			$cat_id = 0;
		}
		$this->result["path"] = $this->diafan->_route->link($site_id);
		$this->result["cat_id"] = $cat_id;

		if ($this->diafan->configmodules("search_name", "ads", $site_id))
		{
			$this->result["name"] = array(
				"name" => 1,
				"value" => ! empty($_GET["n"]) ? trim(htmlspecialchars(stripslashes($_GET["n"]))) : ''
			);
		}

		if ($this->diafan->configmodules("search_text", "ads", $site_id))
		{
			$this->result["text"] = array(
				"name" => 1,
				"value" => ! empty($_GET["d"]) ? trim(htmlspecialchars(stripslashes($_GET["d"]))) : ''
			);
		}

		$result = DB::query("SELECT DISTINCT(p.id), p.type, p.[name] FROM {ads_param} as p "
						. " INNER JOIN {ads_param_category_rel} AS c ON p.id=c.element_id "
						. ($this->diafan->configmodules("cat", "ads", $site_id) ? " AND (c.cat_id=%d OR c.cat_id=0)" : "")
						. " WHERE p.search='1' AND p.trash='0' ORDER BY p.sort ASC", $cat_id);

		while ($row = DB::fetch_array($result))
		{
			if ($row["type"] == 'text' || $row["type"] == 'textarea' || $row["type"] == 'editor')
			{
				$row["value"] = ! empty($_GET["p" . $row["id"]]) ? trim(htmlspecialchars(stripslashes($_GET["p" . $row["id"]]))) : '';
			}
			elseif ($row["type"] == 'date' || $row["type"] == 'datetime')
			{
				$row["value1"] = $this->diafan->get_param($_GET, "p" . $row["id"] . "_1", '', 1);
				$row["value2"] = $this->diafan->get_param($_GET, "p" . $row["id"] . "_2", '', 1);
			}
			elseif ($row["type"] == 'numtext')
			{
				$row["value1"] = (int) $this->diafan->get_param($_GET, "p" . $row["id"] . "_1", '', 2);
				$row["value2"] = (int) $this->diafan->get_param($_GET, "p" . $row["id"] . "_2", '', 2);
			}
			elseif ($row["type"] == 'checkbox')
			{
				$row["value"] = (int) $this->diafan->get_param($_GET, "p" . $row["id"], '', 2);
			}
			elseif ($row["type"] == 'select' || $row["type"] == 'multiple')
			{
				$result_select = DB::query("SELECT [name], id FROM {ads_param_select} WHERE param_id=%d ORDER BY sort ASC", $row["id"]);
				while ($row_select = DB::fetch_array($result_select))
				{
					$row["select_array"][$row_select["id"]] = $row_select["name"];
				}
				if ( ! empty($_GET["p" . $row["id"]]) && ! is_array($_GET["p" . $row["id"]]))
				{
					$row["value"][] = (int) $this->diafan->get_param($_GET, "p" . $row["id"], 0, 2);
				}
				elseif ( ! empty($_GET["p" . $row["id"]]) && is_array($_GET["p" . $row["id"]]))
				{
					foreach ($_GET["p" . $row["id"]] as $val)
					{
						$row["value"][] = intval($val);
					}
				}
				else
				{
					$row["value"] = array();
				}
			}
			unset($row["param"]);
			$this->result["rows"][] = $row;
		}
		$this->result["send_ajax"] = $ajax;
		return $this->result;
	}

	/**
	 * Генерирует данные для формы добавления объявления
	 * 
	 * @param integer $site_id номер страницы
	 * @param integer $cat_id номер категории
	 * @param boolean $insert_form форма выводится с помощью шаблонного тэга
	 * @return array|boolean false
	 */
	public function form($site_id = 0, $cat_id = 0, $insert_form = false)
	{
		if (! $insert_form)
		{
			$site_id = $this->diafan->cid;
			$cat_id = $this->diafan->cat;
		}
		else
		{
			if (! $site_id)
			{
				$site_id = DB::query_result(
						"SELECT s.id FROM {site} AS s"
						.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=s.id AND a.module_name='site'" : "")
						." WHERE s.module_name='ads' AND s.trash='0' AND s.block='0'"
						." AND (s.access='0'"
						.($this->diafan->_user->id ? " OR s.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
						.") LIMIT 1"
					);
			}
			else
			{
				if(DB::query_result("SELECT access FROM {site} WHERE id=%d", $site_id))
				{
					if(! $this->access($site_id, 0, "site"))
					{
						return $this->result;
					}
				}
			}
			if (! $site_id)
			{
				return $this->result;
			}
			if($cat_id == 'current')
			{
				if($site_id == $this->diafan->cid)
				{
					$cat_id = $this->diafan->cat;
				}
				else
				{
					$cat_id = 0;
				}
			}
		}
		if ($this->diafan->configmodules('only_user', "ads", $site_id) && ! $this->diafan->_user->id)
		{
			return $this->result;
		}
		$this->result["form"]["site_id"] = $site_id;

		$this->result["form"]["captcha"] = '';
		if ($this->diafan->configmodules('captcha', "ads", $site_id))
		{
			$this->result["form"]["captcha"] = $this->diafan->_captcha->get("ads".$site_id, $this->get_error("ads".$site_id, "code"));
		}

		$this->result["form"]['error_name'] = $this->get_error("ads".$site_id, 'name');
		$this->result["form"]['error_anons'] = $this->get_error("ads".$site_id, 'anons');
		$this->result["form"]['error_text'] = $this->get_error("ads".$site_id, 'text');
		$this->result["form"]['error_date_finish'] = $this->get_error("ads".$site_id, 'date_finish');
		$use_cat = $this->diafan->configmodules('cat', "ads", $site_id);
		if(! $use_cat)
		{
			$cat_id = 0;
		}
		elseif(! $cat_id)
		{
			$this->result["form"]['error_cat_id'] = $this->get_error("ads".$site_id, 'cat_id');
			$result = DB::query("SELECT id, [name], parent_id FROM {ads_category} WHERE  site_id=%d AND [act]='1' AND trash='0' ORDER BY sort ASC", $site_id);
			while($row = DB::fetch_array($result))
			{
				$this->result["form"]["cats"][$row["parent_id"]][] = $row;
			}
		}
		else
		{
			$this->result["form"]["cat_id"] = $cat_id;
		}

		$rows_param = $this->get_param_form($site_id, $cat_id, $use_cat);
		foreach ($rows_param as $row)
		{
			$this->result["form"]['error_p'.$row["id"]] = $this->get_error("ads".$site_id, 'p'.$row["id"]);
		}

		$this->result["form"]["error"]  = $this->get_error("ads".$site_id);
		$this->result["form"]["rows"]   = $rows_param;
		return $this->result;
	}

	/**
	 * Форматирует данные об объявлении для списка объявлений
	 *
	 * @param resource $result результат выполнения SQL-запроса
	 * @param string $function функция, для которой генерируется список товаров
	 * @param string $images_config настройки отображения изображений
	 * @return array
	 */
	public function get_elements($result, $function = 'list', $images_config = '')
	{
		if (empty($this->result["timeedit"]))
		{
			$this->result["timeedit"] = '';
		}
		$rows = array();
		while ($row = DB::fetch_array($result))
		{
			if ( ! $this->diafan->configmodules("cat", "ads", $row["site_id"]))
			{
				$row["cat_id"] = 0;
			}
			if ($row["timeedit"] < $this->result["timeedit"])
			{
				$this->result["timeedit"] = $row["timeedit"];
			}
			unset($row["timeedit"]);

			$row["link"] = $this->diafan->_route->link($row["site_id"], "ads", $row["cat_id"], $row["id"]);

			if ($this->diafan->configmodules("images", "ads", $row["site_id"]))
			{
				if (is_array($images_config))
				{
					$row["img"]  = $this->diafan->_images->get(
							$images_config["variation"], $row["id"], 'ads',
							$row["site_id"], $row["name"], false,
							$images_config["count"], $row["link"]
						);
				}
				elseif($this->diafan->configmodules("list_img", "ads", $row["site_id"]))
				{
					$row["img"]  = $this->diafan->_images->get(
							'medium', $row["id"], 'ads', $row["site_id"], $row["name"], false,
					        $this->diafan->configmodules("list_img", "ads", $row["site_id"]) == 1 ? 1 : 0,
					        $row["link"]
						);
				}
			}

			$row["param"] = $this->get_param($row["id"], $row["site_id"], $function);
			$row["date"] = $this->format_date($row['created'], "ads", $row["site_id"]);
			unset($row["created"]);

			$rows[] = $row;
		}
		return $rows;
	}

	/**
	 * Получает дополнительные характеристики объявлений
	 * 
	 * @param integer $id номер объявления
	 * @param integer $site_id номер страницы, к которой прикреплено объявление
	 * @param string $function функция, для которой выбираются параметры
	 * @return array
	 */
	private function get_param($id, $site_id, $function = "id")
	{
		global $param_select, $param_select_page;
		$values = array();
		$rvalues = array();
		$result_el = DB::query("SELECT e.value".$this->diafan->language_base_site." as rvalue, e.[value], e.param_id, e.id FROM {ads_param_element} as e"
		. " LEFT JOIN {ads_param_select} as s ON e.param_id=s.param_id AND e.param_id=s.id"
		. " WHERE e.element_id=%d GROUP BY e.id ORDER BY s.sort ASC", $id);
		while ($row_el = DB::fetch_array($result_el))
		{
			$values[$row_el["param_id"]][] = $row_el;
		}
		$result = DB::query("SELECT p.id, p.[name], p.type, p.page, p.[measure_unit], p.config FROM {ads_param} as p "
		. ($this->diafan->configmodules("cat", "ads", $site_id) ? " INNER JOIN {ads_category_rel} as c ON c.element_id=" . $id : "")
		. " INNER JOIN {ads_param_category_rel} as cp ON cp.element_id=p.id "
		. ($this->diafan->configmodules("cat", "ads", $site_id) ?
				" AND (cp.cat_id=c.cat_id OR cp.cat_id=0) " : "")
		. " WHERE p.trash='0' "
		. ($function == "block" ? " AND p.block='1'" : '')
		. ($function == "list" ? " AND p.list='1'" : '')
		. " GROUP BY p.id ORDER BY p.sort ASC"
		);

		$param = array();
		while ($row = DB::fetch_array($result))
		{
			switch ($row["type"])
			{
				case "text":
				case "textarea":
				case "editor":
					if ( ! empty($values[$row["id"]][0]["value"]))
					{
						$param[] = array(
							"id" => $row["id"],
							"name" => $row["name"],
							"value" => $values[$row["id"]][0]["value"],
							"value_id" => $values[$row["id"]][0]["id"],
							"type" => $row["type"]
						);
					}
					break;
				case "date":
					if ( ! empty($values[$row["id"]][0]["rvalue"]))
					{
						$param[] = array(
							"id" => $row["id"],
							"name" => $row["name"],
							"value" => $this->diafan->formate_from_date($values[$row["id"]][0]["rvalue"]),
							"value_id" => $values[$row["id"]][0]["id"],
							"type" => $row["type"]
						);
					}
					break;
				case "datetime":
					if ( ! empty($values[$row["id"]][0]["rvalue"]))
					{
						$param[] = array(
							"id" => $row["id"],
							"name" => $row["name"],
							"value" => $this->diafan->formate_from_datetime($values[$row["id"]][0]["rvalue"]),
							"value_id" => $values[$row["id"]][0]["id"],
							"type" => $row["type"]
						);
					}
					break;
				case "select":
					$value = ! empty($values[$row["id"]][0]["rvalue"]) ? $values[$row["id"]][0]["rvalue"] : '';
					if ($value)
					{
						if (empty($param_select[$row["id"]][$value]))
						{
							$param_select[$row["id"]][$value] = DB::query_result("SELECT [name] FROM {ads_param_select} WHERE id=%d AND param_id=%d", $values[$row["id"]][0]["rvalue"], $row["id"]);
						}
						if ($row["page"])
						{
							if (empty($param_select_page[$row["id"]][$value]))
							{
								$param_select_page[$row["id"]][$value] = $this->diafan->_route->link($site_id, "ads", 0, 0, $value);
							}
							$link = $param_select_page[$row["id"]][$value];
							$param[] = array("id" => $row["id"], "name" => $row["name"], "type" => $row["type"], "value" => $param_select[$row["id"]][$value], "link" => $link);
						}
						else
						{
							$param[] = array("id" => $row["id"], "name" => $row["name"], "type" => $row["type"], "value" => $param_select[$row["id"]][$value]);
						}
					}
					break;
				case "multiple":
					if ( ! empty($values[$row["id"]]))
					{
						$value = array();
						foreach ($values[$row["id"]] as $val)
						{
							if (empty($param_select[$row["id"]][$val["rvalue"]]))
							{
								$param_select[$row["id"]][$val["rvalue"]] =
										DB::query_result("SELECT [name] FROM {ads_param_select} WHERE id=%d AND param_id=%d", $val["rvalue"], $row["id"]);
							}
							if ($row["page"])
							{
								if ($this->diafan->module == 'ads' && $this->diafan->param == $val["rvalue"])
								{
									$link = '';
								}
								else
								{
									if (empty($param_select_page[$row["id"]][$val["rvalue"]]))
									{
										$param_select_page[$row["id"]][$val["rvalue"]] = $this->diafan->_route->link($site_id, "ads", 0, 0, $val["rvalue"]);
									}
									$link = $param_select_page[$row["id"]][$val["rvalue"]];
								}
								$value[] = array("id" => $row["id"], "name" => $param_select[$row["id"]][$val["rvalue"]], "link" => $link);
							}
							else
							{
								$value[] = $param_select[$row["id"]][$val["rvalue"]];
							}
						}
						$param[] = array("id" => $row["id"], "name" => $row["name"], "type" => $row["type"], "value" => $value);
					}
					break;
				case "checkbox":
					$value = ! empty($values[$row["id"]][0]["rvalue"]) ? 1 : 0;
					if ( ! isset($param_select[$row["id"]][$value]))
					{
						$param_select[$row["id"]][$value] =
								DB::query_result("SELECT [name] FROM {ads_param_select} WHERE value=%d AND param_id=%d", $value, $row["id"]);
					}
					if ( ! $param_select[$row["id"]][$value] && $value == 1)
					{
						$param[] = array("id" => $row["id"], "name" => $row["name"], "type" => $row["type"], "value" => '');
					}
					else
					{
						$param[] = array("id" => $row["id"], "name" => $row["name"], "type" => $row["type"], "value" => $param_select[$row["id"]][$value]);
					}
					break;
				case "title":
					$param[] = array(
						"id" => $row["id"],
						"name" => $row["name"],
						"type" => $row["type"],
						"value" => ''
					);
					break;
				case "numtext":
					if ( ! empty($values[$row["id"]][0]["rvalue"]))
					{
						$param[] = array(
							"id" => $row["id"],
							"name" => $row["name"],
							"value" => $values[$row["id"]][0]["rvalue"],
							"value_id" => $values[$row["id"]][0]["id"],
							"type" => $row["type"],
							"measure_unit" => $row["measure_unit"]
						);
					}
					break;
				case "attachments":
					$config = unserialize($row["config"]);
					if($config["attachments_access_admin"])
						continue 2;

					$value = $this->diafan->_attachments->get($id, "ads", 0, $row["id"]);
					if(! $value)
						continue 2;

					$param[] = array(
						"id" => $row["id"],
						"name" => $row["name"],
						"type" => $row["type"],
						"value" => $value,
						"use_animation" => ! empty($config["use_animation"]) ? true : false
					);
					break;
				default:
					if ( ! empty($values[$row["id"]][0]["rvalue"]))
					{
						$param[] = array(
							"id" => $row["id"],
							"name" => $row["name"],
							"value" => $values[$row["id"]][0]["rvalue"],
							"value_id" => $values[$row["id"]][0]["id"],
							"type" => $row["type"]
						);
					}
					break;
			}
		}
		return $param;
	}

	/**
	 * Получает дополнительные характеристики объявлений для формы добавления
	 *
	 * @param integer $site_id страница сайта
	 * @param integer $cat_id категория
	 * @param boolean $use_cat категории используются
	 * @return array
	 */
	public function get_param_form($site_id, $cat_id, $use_cat)
	{
		$cache_meta = array(
			"name" => "ads_param",
			"lang_id" => _LANG,
			"cat_id" => $cat_id,
			"site_id" => $site_id
		);
		if (! $rows_param = $this->diafan->_cache->get($cache_meta, 'ads'))
		{
			if(! $use_cat)
			{
				$where = ' AND r.cat_id = 0';
			}
			elseif($cat_id)
			{
				$where = " AND (r.cat_id=%d OR r.cat_id=0)";
			}
			else
			{
				$where = " INNER JOIN {ads_category} AS c ON c.site_id=%d AND (c.id=r.cat_id OR r.cat_id=0)";
			}
			$rows_param = array();
			$result = DB::query(
					"SELECT p.id, p.[name], p.type, p.required, p.[text], p.config,"
					." GROUP_CONCAT(r.cat_id SEPARATOR ',') AS cats FROM {ads_param} AS p"
					." INNER JOIN {ads_param_category_rel} AS r ON r.element_id=p.id"
					.$where
					." WHERE p.trash='0' GROUP BY p.id ORDER BY p.sort ASC", ($cat_id ? $cat_id : $site_id));
	
			while ($row = DB::fetch_array($result))
			{
				$row["cats"] = array_unique(explode(',', $row["cats"]));
				if ($row["type"] == 'select' || $row["type"] == 'multiple' || $row["type"] == 'checkbox')
				{
					$result_select = DB::query("SELECT [name], id, value FROM {ads_param_select} WHERE param_id=%d"
					                           ." ORDER BY sort ASC", $row["id"]);
					while ($row_select = DB::fetch_array($result_select))
					{
						$row["select_array"][] = $row_select;
						$row["select_values"][$row["type"] == 'checkbox' ? $row_select["value"] : $row_select["id"]] = $row_select["name"];
					}
				}
				if($row["type"] == 'attachments')
				{
					$config = unserialize($row["config"]);
					$row["max_count_attachments"] = ! empty($config["max_count_attachments"]) ? $config["max_count_attachments"] : 0;
					$row["attachments_access_admin"] = ! empty($config["attachments_access_admin"]) ? $config["attachments_access_admin"] : 0;
					$row["attachment_extensions"] = ! empty($config["attachment_extensions"]) ? $config["attachment_extensions"] : '';
					$row["use_animation"] = ! empty($config["use_animation"]) ? true : false;
				}
				$rows_param[] = $row;
			}
			//сохранение кеша
			$this->diafan->_cache->save($rows_param, $cache_meta, 'ads');
		}
		return $rows_param;
	}

	/**
	 * Формирует SQL-запрос при поиске по объявлениям
	 *
	 * @return void
	 */
	private function get_where(&$where, &$where_param, &$values, &$getnav, &$group)
	{
		$where = ' AND s.site_id=%d';
		$values[] = $this->diafan->cid;
		$values_param = array();

		$getnav = '?action=search';
		if (!empty($_GET["catid"]))
		{
			$this->diafan->cat = (int) preg_replace("/\D/", '', $_GET['catid']);
			$catarr = array(0);
			$getnav .='&catid='.$this->diafan->cat;
			if ($this->diafan->cat)
			{
				$children = $this->diafan->get_children($this->diafan->cat, "ads_category");
				$children[] = $this->diafan->cat;
				$where_param .= " INNER JOIN {ads_category_rel} AS c ON s.id=c.element_id AND c.cat_id IN (".implode(',', $children).")";
			}
		}

		if (!empty($_GET["n"]) && $this->diafan->configmodules("search_name"))
		{
			$where .= " AND s.name"._LANG." LIKE '%%%h%%'";
			$_GET["n"] = trim($this->diafan->get_param($_GET, "n", '', 1));
			$values[] = $_GET["n"];
			$getnav .= '&n='.$_GET["n"];
		}
	
		if (!empty($_GET["d"]) && $this->diafan->configmodules("search_text"))
		{
			$where .= " AND s.text"._LANG." LIKE '%%%h%%'";
			$_GET["d"] = trim($this->diafan->get_param($_GET, "d", '', 1));
			$values[] = $_GET["d"];
			$getnav .= '&d='.$_GET["d"];
		}
		$result = DB::query("SELECT DISTINCT(p.id), p.type, p.required FROM {ads_param} as p "
				." INNER JOIN {ads_param_category_rel} AS c ON p.id=c.element_id "
				.($this->diafan->configmodules("cat") ? " AND (c.cat_id=%d OR c.cat_id=0)" : "")
				." WHERE p.search='1' AND p.trash='0' ORDER BY p.sort ASC", $this->diafan->cat);
		while ($row = DB::fetch_array($result))
		{
			if (($row["type"] == 'text' || $row["type"] == 'textarea' || $row["type"] == 'editor') && !empty($_GET["p".$row["id"]]))
			{
				$val = trim($this->diafan->get_param($_GET, "p".$row["id"], '', 1));
				$where_param .= "
							INNER JOIN {ads_param_element} AS pe".$row["id"]." ON pe".$row["id"].".element_id=s.id AND pe".$row["id"].".param_id='%d'"
					." AND pe".$row["id"].".trash='0' AND pe".$row["id"].".value"._LANG." LIKE '%%%h%%'";
				$values_param[] = $row["id"];
				$values_param[] = $val;
				$getnav .= '&p'.$row["id"].'='.$val;
			}
			elseif ($row["type"] == 'date' && (!empty($_GET["p".$row["id"]."_1"]) || !empty($_GET["p".$row["id"]."_2"])))
			{
				$where_param .= "
							INNER JOIN {ads_param_element} AS pe".$row["id"]." ON pe".$row["id"].".element_id=s.id AND pe".$row["id"].".param_id='%d'"
					." AND pe".$row["id"].".trash='0'";
				$values_param[] = $row["id"];
				if (!empty($_GET["p".$row["id"]."_1"]))
				{
					$where_param .= " AND pe".$row["id"].".value".$this->diafan->language_base_site.">='%s'";
					$values_param[] = $this->diafan->formate_in_date($_GET["p".$row["id"]."_1"]);
					$getnav .= '&p'.$row["id"].'_1='.trim($this->diafan->get_param($_GET, "p".$row["id"]."_1", '', 1));
				}
				if (!empty($_GET["p".$row["id"]."_2"]))
				{
					$where_param .= " AND pe".$row["id"].".value".$this->diafan->language_base_site."<='%s'";
					$values_param[] = $this->diafan->formate_in_date($_GET["p".$row["id"]."_2"]);
					$getnav .= '&p'.$row["id"].'_2='.trim($this->diafan->get_param($_GET, "p".$row["id"]."_2", '', 1));
				}
			}
			elseif ($row["type"] == 'datetime' && (!empty($_GET["p".$row["id"]."_1"]) || !empty($_GET["p".$row["id"]."_2"])))
			{
				$where_param .= "
							INNER JOIN {ads_param_element} AS pe".$row["id"]." ON pe".$row["id"].".element_id=s.id AND pe".$row["id"].".param_id='%d'"
					." AND pe".$row["id"].".trash='0'";
				$values_param[] = $row["id"];
				if (!empty($_GET["p".$row["id"]."_1"]))
				{
					$where_param .= " AND pe".$row["id"].".value".$this->diafan->language_base_site.">='%s'";
					$values_param[] = $this->diafan->formate_in_datetime($_GET["p".$row["id"]."_1"]);
					$getnav .= '&p'.$row["id"].'_1='.trim($this->diafan->get_param($_GET, "p".$row["id"]."_1", '', 1));
				}
				if (!empty($_GET["p".$row["id"]."_2"]))
				{
					$where_param .= " AND pe".$row["id"].".value".$this->diafan->language_base_site."<='%s'";
					$values_param[] = $this->diafan->formate_in_datetime($_GET["p".$row["id"]."_2"]);
					$getnav .= '&p'.$row["id"].'_2='.trim($this->diafan->get_param($_GET, "p".$row["id"]."_2", '', 1));
				}
			}
			elseif ($row["type"] == 'numtext' && (!empty($_GET["p".$row["id"]."_2"]) || !empty($_GET["p".$row["id"]."_1"])))
			{
				$val1 = (int) $this->diafan->get_param($_GET, "p".$row["id"]."_1", '', 2);
				$val2 = (int) $this->diafan->get_param($_GET, "p".$row["id"]."_2", '', 2);
				$where_param .= "
							INNER JOIN {ads_param_element} AS pe".$row["id"]." ON pe".$row["id"].".element_id=s.id AND pe".$row["id"].".param_id='%d'"
					." AND pe".$row["id"].".trash='0'"
					.($val1 ? " AND pe".$row["id"].".value".$this->diafan->language_base_site.">=%d" : '')
					.($val2 ? " AND pe".$row["id"].".value".$this->diafan->language_base_site."<=%d" : '')
				;
				$values_param[] = $row["id"];
				if ($val1)
				{
					$values_param[] = $val1;
					$getnav .= '&p'.$row["id"].'_1='.$val1;
				}
				if ($val2)
				{
					$values_param[] = $val2;
					$getnav .= '&p'.$row["id"].'_2='.$val2;
				}
			}
			elseif ($row["type"] == 'checkbox' && !empty($_GET["p".$row["id"]]))
			{
				$where_param .= "
							INNER JOIN {ads_param_element} AS pe".$row["id"]." ON pe".$row["id"].".element_id=s.id AND pe".$row["id"].".param_id='%d'"
					." AND pe".$row["id"].".trash='0' AND pe".$row["id"].".value".$this->diafan->language_base_site."='1'";
				$values_param[] = $row["id"];
				$getnav .= '&p'.$row["id"].'=1';
			}
			elseif (($row["type"] == 'select' || $row["type"] == 'multiple') && !empty($_GET["p".$row["id"]]))
			{
				if (!is_array($_GET["p".$row["id"]]))
				{
					$val = (int) $this->diafan->get_param($_GET, "p".$row["id"], '', 2);
					if ((!empty($_GET["pr1"]) || !empty($_GET["pr2"])) && $row["required"])
					{
						$where .= " AND prp.param_id=".$row["id"]." AND prp.param_value".$this->diafan->language_base_site."='".$val."'";
					}
					else
					{
						$where_param .= "
						INNER JOIN {ads_param_element} AS pe".$row["id"]." ON pe".$row["id"].".element_id=s.id AND pe".$row["id"].".param_id='%d'"
						." AND pe".$row["id"].".trash='0' AND pe".$row["id"].".value".$this->diafan->language_base_site."='%d'";
						$values_param[] = $row["id"];
						$values_param[] = $val;
					}
					$getnav .= '&p'.$row["id"].'='.$val;
				}
				else
				{
					$vals = array();
					foreach ($_GET["p".$row["id"]] as $val)
					{
						if ($val)
						{
							$val = intval($val);
							$vals[] = $val;
							$getnav .= '&p'.$row["id"].'[]='.$val;
						}
					}
					if (!empty($vals))
					{
						$where_param .= " INNER JOIN {ads_param_element} AS pe".$row["id"]." ON pe".$row["id"].".element_id=s.id AND pe".$row["id"].".param_id='%d'"
						." AND pe".$row["id"].".trash='0' AND pe".$row["id"].".value".$this->diafan->language_base_site." IN (".implode(", ", $vals).")";
						$values_param[] = $row["id"];
					}
				}
			}
		}

		$values = array_merge($values_param, $values);
	}

	/**
	 * Генерирует ссылки на форму редактирования
	 *
	 * @param array $row данные о товаре
	 * @return void
	 */
	private function useradmin(&$row)
	{
		if ( ! empty($row["name"]))
		{
			$row["name"] = $this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'ads', _LANG);
		}
		if ( ! empty($row["text"]))
		{
			$row["text"] = $this->diafan->_useradmin->get($row["text"], 'text', $row["id"], 'ads', _LANG);
		}
		if ( ! empty($row["anons"]))
		{
			$row["anons"] = $this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'ads', _LANG);
		}
		if ( ! empty($row["param"]))
		{
			foreach ($row["param"] as $k => $param)
			{
				$row["param"][$k]["name"] = $this->diafan->_useradmin->get($param["name"], 'name', $param["id"], 'ads_param');
				if ( ! empty($param["value_id"]))
				{
					$lang = in_array($param["type"], array('text', 'textarea', 'editor')) ? _LANG : '';
					$row["param"][$k]["value"] = $this->diafan->_useradmin->get($param["value"], 'value', $param["value_id"], 'ads_param_element', $lang, $param["type"]);
				}
			}
		}
	}
}