<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.1
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Оформление блока объявлений, выводимых тегом show_block module=ads
 */

if (empty($result["rows"]))
	return false;

echo '<div class="ads_block">';

//заголовок блока
if (!empty($result["name"]))
{
	echo '<h2>' . $result["name"] . '</h2>';
}

//объявления
if (!empty($result["rows"]))
{
	foreach ($result["rows"] as $row)
	{
		echo '<div class="ads">';

		//название и ссылка
		echo '<div class="ads_name"><a href="' . BASE_PATH_HREF . $row["link"] . '">' . $row["name"] . '</a></div>';

		//изображения
		if (!empty($row["img"]))
		{
			echo '<div class="ads_img">';
			foreach ($row["img"] as $img)
			{
				switch ($img["type"])
				{
					case 'animation':
						echo '<a href="' . BASE_PATH . $img["link"] . '" rel="prettyPhoto[gallery' . $row["id"] . 'ads]">';
						break;
					case 'large_image':
						echo '<a href="' . BASE_PATH . $img["link"] . '" rel="large_image" width="' . $img["link_width"] . '" height="' . $img["link_height"] . '">';
						break;
					default:
						echo '<a href="' . BASE_PATH_HREF . $img["link"] . '">';
						break;
				}
				echo '<img src="' . $img["src"] . '" width="' . $img["width"] . '" height="' . $img["height"] . '" alt="' . $img["alt"] . '" title="' . $img["title"] . '">'
				. '</a> ';
			}
			echo '</div>';
		}

		//дата
		if (! empty($row["date"]))
		{
			echo '<div class="ads_date">'.$row["date"].'</div>';
		}

		// параметры товара
		if (!empty($row["param"]))
		{
			$this->get('param', 'ads', array("rows" => $row["param"], "id" => $row["id"]));
		}

		//краткое описание
		if (!empty($row["anons"]))
		{
			echo '<div class="ads_anons">';
			$this->htmleditor($row['anons']);
			echo '</div>';
		}
		echo '</div>';
	}
}

//ссылка на все объявления
if (!empty($result["link_all"]))
{
	echo '<div class="show_all"><a href="' . BASE_PATH_HREF . $result["link_all"] . '">';
	if ($result["category"])
	{
		echo $this->diafan->_('Посмотреть все объявления в категории «%s»', true, $result["name"]);
	}
	else
	{
		echo $this->diafan->_('Все объявления');
	}
	echo '</a></div>';
}

echo '</div>';