<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.1
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Captcha_inc
 * 
 * Работа с каптчей
 */

class Captcha_inc extends Model
{
	/**
	 * Выводит каптчу
	 * 
	 * @param string $modules метка каптчи
	 * @param string $error ошибка ввода кода, если запрос передан не через Ajax
	 * @param boolean $is_update каптча генерируется для обновления
	 * @return string
	 */
	public function get($modules = "modules", $error = "", $is_update = false)
	{
		return $this->diafan->_tpl->get('get', 'captcha', array("modules" => $modules, "error" => $error, "update" => $is_update));
	}

	/**
	 * Проверяет правильность ввода каптчи
	 * 
	 * @param string $modules метка каптчи
	 * @return string|boolean false
	 */
	public function is_right($modules = "modules")
	{
		//Защитный код не введен
		if (empty($_POST['code']) || empty($_POST['codeint']))
			return $this->diafan->_('Введите защитный код', false);

		//В сессии не записан код с данным идентификатором codeint
		if (! isset($_SESSION['captcha'][$modules][$_POST['codeint']])
		||
		//код из сессии не соответствует введенному. регистр не учитывается
		strtoupper($_SESSION['captcha'][$modules][$_POST['codeint']]) != strtoupper($_POST['code']))
			return $this->diafan->_('Не правильно введен защитный код', false);

		//очищаем из сессии запись с данным идентификатором
		unset($_SESSION['captcha'][$modules][$_POST['codeint']]);
		return false;
	}
}