<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.1
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Cart_model
 *
 * Модель модуля "Корзина товаров, офрмление заказа"
 */
class Cart_model extends Model
{
    /**
     * Генерирует данные для формы редактирования товаров
     * 
     * @return array
     */
    public function form()
    {
		$this->result["error"] = $this->get_error("cart");
		$this->result["error_table"] = $this->get_error("cart", "table");

		$this->form_table();
		$this->form_registration();
		$this->form_param();
		$this->form_payments();

        return $this->result;
    }

	/**
	 * Генерирует таблицу купленных товаров
	 * 
	 * @return boolean true
	 */
	public function form_table()
	{
        // корзина
		$this->result["currency"] = $this->diafan->configmodules("currency", "shop");
        $this->result["summ"] = 0;
        $this->result["count"] = 0;
		$this->result["discount"] = false;
		$cart = $this->diafan->_cart->get();
        if ($cart)
        {
            $k = 0;
            foreach ($cart as $good_id => $array)
            {
				if (!$row = DB::fetch_array(DB::query("SELECT id, [name], article, cat_id, site_id FROM {shop} WHERE [act]='1' AND id = %d AND trash='0'", $good_id)))
				{
					continue;
				}
				$link = $this->diafan->_route->link($row["site_id"], "shop", $row["cat_id"], $row["id"]);
				$img = $this->diafan->_images->get('medium', $good_id, 'shop', $row["site_id"], $row["name"], false, 1, '');
				foreach ($array as $param => $c)
				{
					$this->result["rows"][$k]["name"] = $row["name"];
					$this->result["rows"][$k]["article"] = $row["article"];
					$this->result["rows"][$k]["link"] = $link;
					$query = array();
					$params = unserialize($param);
					if($row["cat_id"])
					{
						if (empty($select_cats[$row["cat_id"]]))
						{
							$select_cats[$row["cat_id"]] = array(
									"name" => DB::query_result("SELECT [name] FROM {shop_category} WHERE id=%d", $row["cat_id"]),
									"link" => $this->diafan->_route->link($row["site_id"], "shop", $row["cat_id"])
								);
						}
						$this->result["rows"][$k]["cat"]["name"] = $select_cats[$row["cat_id"]]["name"];
						$this->result["rows"][$k]["cat"]["link"] = $select_cats[$row["cat_id"]]["link"];
					}
					foreach ($params as $id => $value)
					{
						$query[] = 'p'.$id.'='.$value;
						if (empty($param_names[$id]))
						{
							$param_names[$id] = DB::query_result("SELECT [name] FROM {shop_param} WHERE id=%d", $id);
						}
						if (empty($select_names[$id][$value]))
						{
							$select_names[$id][$value] =
								DB::query_result("SELECT [name] FROM {shop_param_select} WHERE param_id=%d AND id=%d", $id, $value);
						}

						$this->result["rows"][$k]["name"] .= ', '.$param_names[$id].': '.$select_names[$id][$value];
					}
					$row_price = $this->diafan->_shop->price_get($good_id, $params, $this->diafan->_user->id, true);

					$price = $row_price["price"];

					$this->result["rows"][$k]["link"] .= !empty($query) ? '?'.implode('&', $query) : '';
					$this->result["rows"][$k]["count"] = $c["count"];
					if ($img)
					{
						$this->result["rows"][$k]["img"] = $img[0];
					}
					$this->result["rows"][$k]["id"] = $row["id"].'_'.str_replace(array('{',':',';','}',' ','"',"'"), '', $param);
					$this->result["rows"][$k]["price"] = $this->diafan->_shop->price_format($price);
					$this->result["rows"][$k]["summ"] = $this->diafan->_shop->price_format($price * $c["count"]);
					$this->result["rows"][$k]["discount"] = 0;
					if($row_price["discount_id"])
					{
						if(! isset($cache["discount"][$row_price["discount_id"]]))
						{
							$cache["discount"][$row_price["discount_id"]] = DB::query_result("SELECT discount FROM {shop_discount} WHERE id=%d", $row_price["discount_id"]);
						}
						$this->result["discount"] = true;
						$this->result["rows"][$k]["discount"] = $cache["discount"][$row_price["discount_id"]];
					}

					$this->result["summ"] += $price * $c["count"];
					$this->result["count"] += $c["count"];
					$k++;
				}
            }
			if(! $this->result["count"])
			{
				return $this->result;
			}
            $this->result["summ_goods"] = $this->result["summ"];

			// способы доставки
			$this->result["delivery"] = array();
			$result = DB::query("SELECT id, [name], price, [text], amount FROM {shop_delivery} WHERE [act]='1' AND trash='0' ORDER by sort ASC");
			while ($row = DB::fetch_array($result))
			{
				if (! empty($row['amount']))
				{
					if ($row['amount'] < $this->result["summ_goods"])
					{
						$row['price'] = 0;
					}
				}

				if (empty($_SESSION["cart_delivery"]) && empty($this->result["delivery"]))
				{
					$_SESSION["cart_delivery"] = $row['id'];
				}
				if (! empty($_SESSION["cart_delivery"]) && $row['id'] == $_SESSION["cart_delivery"])
				{
					$this->result["summ"] += $row['price'];
				}
				$this->result["delivery"][] = $row;
            }
			$this->result["cart_delivery"] = ! empty($_SESSION["cart_delivery"]) ? $_SESSION["cart_delivery"] : 0;

			// дополнительно
			$this->result["additional_cost"] = array();
			$this->result["cart_additional_cost"] = ! empty($_SESSION["cart_additional_cost"]) ? $_SESSION["cart_additional_cost"] : array();
			$result = DB::query("SELECT id, [name], price, percent, [text], amount, required FROM {shop_additional_cost} WHERE [act]='1' AND trash='0' ORDER by sort ASC");
			while ($row = DB::fetch_array($result))
			{
				$row["summ"] = $row['price'];
				if($row['percent'])
				{
					$row["summ"] = $this->result["summ_goods"] * $row['percent'] / 100;
				}
				if (! empty($row['amount']))
				{
					if ($row['amount'] < $this->result["summ_goods"])
					{
						$row["summ"] = 0;
					}
				}
				if (in_array($row["id"], $this->result["cart_additional_cost"]) || $row["required"])
				{
					$this->result["summ"] += $row['summ'];
				}
				$this->result["additional_cost"][] = $row;
            }
        }
        $this->result["summ"] = $this->diafan->_shop->price_format($this->result["summ"]);
        $this->result["summ_goods"] = ! empty($this->result["summ_goods"]) ? $this->diafan->_shop->price_format($this->result["summ_goods"]) : 0;

		return $this->result;
	}

	/**
	 * Генерирует форму регистрации и авторизации
	 * 
	 * @return boolean true
	 */
	private function form_registration()
	{
		$this->result["show_auth"] = true;
		if ($this->diafan->_user->id || ! DB::query_result("SELECT id FROM {site} WHERE module_name='registration' AND [act]='1' AND trash='0' AND block='0'"))
		{
			$this->result["show_auth"] = false;
		}
		else
		{
			Customization::inc('modules/registration/registration.model.php');
			$reg = new Registration_model($this->diafan);
			$this->result["registration"] = $reg->form();
			$this->result["registration"]["action"] = BASE_PATH_HREF . $this->diafan->_route->module("registration");
			$show_login = array("error" => $this->diafan->_user->errauth ? $this->diafan->_('Неверный логин или пароль.', false) : '', "action" => '', "user" => '', 'hide' => true);

			$this->result["show_login"] = $show_login;
		}
		return true;
	}

	/**
	 * Генерирует поля формы, созданные в конструкторе
	 * 
	 * @return boolean true
	 */
	private function form_param()
	{
		$this->result["rows_param"] = $this->get_params(array("module" => "shop", "table" => "shop_order"));

		$multiple = array();
		foreach ($this->result["rows_param"] as $row)
		{
			$this->result['error_p'.$row["id"]] = $this->get_error("cart", 'p'.$row["id"]);
			if ($row["type"] == "multiple")
			{
				$multiple[] = $row["id"];
			}
		}

		// данные о пользователе
		if ($this->diafan->_user->id)
		{
			$result = DB::query("SELECT param_id, value FROM {shop_order_param_user} WHERE trash='0' AND user_id=%d", $this->diafan->_user->id);
			while($row = DB::fetch_array($result))
			{
				if (in_array($row["param_id"], $multiple))
				{
					$this->result["user"]['p'.$row["param_id"]][] = $row["value"];
				}
				else
				{
					$this->result["user"]['p'.$row["param_id"]] = $row["value"];
				}
			}
			$max_order_id = DB::query_result("SELECT MAX(id) FROM {shop_order} WHERE user_id=%d AND trash='0'", $this->diafan->_user->id);
			$result = DB::query("SELECT value, param_id FROM {shop_order_param_element} WHERE trash='0' AND element_id=%d", $max_order_id);
			while ($row = DB::fetch_array($result))
			{
				if(! empty($this->result["user"]['p'.$row["param_id"]]))
					continue;

				if (in_array($row["param_id"], $multiple))
				{
					$this->result["user"]['p'.$row["param_id"]][] = $row["value"];
				}
				else
				{
					$this->result["user"]['p'.$row["param_id"]] = $row["value"];
				}
			}
		}
		return true;
	}

	/**
	 * Генерирует список методов оплаты
	 * 
	 * @return boolean true
	 */
	private function form_payments()
	{
		$result = DB::query("SELECT id, [name], [text] FROM {shop_payment} WHERE [act]='1' AND trash='0' ORDER BY sort ASC");
		while($row = DB::fetch_array($result))
		{
		    $this->result["payments"][] = $row;
		}
		return true;
	}

	/**
	 * Генерирует данные для втого шага в оформлении заказа: оплата
	 * 
	 * @return array|boolean
	 */
	public function payment()
	{
		$row = DB::fetch_array(DB::query("SELECT payment_id, summ FROM {shop_order} WHERE id=%d", $this->diafan->show));
		
		$method = DB::fetch_array(DB::query("SELECT payment, [text], params FROM {shop_payment} WHERE id='%d'",$row['payment_id']));
		if($method["payment"])
		{
			if(! DB::query_result("SELECT id FROM {shop_pay_history} WHERE order_id=%d", $this->diafan->show))
			{
				DB::query("INSERT INTO {shop_pay_history} (created, status, order_id, payment, summ, user_id) VALUES (%d, 'request_pay', %d, '%s', %f, %d)", time(), $this->diafan->show, $method["payment"], $row["summ"], $this->diafan->_user->id);
			}
			$params = unserialize($method["params"]);
			$params["text"] = $this->diafan->configmodules('mes', 'shop').'<br><br>'.$method["text"];
			$params["summ"] = $row['summ'];
			$params["user_id"] = $this->diafan->_user->id;
			$params["order_id"] = $this->diafan->show;
			$params["desc_order"] = str_replace('%order', $params["order_id"], $this->diafan->configmodules("desc_order", "shop"));
			Customization::inc('modules/cart/payment/'.$method["payment"].'/cart.payment.'.$method["payment"].'.model.php');
			$class = 'Cart_payment_'.$method["payment"].'_model';
			$payment_class = new $class($this->diafan);
			$this->result = $payment_class->get($params);
			$this->result["method"] = $method["payment"];
		}
		else
		{
			return $this->diafan->configmodules('mes', 'shop').'<br><br>'.$method["text"];
		}

		return $this->result;
	}

	/**
	 * Генерирует данные для третьего шага в офрмлении заказа: результат оплаты
	 * 
	 * @return array
	 */
	public function result()
	{
		if ($this->diafan->step == 3)
		{
		    if($this->diafan->configmodules('order_redirect', 'shop'))
		    {
			    if(preg_match("/^[0-9]+$/", $this->diafan->configmodules('order_redirect', 'shop')))
			    {
				$this->result["redirect"] = BASE_PATH_HREF.$this->diafan->_route->link($this->diafan->configmodules('order_redirect', 'shop'));
			    }
			    else
			    {
				$this->result["redirect"] = BASE_PATH_HREF.$this->diafan->configmodules('order_redirect', 'shop');
			    }
		    }
		    $this->result["text"] = $this->diafan->configmodules("payment_success_text", "shop");
		}
		else
		{
		    $this->result["text"] = $this->diafan->configmodules("payment_fail_text", "shop");
		}
		return $this->result["text"];
	}

    /**
     * Генерирует данные для шаблонной функции: выводит информацию о заказанных товарах
     * 
     * @return array
     */
    public function show_block()
    {
		$result["summ"] = $this->diafan->_cart->get_summ_discount();
		$result["count"] = $this->diafan->_cart->get_count();

		$result["link"] = BASE_PATH_HREF.$this->diafan->_route->module("cart", true);
		$result["summ"] = $this->diafan->_shop->price_format($result["summ"]);
		$result["currency"] = $this->diafan->configmodules("currency", "shop");

		$result["wishlist_link"] = BASE_PATH_HREF.$this->diafan->_route->module("wishlist", true);
		return $result;
    }
}