<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.1
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Clauses
 *
 * Контроллер модуля "Статьи"
 */
class Clauses extends Controller
{
	/**
	 * Инициализация модуля
	 * 
	 * @return void
	 */
	public function init()
	{
		$this->rewrite_variable_names = array('page', 'show', 'cat');
		$this->diafan->rewrite_variable_names = $this->rewrite_variable_names;
		
		$model = new Clauses_model($this->diafan);
		
		if ($this->diafan->show)
		{
			$this->result = $model->id();
		}
		elseif (! $this->diafan->configmodules("cat"))
		{
			$this->result = $model->list_();
		}
		elseif (! $this->diafan->cat)
		{
			$this->result = $model->first_page();
		}
		else
		{
			$this->result = $model->list_category();
		}
		$this->get_global_variables();
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return void
	 */
	public function show_module()
	{
		$this->diafan->_tpl->get($this->view, 'clauses', $this->result);
	}

	/**
	 * Шаблонная функция: блок статей
	 * 
	 * @param array $attributes атрибуты шаблонного тэга
	 * @return void
	 */
	public function show_block($attributes)
	{
		$attributes = $this->get_attributes($attributes, 'count', 'cat_id', 'images', 'images_variation', 'sort', 'site_id', 'template');
		
		$count   = $attributes["count"] ? intval($attributes["count"]) : 3;
		$cat_id  = intval($attributes["cat_id"]);
		$site_id = intval($attributes["site_id"]);
		$sort    = $attributes["sort"] == "date" || $attributes["sort"] == "rand" || $attributes["sort"] == "keywords" ? $attributes["sort"] : "date";
		$images  = intval($attributes["images"]);
		$images_variation = $attributes["images_variation"] ? strval($attributes["images_variation"]) : 'medium';

		Customization::inc('modules/clauses/clauses.model.php');
		$model = new Clauses_model($this->diafan);
		$result = $model->show_block($count, $cat_id, $images, $images_variation, $sort, $site_id);

		if (! $attributes["template"] || ! $this->diafan->_tpl->get('show_block_'.$attributes["template"], 'clauses', $result))
		{
			$this->diafan->_tpl->get('show_block', 'clauses', $result);
		}
	}

	/**
	 * Шаблонная функция: блок связанных статей
	 * 
	 * @param array $attributes атрибуты шаблонного тэга
	 * @return void
	 */
	public function show_block_rel($attributes)
	{
		$attributes = $this->get_attributes($attributes, 'count', 'images', 'images_variation', 'template');

		$count   = $attributes["count"] ? intval($attributes["count"]) : 3;
		$images  = intval($attributes["images"]);
		$images_variation = $attributes["images_variation"] ? strval($attributes["images_variation"]) : 'medium';

		if ($this->diafan->module != "clauses" || ! $this->diafan->show)
			return;

		Customization::inc('modules/clauses/clauses.model.php');
		$model = new Clauses_model($this->diafan);
		$result = $model->show_block_rel($count, $images, $images_variation);

		if (! $attributes["template"] || ! $this->diafan->_tpl->get('show_block_rel_'.$attributes["template"], 'clauses', $result))
		{
			$this->diafan->_tpl->get('show_block_rel', 'clauses', $result);
		}
	}
}