<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.1
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (!defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Files_admin_config
 *
 * Настройки модуля "Файловый архив"
 */
class Files_admin_config extends Frame_admin
{
	/**
	 * @var array поля в базе данных для редактирования
	 */
	public $variables = array (
		'config' => array (
			'nastr' => array(
				'type' => 'numtext',
				'name' => 'Количество файлов на странице',
			),
			'hr1' => 'hr',
			'attachment_extensions' => array(
				'type' => 'text',
				'name' => 'Доступные типы файлов (через запятую)',
			),
			'hr2' => 'hr',
			'cat' => array(
				'type' => 'checkbox',
				'name' => 'Использовать категории',
			),
			'count_list' => array(
				'type' => 'numtext',
				'name' => 'Количество файлов в списке категорий',
			),
			'childrens_elements' => array(
				'type' => 'checkbox',
				'name' => 'Показывать файлы подкатегорий',
			),
			'hr3' => 'hr',
			'images' => array(
				'type' => 'module',
				'name' => 'Использовать изображения',
			),
			'hr4' => 'hr',
			'comments' => array(
				'type' => 'module',
				'name' => 'Показывать комментарии к файлам',
			),
			'tags' => array(
				'type' => 'module',
				'name' => 'Показывать теги файлов',
			),
			'rating' => array(
				'type' => 'module',
				'name' => 'Показывать рейтинг файлов',
			),
			'rel_two_sided' => array(
				'type' => 'checkbox',
				'name' => 'В блоке похожих файлов связь двусторонняя',
			),
			'themes' => array(
				'type' => 'function',
			),
			'theme_list' => array(
				'type' => 'none',
				'name' => 'Шаблон для списка элементов',
				'help' => 'Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_list' => array(
				'type' => 'none',
			),
			'theme_first_page' => array(
				'type' => 'none',
				'name' => 'Шаблон для первой страницы модуля (если подключены категории)',
				'help' => 'Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_first_page' => array(
				'type' => 'none',
			),
			'theme_id' => array(
				'type' => 'none',
				'name' => 'Шаблон для страницы элемента',
				'help' => 'Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_id' => array(
				'type' => 'none',
			),
			'hr_admin_page' => 'hr',
			'admin_page'     => array(
				'type' => 'checkbox',
				'name' => 'Отдельный пункт в меню администрирования для каждого раздела сайта',
			),
		),
	);

	/**
	 * @var array настройки модуля
	 */
	public $config = array (
		'element_site', // делит элементы по разделам (страницы сайта, к которым прикреплен модуль)
		'config', // файл настроек модуля
	);

	/**
	 * @var array зависимости между полями
	 */
	public $show_tr_click_checkbox = array(
		'cat' => array(
			'count_list',
			'childrens_elements',
		),
	);
}