<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.1
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Menu_admin_category
 *
 * Редактирование меню
 */
class Menu_admin_category extends Frame_admin
{
	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'menu_category';

	/**
	 * @var array поля в базе данных для редактирования
	 */
	public $variables = array (
		'main' => array (
			'name' => array(
				'type' => 'text',
				'name' => 'Название',
				'multilang' => true,
			),
			'number' => array(
				'type' => 'function',
				'name' => 'Номер',
				'help' => 'Номер элемента в БД (для разработчиков).',
			),
			'act' => array(
				'type' => 'checkbox',
				'name' => 'Показывать на сайте',
				'default' => true,
				'multilang' => true,
			),
			'show_title' => array(
				'type' => 'checkbox',
				'name' => 'Показывать заголовок',
				'help' => 'Если отмечен, перед пунктами меню выведется название меню',
			),
			'show_all_level' => array(
				'type' => 'checkbox',
				'name' => 'Раскрывать все пункты меню',
				'help' => 'Если отмечено, в меню будут выводиться все пункты меню, включая вложенные. Иначе вложенные пункты будут появляться только при выборе родительского пункта.',
			),
			'hide_parent_link' => array(
				'type' => 'checkbox',
				'name' => 'Не отображать ссылку на элемент, если он имеет дочерние пункты',
			),
			'current_link' => array(
				'type' => 'checkbox',
				'name' => 'Текущий пункт меню как ссылка',
				'help' => 'Если отмечено, активный пункт меню останется ссылкой.',
			),
			'access' => array(
				'type' => 'function',
				'name' => 'Доступ',
			),
		),
	);

	/**
	 * @var array настройки модуля
	 */
	public $config = array (
		'del', // удалить
		'act', // показать/скрыть
		'category', // часть модуля - категории
		'trash', // использовать корзину
	);

	/**
	 * Выводит список вопросов
	 * @return void
	 */
	public function show()
	{
		$this->diafan->addnew_init('Добавить меню');
		
		$this->diafan->list_row();
	}

	/**
	 * Проверяет можно ли удалить текущий элемент строки
	 *
	 * @param array $row информация о текущем элменте списка
	 * @return boolean
	 */
	public function check_delete($row)
	{
		// нельзя удалить первую категорию меню
		if($row["id"] == 1)
		{
			return false;
		}
		else
		{
			return true;
		}
	}
}