<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.1
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Menu_admin
 *
 * Редактирование пунктов меню
 */
class Menu_admin extends Frame_admin
{
    /**
     * @var string таблица в базе данных
     */
    public $table = 'menu';

	/**
	 * @var array поля в базе данных для редактирования
	 */
	public $variables = array (
		'main' => array (
			'name' => array(
				'type' => 'text',
				'name' => 'Название',
				'multilang' => true,
			),
			'act' => array(
				'type' => 'checkbox',
				'name' => 'Показывать на сайте',
				'default' => true,
				'multilang' => true,
			),
			'module_name' => array(
				'type' => 'function',
				'name' => 'Элемент',
			),
			'parent_id' => array(
				'type' => 'function',
				'name' => 'Вложенность: принадлежит',
			),
			'cat_id' => array(
				'type' => 'function',
				'name' => 'Категория',
			),
			'othurl' => array(
				'type' => 'text',
				'name' => 'Внешняя ссылка (в формате http://site.com/)',
				'help' => 'Если заполнено это поле, пункт меню будет безусловно ссылаться на указанный адрес',
			),
			'access' => array(
				'type' => 'none',
				'name' => 'Доступ',
			),
			'sort' => array(
				'type' => 'function',
				'name' => 'Сортировка: установить перед',
			),
			'images' => array(
				'type' => 'module',
				'name' => 'Изображение',
				'count' => 1,
			),
		),
	);

	/**
	 * @var array настройки модуля
	 */
	public $config = array (
		'del', // удалить
		'act', // показать/скрыть
		'parent', // содержит вложенности
		'trash', // использовать корзину
		'order', // сортируется
		'element', // используются группы
		'category_flat', // категори не содержат вложенности
		'category_no_empty', // категория всегда выбрана
	);

	/**
	 * Подготавливает конфигурацию модуля
	 * @return void
	 */
	public function prepare_config()
	{
		if ($this->diafan->edit)
		{
			$this->diafan->variable_unset('access');
		}
	}

    /**
     * Выводит списко ответов
     * @return void
     */
    public function show()
    {
		if (! $this->diafan->cat)
		{
			$this->diafan->cat = 1;
		}

		$this->diafan->addnew_init('Добавить пункт меню');

		$this->diafan->list_row();
    }

    /**
     * Редактирование поля "Элемент модуля"
     * @return void
     */
    public function edit_variable_module_name()
    {
		if ($this->diafan->addnew)
		{
			$this->diafan->values["module_name"] = '';
			$this->diafan->values["element_id"] = 0;
			$this->diafan->values["site_id"] = 0;
			$this->diafan->values["module_cat_id"] = 0;
		}
		echo '
			<script type="text/javascript" src="'.BASE_PATH.'modules/menu/admin/menu.admin.js"></script>
			<tr id="module_name">
				<td class="td_first">'.$this->diafan->variable_name("module_name").'</td>
				<td>';
		if ($this->diafan->values["site_id"] && $this->diafan->values["module_name"] == "site")
		{
			$name = DB::query_result("SELECT [name] FROM {site} WHERE id=%d", $this->diafan->values["site_id"]);
			echo '<a href="'.BASE_PATH_HREF.'site/edit'.$this->diafan->values["site_id"].'/" class="menu_base_link">'.$name.'</a>
					<a href="javascript:void(0)"><img src="'.BASE_PATH.'adm/img/edit.gif" width="12" height="14" alt="'.$this->diafan->_('Редактировать').'" class="menu_check"></a>';
		}
		elseif ($this->diafan->values["element_id"])
		{
			$name = DB::query_result("SELECT [name] FROM {%s} WHERE id=%d", $this->diafan->values["module_name"], $this->diafan->values["element_id"]);
			echo '<a href="'.BASE_PATH_HREF.$this->diafan->values["module_name"].'/edit'.$this->diafan->values["element_id"].'/" class="menu_base_link">'.$name.'</a>
					<a href="javascript:void(0)"><img src="'.BASE_PATH.'adm/img/edit.gif" width="12" height="14" alt="'.$this->diafan->_('Редактировать').'" class="menu_check"></a>';
		}
		elseif ($this->diafan->values["module_cat_id"])
		{
			$name = DB::query_result("SELECT [name] FROM {%s_category} WHERE id=%d", $this->diafan->values["module_name"], $this->diafan->values["module_cat_id"]);
			echo '<a href="'.BASE_PATH_HREF.$this->diafan->values["module_name"].'/category/edit'.$this->diafan->values["module_cat_id"].'/" class="menu_base_link">'.$name.'</a>
					<a href="javascript:void(0)"><img src="'.BASE_PATH.'adm/img/edit.gif" width="12" height="14" alt="'.$this->diafan->_('Редактировать').'" class="menu_check"></a>';
		}
		else
		{
			echo '<a href="#" class="menu_base_link"></a>
					<a href="#inline" class="menu_check"><img src="'.BASE_PATH.'adm/img/edit.gif" width="12" height="14" alt="'.$this->diafan->_('Редактировать').'"></a>';
		}

		echo $this->diafan->help("element_id").'
				<input name="module_name" value="'.$this->diafan->values["module_name"].'" type="hidden">
				<input name="site_id" value="'.$this->diafan->values["site_id"].'" type="hidden">
				<input name="module_cat_id" value="'.$this->diafan->values["module_cat_id"].'" type="hidden">
				<input name="element_id" value="'.$this->diafan->values["element_id"].'" type="hidden">
				<div id="inline" class="hide"></div>
				</td>
			</tr>';
    }

    /**
     * Сохранение поля "Элемент модуля"
     * @return void
     */
    public function save_variable_module_name()
    {
		$this->diafan->set_query("module_cat_id='%d'");
		$this->diafan->set_value($_POST["module_cat_id"]);

		$this->diafan->set_query("site_id='%d'");
		$this->diafan->set_value($_POST["site_id"]);

		$this->diafan->set_query("element_id='%d'");
		$this->diafan->set_value($_POST["element_id"]);

		$this->diafan->set_query("module_name='%h'");
		$this->diafan->set_value($_POST["module_name"]);
    }

    /**
     * Сохранение поля "Доступ, период показа"
     * @return void
     */
    public function save_variable_access()
    {
		if ($_POST["element_id"])
		{
			$element = DB::fetch_array(DB::query("SELECT access, date_start, date_finish FROM {%h} WHERE id=%d", $_POST["module_name"], $_POST["element_id"]));
		}
		elseif ($_POST["module_cat_id"])
		{
			$element = DB::fetch_array(DB::query("SELECT access FROM {%h_category} WHERE id=%d", $_POST["module_name"], $_POST["module_cat_id"]));
		}
		else
		{
			$element = DB::fetch_array(DB::query("SELECT access, date_start, date_finish FROM {site} WHERE id=%d", $_POST["site_id"]));
		}

		$this->diafan->set_query("access='%d'");
		$this->diafan->set_value($element["access"]);
		if(! empty($element["date_start"]))
		{
			$this->diafan->set_query("date_start=%d");
			$this->diafan->set_value($element["date_start"]);
		}
		if(! empty($element["date_finish"]))
		{
			$this->diafan->set_query("date_finish=%d");
			$this->diafan->set_value($element["date_finish"]);
		}
	}

	/**
	 * Сохранение поля "Родитель"
	 * 
	 * @return void
	 */
	public function save_variable_parent_id()
	{
		if (!$this->diafan->savenew && $_POST["cat_id"] != $this->diafan->oldrow["cat_id"])
		{
			if ($_POST["parent_id"] && DB::query_result("SELECT cat_id FROM {menu} WHERE id=%d", $_POST["parent_id"]) != $_POST["cat_id"])
			{
				$_POST["parent_id"] = 0;
			}
		}
		parent::__call('save_variable_parent_id', array());
	}
}