<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.1
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * News_model
 *
 * Модель модуля "Новости"
 */
class News_model extends Model
{
	/**
	 * Генерирует данные для списка всех новостей без деления на категории
	 *
	 * @return array
	 */
	public function list_()
	{
		if ($this->diafan->cat)
		{
			include ABSOLUTE_PATH . 'includes/404.php';
		}
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		$cache_meta = array(
			"name" => "list",
			"lang_id" => _LANG,
			"page" => $this->diafan->page > 1 ? $this->diafan->page : 1,
			"site_id" => $this->diafan->cid,
			"time" => $time,
			"year" => $this->diafan->year,
			"month" => $this->diafan->month,
			"day" => $this->diafan->day,
			"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0
		);

		//кеширование
		if (!$this->result = $this->diafan->_cache->get($cache_meta, $this->diafan->module))
		{
			$this->result = array();

			if ($this->diafan->year || $this->diafan->month || $this->diafan->day)
			{
				if ($this->diafan->cat)
				{
					include ABSOLUTE_PATH . 'includes/404.php';
				}
				if (! $this->diafan->year || ! $this->diafan->month && $this->diafan->day)
				{
					include ABSOLUTE_PATH . 'includes/404.php';
				}
				if ($this->diafan->month)
				{
					$month_arr = array(
						'12' => $this->diafan->_('Декабрь', false),
						'11' => $this->diafan->_('Ноябрь', false),
						'10' => $this->diafan->_('Октябрь', false),
						'09' => $this->diafan->_('Сентябрь', false),
						'08' => $this->diafan->_('Август', false),
						'07' => $this->diafan->_('Июль', false),
						'06' => $this->diafan->_('Июнь', false),
						'05' => $this->diafan->_('Май', false),
						'04' => $this->diafan->_('Апрель', false),
						'03' => $this->diafan->_('Март', false),
						'02' => $this->diafan->_('Февраль', false),
						'01' => $this->diafan->_('Январь', false)
					);
					if ($this->diafan->day)
					{
						$this->result["titlemodule"] =
								sprintf(
								$this->diafan->_('Новости за %s', false), $this->format_date(mktime(0, 0, 0, $this->diafan->month, $this->diafan->day, $this->diafan->year))
						);
					}
					else
					{
						$this->result["titlemodule"] =
								sprintf(
								$this->diafan->_('Новости за %s %s года', false), $month_arr[$this->diafan->month], $this->diafan->year
						);
					}
				}
				else
				{
					$this->result["titlemodule"] =
							sprintf(
							$this->diafan->_('Новости за %s год', false), $this->diafan->year
					);
				}

				$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));
				if($this->diafan->day)
				{
					$time1 = mktime(0, 0, 0, $this->diafan->month, $this->diafan->day, $this->diafan->year);
					$time2 = $time1 + 86400;
				}
				elseif($this->diafan->month)
				{
					$time1 = mktime(0, 0, 0, $this->diafan->month, 1, $this->diafan->year);
					$time2 = mktime(0, 0, 0, $this->diafan->month, date("t", $time1), $this->diafan->year) + 86400;
				}
				else
				{
					$time1 = mktime(0, 0, 0, 1, 1, $this->diafan->year);
					$time2 = mktime(0, 0, 0, 1, 1, $this->diafan->year + 1);
				}
				$time2 = $time2 < $time ? $time2 : $time;

				////navigation///
				$this->diafan->_paginator->page = $this->diafan->page;
				$this->diafan->_paginator->navlink = $this->diafan->_route->current_link("page");
				$this->diafan->_paginator->navlink_tpl = $this->diafan->_route->current_link("", array("page" => "%d"));
				$this->diafan->_paginator->nen = DB::query_result(
						"SELECT COUNT(DISTINCT e.id) FROM {news} AS e"
						.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='news'" : "")
						." WHERE e.[act]='1' AND e.trash='0'"
						." AND e.site_id=%d AND e.created>=%d AND e.created<%d"
						." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
						." AND (e.access='0'"
						.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
						.")",
						$this->diafan->cid, $time1, $time2, $time, $time
					);
				$links = $this->diafan->_paginator->get();
				////navigation///

				$result = DB::query_range(
						"SELECT e.id, e.created, e.[name], e.[anons], e.timeedit, e.cat_id, e.site_id FROM {news} AS e"
						.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='news'" : "")
						." WHERE e.[act]='1'"
						." AND e.trash='0' AND e.site_id=%d AND e.created>=%d AND e.created<%d"
						." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
						." AND (e.access='0'"
						.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
						.")"
						." GROUP BY e.id ORDER BY e.prior DESC, e.created DESC, e.id DESC",
						$this->diafan->cid, $time1, $time2, $time, $time,
						$this->diafan->_paginator->polog, $this->diafan->_paginator->nastr
					);
			}
			else
			{
				////navigation///
				$this->diafan->_paginator->page = $this->diafan->page;
				$this->diafan->_paginator->navlink = $this->diafan->_route->current_link("page");
				$this->diafan->_paginator->nen = DB::query_result(
						"SELECT COUNT(DISTINCT e.id) FROM {news} AS e"
						.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='news'" : "")
						." WHERE e.[act]='1' AND e.trash='0'"
						." AND e.site_id=%d AND e.created<%d"
						." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
						." AND (e.access='0'"
						.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
						.")",
						$this->diafan->cid, $time, $time, $time
					);
				$links = $this->diafan->_paginator->get();
				////navigation///

				$result = DB::query_range(
						"SELECT e.id, e.created, e.[name], e.[anons], e.timeedit, e.cat_id, e.site_id FROM {news} AS e"
						.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='news'" : "")
						." WHERE e.[act]='1' AND e.trash='0' AND e.site_id=%d AND e.created<%d"
						." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
						." AND (e.access='0'"
						.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
						.")"
						." GROUP BY e.id ORDER BY e.prior DESC, e.created DESC, e.id DESC",
						$this->diafan->cid, $time, $time, $time,
						$this->diafan->_paginator->polog, $this->diafan->_paginator->nastr
					);
			}

			$this->result["rows"] = $this->get_elements($result);
			$this->result["path"] = $this->get_path('news');

			$this->result["paginator"] = $links;

			//сохранение кеша
			$this->diafan->_cache->save($this->result, $cache_meta, $this->diafan->module);
		}

		if ($this->result["rows"])
		{
			foreach ($this->result["rows"] as $i => $row)
			{
				$this->result["rows"][$i]["tags"] = $this->diafan->_tags->get($row["id"]);

				$this->result["rows"][$i]["rating"] = $this->diafan->_rating->get($row["id"]);

				$this->result["rows"][$i]["name"] = $this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'news', _LANG);

				$this->result["rows"][$i]["anons"] = $this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'news', _LANG);

				$this->result["rows"][$i]["date"] = $this->diafan->_useradmin->get($row["date"], 'created', $row["id"], 'news');
			}
		}
		if($this->diafan->configmodules("theme_list"))
		{
			$this->result["theme"] = $this->diafan->configmodules("theme_list");
		}
		if($this->diafan->configmodules("view_list"))
		{
			$this->result["view"] = $this->diafan->configmodules("view_list");
		}
		else
		{
			$this->result["view"] = 'list';
		}
		$this->result["paginator"] = $this->diafan->_tpl->get('get', 'paginator', $this->result["paginator"]);
		return $this->result;
	}

	/**
	 * Генерирует данные для первой страницы новостей
	 *
	 * @return array
	 */
	public function first_page()
	{
		if ($this->diafan->page)
		{
			include ABSOLUTE_PATH . 'includes/404.php';
		}
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		//кеширование
		$cache_meta = array(
			"name" => "first_page",
			"lang_id" => _LANG,
			"page" => $this->diafan->page > 1 ? $this->diafan->page : 1,
			"time" => $time,
			"site_id" => $this->diafan->cid,
			"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0
		);
		if (!$this->result = $this->diafan->_cache->get($cache_meta, $this->diafan->module))
		{
			$this->result = array();
			if(! $this->diafan->page)
			{
				$result = DB::query(
						"SELECT c.id, c.[name], c.[anons], c.timeedit, c.site_id FROM {news_category} AS c"
						.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.cat_id=c.id AND a.module_name='news'" : "")
						." WHERE c.[act]='1' AND c.parent_id=0 AND c.trash='0' AND c.site_id=%d"
						." AND (c.access='0'"
						.($this->diafan->_user->id ? " OR c.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
						.")"
						." GROUP BY c.id ORDER by c.sort ASC, c.id ASC",
						$this->diafan->cid
					);
	
				while ($row = DB::fetch_array($result))
				{
					$cats = array();
					$cats["name"] = $row["name"];
					$cats["anons"] = $row["anons"];
					$cats["id"] = $row["id"];
	
					if (empty($this->result["timeedit"]) || $row["timeedit"] > $this->result["timeedit"])
					{
						$this->result["timeedit"] = $row["timeedit"];
					}
	
					$cats["children"] = array();
					$children = array();
					$result_children = DB::query(
							"SELECT c.id, c.[name], c.[anons], c.site_id FROM {news_category} AS c"
							.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.cat_id=c.id AND a.module_name='news'" : "")
							." WHERE c.[act]='1' AND c.parent_id=%d AND c.trash='0' AND c.site_id=%d"
							." AND (c.access='0'"
							.($this->diafan->_user->id ? " OR c.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
							.")"
							." GROUP BY c.id ORDER BY c.sort ASC, c.id ASC",
							$row["id"], $this->diafan->cid);
	
					while ($child = DB::fetch_array($result_children))
					{
						$child["link"] = $this->diafan->_route->link($child["site_id"], 'news', $child["id"]);
						if ($this->diafan->configmodules("images_cat") && $this->diafan->configmodules("list_img_cat"))
						{
							$child["img"] = $this->diafan->_images->get(
									'medium', $child["id"], $this->diafan->module, $child["site_id"],
									$child["name"], true, $this->diafan->configmodules("list_img_cat") == 1 ? 1 : 0,
									$child["link"]);
						}
						unset($child["site_id"]);
						$cats["children"][] = $child;
						$children[] = $child["id"];
					}
	
					if (! $this->diafan->configmodules("childrens_elements"))
					{
						$children = array();
					}
					$children[] = $row["id"];
	
					$result_img = DB::query_range(
							"SELECT e.id, e.[name], e.cat_id, e.timeedit, e.[anons], e.site_id, e.created FROM {news} AS e"
							." INNER JOIN {news_category_rel} AS r ON e.id=r.element_id"
							.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='news'" : "")
							." WHERE r.cat_id IN (%s) AND e.[act]='1' AND e.trash='0' AND e.created<'%d'"
							." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
							." AND (e.access='0'"
							.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
							.")"
							." GROUP BY e.id ORDER BY e.prior DESC, e.created DESC, e.id DESC",
							implode(',', $children), $time, $time, $time, 0, $this->diafan->configmodules("count_list")
					);
					$cats["rows"] = $this->get_elements($result_img);
	
					$cats["link_all"] = $this->diafan->_route->link($row["site_id"], 'news', $row["id"]);
	
					if ($this->diafan->configmodules("images_cat") && $this->diafan->configmodules("list_img_cat"))
					{
						$cats["img"] =
						$this->diafan->_images->get(
								'medium', $row["id"], $this->diafan->module,
								$row["site_id"], $row["name"], true,
								$this->diafan->configmodules("list_img_cat") == 1 ? 1 : 0,
								$cats["link_all"]
							);
					}
					$this->result["categories"][] = $cats;
				}
			}

			////navigation///
			$this->diafan->_paginator->page = $this->diafan->page;
			$this->diafan->_paginator->navlink = $this->diafan->_route->current_link("page");
			$this->diafan->_paginator->nen = DB::query_result(
					"SELECT COUNT(DISTINCT e.id) FROM {news} AS e"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='news'" : "")
					." WHERE e.[act]='1' AND e.trash='0'"
					." AND e.cat_id=0"
					." AND e.site_id=%d AND e.created<%d"
					." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
					." AND (e.access='0'"
					.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")",
					$this->diafan->cid, $time, $time, $time
				);
			$links = $this->diafan->_paginator->get();
			////navigation///

			$result = DB::query_range(
					"SELECT e.id, e.created, e.[name], e.[anons], e.timeedit, e.cat_id, e.site_id FROM {news} AS e"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='news'" : "")
					." WHERE e.[act]='1' AND e.trash='0'"
					." AND e.cat_id=0"
					." AND e.site_id=%d AND e.created<%d"
					." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
					." AND (e.access='0'"
					.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")"
					." GROUP BY e.id ORDER BY e.prior DESC, e.created DESC, e.id DESC",
					$this->diafan->cid, $time, $time, $time,
					$this->diafan->_paginator->polog, $this->diafan->_paginator->nastr
				);

			$this->result["rows"] = $this->get_elements($result);
			$this->result["paginator"] = $links;

			//сохранение кеша
			$this->diafan->_cache->save($this->result, $cache_meta, $this->diafan->module);
		}
		$this->result["paginator"] = $this->diafan->_tpl->get('get', 'paginator', $this->result["paginator"]);

		if (!empty($this->result["categories"]))
		{
			foreach ($this->result["categories"] as $cat => $rows)
			{
				if (!$rows)
					continue;

				$this->result["categories"][$cat]["name"] = $this->diafan->_useradmin->get($rows["name"], 'name', $rows["id"], 'news_category', _LANG);

				$this->result["categories"][$cat]["anons"] = $this->diafan->_useradmin->get($rows["anons"], 'anons', $rows["id"], 'news_category', _LANG);
				$this->result["categories"][$cat]["rating"] = $this->diafan->_rating->get($rows["id"], '', 0, true);
				foreach ($rows["children"] as $k => $row)
				{
					$this->result["categories"][$cat]["children"][$k]["name"] =
							$this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'news_category', _LANG);

					$this->result["categories"][$cat]["children"][$k]["anons"] =
							$this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'news_category', _LANG);
				}

				foreach ($rows["rows"] as $k => $row)
				{
					$this->result["categories"][$cat]["rows"][$k]["tags"] = $this->diafan->_tags->get($row["id"]);

					$this->result["categories"][$cat]["rows"][$k]["rating"] = $this->diafan->_rating->get($row["id"]);

					$this->result["categories"][$cat]["rows"][$k]["name"] =
							$this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'news', _LANG);

					$this->result["categories"][$cat]["rows"][$k]["anons"] =
							$this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'news', _LANG);

					$this->result["categories"][$cat]["rows"][$k]["date"] = $this->diafan->_useradmin->get($row["date"], 'created', $row["id"], 'news');
				}
			}
		}
		if ($this->result["rows"])
		{
			foreach ($this->result["rows"] as $i => $row)
			{
				$this->result["rows"][$i]["tags"] = $this->diafan->_tags->get($row["id"]);

				$this->result["rows"][$i]["rating"] = $this->diafan->_rating->get($row["id"]);

				$this->result["rows"][$i]["name"] = $this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'news', _LANG);

				$this->result["rows"][$i]["anons"] = $this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'news', _LANG);

				$this->result["rows"][$i]["date"] = $this->diafan->_useradmin->get($row["date"], 'created', $row["id"], 'news');
			}
		}
		if($this->diafan->configmodules("theme_first_page"))
		{
			$this->result["theme"] = $this->diafan->configmodules("theme_first_page");
		}
		if($this->diafan->configmodules("view_first_page"))
		{
			$this->result["view"] = $this->diafan->configmodules("view_first_page");
		}
		else
		{
			$this->result["view"] = 'first_page';
		}
		return $this->result;
	}

	/**
	 * Генерирует данные для списка новостей в категории
	 *
	 * @return array
	 */
	public function list_category()
	{
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		//кеширование
		$cache_meta = array(
			"name" => "list",
			"cat_id" => $this->diafan->cat,
			"lang_id" => _LANG,
			"page" => $this->diafan->page > 1 ? $this->diafan->page : 1,
			"time" => $time,
			"site_id" => $this->diafan->cid,
			"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0
		);

		if (!$this->result = $this->diafan->_cache->get($cache_meta, $this->diafan->module))
		{
			$this->result = array();

			$this->result["level"] = count($this->diafan->get_parents($this->diafan->cat, 'news_category'));

			$this->result["path"] = $this->get_path('news');

			$result = DB::query(
					"SELECT id, [name], timeedit, [descr], [keywords], sort, parent_id, [title_meta], access, theme, view FROM {news_category}"
					." WHERE [act]='1' and id=%d AND trash='0' AND site_id=%d"
					." ORDER BY sort ASC, id ASC",
					$this->diafan->cat, $this->diafan->cid
				);

			if (! $row = DB::fetch_array($result))
			{
				include_once ABSOLUTE_PATH.'includes/404.php';
			}
			if (empty($row) || (!empty($row['access']) && !$this->access(0, $row['id'])))
			{
				include_once(ABSOLUTE_PATH.'includes/403.php');
			}

			if($row["theme"])
			{
				$this->result["theme"] = $row["theme"];
			}
			elseif($this->diafan->configmodules("theme_list"))
			{
				$this->result["theme"] = $this->diafan->configmodules("theme_list");
			}

			if($row["view"])
			{
				$this->result["view"] = $row["view"];
			}
			elseif($this->diafan->configmodules("view_list"))
			{
				$this->result["view"] = $this->diafan->configmodules("view_list");
			}
			else
			{
				$this->result["view"] = 'list';
			}

			$this->result["id"] = $row["id"];
			if ($this->diafan->configmodules("images_cat"))
			{
				$this->result["img"] = $this->diafan->_images->get(
						'medium', $row["id"], $this->diafan->module,
						$this->diafan->cid, $row["name"], true, 0, 'large'
					);
			}

			$this->result["children"] = array();
			$children = array();
			$result_children = DB::query(
					"SELECT c.id, c.[name], c.[anons], c.site_id FROM {news_category} AS c"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.cat_id=c.id AND a.module_name='news'" : "")
					." WHERE c.[act]='1' AND c.parent_id=%d AND c.trash='0' AND c.site_id=%d"
					." AND (c.access='0'"
					.($this->diafan->_user->id ? " OR c.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")"
					." GROUP BY c.id ORDER BY c.sort ASC, c.id ASC",
					$row["id"], $this->diafan->cid
				);

			while ($child = DB::fetch_array($result_children))
			{
				$child["link"] = $this->diafan->_route->link($child["site_id"], 'news', $child["id"]);
				if ($this->diafan->configmodules("images_cat") && $this->diafan->configmodules("list_img_cat"))
				{
					$child["img"] = $this->diafan->_images->get(
							'medium', $child["id"], $this->diafan->module, $child["site_id"],
							$child["name"], true, $this->diafan->configmodules("list_img_cat") == 1 ? 1 : 0,
							$child["link"]);
				}
				unset($child["site_id"]);
				$this->result["children"][] = $child;
				$children[] = $child["id"];
			}

			if (! $this->diafan->configmodules("childrens_elements"))
			{
				$children = array();
			}
			$children[] = $this->diafan->cat;

			////navigation//
			$this->diafan->_paginator->page = $this->diafan->page;
			$this->diafan->_paginator->navlink = $this->diafan->_route->current_link("page");
			$this->diafan->_paginator->navlink_tpl = $this->diafan->_route->current_link("", array("page" => "%d"));
			$this->diafan->_paginator->nen = DB::query_result(
					"SELECT COUNT(DISTINCT e.id) FROM {news} AS e"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='news'" : "")
					." INNER JOIN {news_category_rel} AS r ON e.id=r.element_id"
					." AND e.id=r.element_id AND r.cat_id IN (%s)"
					." WHERE e.[act]='1' AND e.trash='0' AND e.created<%d"
					." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
					." AND (e.access='0'"
					.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")",
					implode(',', $children), $time, $time, $time
				);
			$links = $this->diafan->_paginator->get();
			////navigation///

			$result_img = DB::query_range(
					"SELECT e.id, e.[name], e.cat_id, e.timeedit, e.[anons], e.site_id, e.created FROM {news} AS e"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='news'" : "")
					." INNER JOIN {news_category_rel} AS r ON e.id=r.element_id AND r.cat_id IN (%s)"
					." WHERE e.[act]='1' AND e.trash='0' AND e.created<%d"
					." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
					." AND (e.access='0'"
					.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")"
					." GROUP BY e.id ORDER BY e.prior DESC, e.created DESC, e.id DESC",
					implode(',', $children), $time, $time, $time,
					$this->diafan->_paginator->polog, $this->diafan->_paginator->nastr
				);

			$this->result["rows"] = $this->get_elements($result_img);

			$this->result["paginator"] = $links;

			$this->result["titlemodule"] = $row["name"];
			$this->result["edit_meta"]   = array("id" => $row["id"], "table" => "news_category");
			$this->result["title_meta"] = $row["title_meta"];
			$this->result["timeedit"] = $row["timeedit"];
			$this->result["keywords"] = $row["keywords"];
			$this->result["descr"] = $row["descr"];

			$previous = DB::fetch_array(DB::query(
					"SELECT c.[name], c.id FROM {news_category} AS c"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.cat_id=c.id AND a.module_name='news'" : "")
					." WHERE c.[act]='1' AND c.trash='0' AND c.site_id=%d"
					." AND (c.sort<%d OR c.sort=%d AND c.id<%d) AND c.parent_id=%d"
					." AND (c.access='0'"
					.($this->diafan->_user->id ? " OR c.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")"
					." ORDER BY c.sort DESC, c.id DESC LIMIT 1",
					$this->diafan->cid, $row["sort"], $row["sort"], $this->diafan->cat, $row["parent_id"]
				));
			if ($previous)
			{
				$this->result["previous"]["text"] = $previous["name"];
				$this->result["previous"]["id"] = $previous["id"];
				$this->result["previous"]["link"] = $this->diafan->_route->link($this->diafan->cid, "news", $previous["id"]);
			}
			$next = DB::fetch_array(DB::query(
					"SELECT c.[name], c.id FROM {news_category} AS c"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.cat_id=c.id AND a.module_name='news'" : "")
					." WHERE c.[act]='1' AND c.trash='0' AND c.site_id=%d"
					." AND (c.sort>%d OR c.sort=%d AND c.id>%d) AND c.parent_id=%d"
					." AND (c.access='0'"
					.($this->diafan->_user->id ? " OR c.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")"
					." ORDER BY c.sort ASC, c.id ASC LIMIT 1",
					$this->diafan->cid, $row["sort"], $row["sort"], $this->diafan->cat, $row["parent_id"]
				));
			if ($next)
			{
				$this->result["next"]["text"] = $next["name"];
				$this->result["next"]["id"] = $next["id"];
				$this->result["next"]["link"] = $this->diafan->_route->link($this->diafan->cid, "news", $next["id"]);
			}

			//сохранение кеша
			$this->diafan->_cache->save($this->result, $cache_meta, $this->diafan->module);
		}

		$text = DB::query_result("SELECT [text] FROM {news_category} WHERE id=%d", $this->diafan->cat);
		$this->result["text"] = $this->diafan->_useradmin->get($text, 'text', $this->diafan->cat, 'news_category', _LANG);

		$this->result["comments"] = $this->diafan->_comments->get(0, '', 0, true);
		$this->result["rating"] = $this->diafan->_rating->get(0, '', 0, true);

		if ($this->result["rows"])
		{
			foreach ($this->result["rows"] as $i => $row)
			{
				$this->result["rows"][$i]["tags"] = $this->diafan->_tags->get($row["id"]);

				$this->result["rows"][$i]["rating"] = $this->diafan->_rating->get($row["id"]);

				$this->result["rows"][$i]["name"] = $this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'news', _LANG);

				$this->result["rows"][$i]["anons"] = $this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'news', _LANG);

				$this->result["rows"][$i]["date"] = $this->diafan->_useradmin->get($row["date"], 'created', $row["id"], 'news');
			}
			if (!empty($this->result["previous"]["text"]))
			{
				$this->result["previous"]["text"] =
						$this->diafan->_useradmin->get($this->result["previous"]["text"], 'name', $this->result["previous"]["id"], 'news_category', _LANG);
			}
			if (!empty($this->result["next"]["text"]))
			{
				$this->result["next"]["text"] =
						$this->diafan->_useradmin->get($this->result["next"]["text"], 'name', $this->result["next"]["id"], 'news_category', _LANG);
			}
			foreach ($this->result["children"] as $id => $row)
			{
				$this->result["children"][$id]["name"] = $this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'news_category', _LANG);
				$this->result["children"][$id]["anons"] = $this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'news_category', _LANG);
			}
			foreach ($this->result["path"] as $k => $path)
			{
				if ($k == 0)
					continue;
				$this->result["path"][$k]["name"] = $this->diafan->_useradmin->get($path["name"], 'name', $path["id"], 'news_category', _LANG);
			}
		}
		$this->result["paginator"] = $this->diafan->_tpl->get('get', 'paginator', $this->result["paginator"]);
		return $this->result;
	}

	/**
	 * Генерирует данные для страницы новости
	 *
	 * @return array|boolean false
	 */
	public function id()
	{
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		//кеширование
		$cache_meta = array(
			"name" => "show",
			"cat_id" => $this->diafan->cat,
			"show" => $this->diafan->show,
			"lang_id" => _LANG,
			"site_id" => $this->diafan->cid,
			"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0,
			"time"    => $time
		);
		if (!$this->result = $this->diafan->_cache->get($cache_meta, $this->diafan->module))
		{
			$row = DB::fetch_array(DB::query(
					"SELECT id, [name], timeedit, created, cat_id, [keywords], [descr], site_id, [title_meta], access, theme, view FROM {news}"
					." WHERE [act]='1' AND id = %d AND trash='0' AND site_id=%d AND created<%d"
					." AND date_start<=%d AND (date_finish=0 OR date_finish>=%d)",
					$this->diafan->show, $this->diafan->cid, $time, $time, $time
				));
			if (empty($row))
			{
				include ABSOLUTE_PATH.'includes/404.php';
			}

			if (! $this->diafan->rewrite_module && ($this->diafan->configmodules("cat") && $this->diafan->cat != $row["cat_id"]
			  || ! $this->diafan->configmodules("cat") && $this->diafan->cat))
			{
				include ABSOLUTE_PATH.'includes/404.php';
			}
			if (!empty($row['access']) && !$this->access($row['id']))
			{
				include ABSOLUTE_PATH . 'includes/403.php';
			}

			if($row["theme"])
			{
				$this->result["theme"] = $row["theme"];
			}
			elseif($this->diafan->configmodules("theme_id"))
			{
				$this->result["theme"] = $this->diafan->configmodules("theme_id");
			}

			if($row["view"])
			{
				$this->result["view"] = $row["view"];
			}
			elseif($this->diafan->configmodules("view_id"))
			{
				$this->result["view"] = $this->diafan->configmodules("view_id");
			}
			else
			{
				$this->result["view"] = 'id';
			}

			$this->result["id"] = $this->diafan->show;
			$this->diafan->cat = $this->diafan->configmodules("cat") ? $row["cat_id"] : 0;
			$this->result["cat_id"] = $this->diafan->configmodules("cat") ? $row["cat_id"] : 0;

			if ($this->diafan->configmodules("images"))
			{
				$this->result["img"] = $this->diafan->_images->get(
						'medium', $row["id"], $this->diafan->module,
						$this->diafan->cid, $row["name"], false, 0, 'large'
					);
			}

			if ($this->result["cat_id"])
			{
				$this->result["allnews"]["link"] = $this->diafan->_route->link($row["site_id"], "news", $row["cat_id"]);
			}
			else
			{
				$this->result["allnews"]["link"] = $this->diafan->_route->link($row["site_id"]);
			}

			$previous = DB::fetch_array(DB::query(
					"SELECT e.[name], e.id, e.cat_id FROM {news} AS e"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='news'" : "")
					." WHERE e.[act]='1' AND e.trash='0' AND e.site_id=%d"
					.($this->diafan->configmodules("cat") ? " AND e.cat_id='" . $this->diafan->cat . "'" : '')
					." AND (e.created<%d OR e.created=%d AND e.id<%d)"
					." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
					." AND (e.access='0'"
					.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")"
					." ORDER BY e.prior DESC, e.created DESC, e.id DESC LIMIT 1",
					$this->diafan->cid, $row["created"], $row["created"], $this->diafan->show, $time, $time
				));
			if ($previous)
			{
				$this->result["previous"]["text"] = $previous["name"];
				if (!$this->diafan->configmodules("cat"))
				{
					$previous["cat_id"] = 0;
				}
				$this->result["previous"]["id"] = $previous["id"];
				$this->result["previous"]["link"] = $this->diafan->_route->link($this->diafan->cid, "news", $previous["cat_id"], $previous["id"]);
			}
			$next = DB::fetch_array(DB::query(
					"SELECT e.[name], e.id, e.cat_id FROM {news} AS e"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='news'" : "")
					." WHERE e.[act]='1' AND e.trash='0' AND e.site_id=%d"
					.($this->diafan->configmodules("cat") ? " AND e.cat_id='" . $this->diafan->cat . "'" : '')
					." AND e.created<%d AND (e.created>%d OR e.created=%d AND e.id>%d)"
					." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
					." AND (e.access='0'"
					.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")"
					." ORDER BY e.prior ASC, e.created ASC, e.id ASC LIMIT 1",
					$this->diafan->cid, $time, $row["created"], $row["created"], $this->diafan->show, $time, $time
				));
			if ($next)
			{
				$this->result["next"]["text"] = $next["name"];
				if (!$this->diafan->configmodules("cat"))
				{
					$next["cat_id"] = 0;
				}
				$this->result["next"]["id"] = $next["id"];
				$this->result["next"]["link"] = $this->diafan->_route->link($this->diafan->cid, "news", $next["cat_id"], $next["id"]);
			}

			$this->result["id"] = $this->diafan->show;
			$this->result["date"] = $this->format_date($row['created']);

			$this->result["titlemodule"] = $row["name"];
			$this->result["edit_meta"]   = array("id" => $row["id"], "table" => "news");
			$this->result["title_meta"] = $row["title_meta"];
			$this->result["timeedit"] = $row["timeedit"];

			$this->result["keywords"] = $row["keywords"];
			$this->result["descr"] = $row["descr"];

			$this->result["path"] = $this->get_path('news');

			//сохранение кеша
			$this->diafan->_cache->save($this->result, $cache_meta, $this->diafan->module);
		}
		$this->diafan->cat = $this->result["cat_id"];

		$row = DB::fetch_array(DB::query("SELECT [text], [anons] FROM {news} WHERE id=%d", $this->diafan->show));

		$this->result["text"] = $this->diafan->_useradmin->get($row["text"], 'text', $this->result["id"], 'news', _LANG);
		$this->result["anons"] = $this->diafan->_useradmin->get($row["anons"], 'anons', $this->result["id"], 'news', _LANG);
		$this->result["date"] = $this->diafan->_useradmin->get($this->result["date"], 'created', $this->result["id"], 'news');

		if (!empty($this->result["previous"]["text"]))
		{
			$this->result["previous"]["text"] =
					$this->diafan->_useradmin->get($this->result["previous"]["text"], 'name', $this->result["previous"]["id"], 'news', _LANG);
		}
		if (!empty($this->result["next"]["text"]))
		{
			$this->result["next"]["text"] =
					$this->diafan->_useradmin->get($this->result["next"]["text"], 'name', $this->result["next"]["id"], 'news', _LANG);
		}
		foreach ($this->result["path"] as $k => $path)
		{
			if ($k == 0)
				continue;
			$this->result["path"][$k]["name"] = $this->diafan->_useradmin->get($path["name"], 'name', $path["id"], 'news_category', _LANG);
		}
		$this->result["rating"] = $this->diafan->_rating->get();
		$this->result["comments"] = $this->diafan->_comments->get();
		$this->result["tags"] = $this->diafan->_tags->get();

		return $this->result;
	}

	/**
	 * Генерирует данные для шаблонной функции: блок новостей
	 *
	 * @param integer $count количество новостей
	 * @param integer $cat_id категория
	 * @param integer $images количество изображений
	 * @param string $images_variation размер изображений
	 * @param integer $site_id страница сайта
	 * @return array
	 */
	public function show_block($count, $cat_id, $images, $images_variation, $site_id)
	{
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		//кеширование
		$cache_meta = array(
			"name" => "block",
			"cat_id" => $cat_id,
			"count" => $count,
			"lang_id" => _LANG,
			"time" => $time,
			"site_id" => $site_id,
			"images"   => $images,
			"images_variation" => $images_variation,
			"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0
		);
		if (!$this->result = $this->diafan->_cache->get($cache_meta, "news"))
		{
			if ( ! $site_id && $cat_id)
			{
				$site_id = DB::query_result("SELECT site_id FROM {news_category} WHERE id=%d", $cat_id);
			}
			if(! $site_id = $this->diafan->_route->id_module("news", $site_id))
			{
				return false;
			}
			if ($cat_id && $this->diafan->configmodules("cat", "news", $site_id))
			{
				if(DB::query_result("SELECT access FROM {news_category} WHERE id=%d", $cat_id))
				{
					if(! $this->access(0, $cat_id, "news"))
					{
						return false;
					}
				}
				if ($this->diafan->configmodules("childrens_elements", "news", $site_id))
				{
					$children = $this->diafan->get_children($cat_id, "news_category");
				}
				$children[] = $cat_id;
			}
			$this->result["rows"] = array();
			$result = DB::query_range(
					"SELECT e.id, e.[name],e.[anons], e.cat_id, e.timeedit, e.site_id, e.created FROM {news} AS e"
					.($cat_id && $this->diafan->configmodules("cat", "news", $site_id)
					  ? " INNER JOIN {news_category_rel} as r ON r.element_id=e.id"
					    ." AND r.cat_id IN (" . implode(',', $children) . ")"
					  : ''
					 )
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='news'" : "")
					." WHERE e.[act]='1' AND e.trash='0' AND e.created<%d"
					." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
					.($site_id ? " AND e.site_id=" . $site_id : '')
					." AND (e.access='0'"
					.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")"
					." GROUP BY e.id ORDER BY e.prior DESC, e.created DESC, e.id DESC",
					$time, $time, $time, 0, $count
				);
			$rows = $this->get_elements($result, array("count" => $images, "variation" => $images_variation));
			$this->result["rows"] = array_merge($this->result["rows"], $rows);

			if (!empty($this->result["rows"]) && $cat_id && $this->diafan->configmodules("cat", "news", $site_id))
			{
				$cat = DB::fetch_array(DB::query("SELECT [name], site_id, id FROM {news_category} WHERE id=%d", $cat_id));

				$this->result["name"] = $cat["name"];
				$this->result["link_all"] = $this->diafan->_route->link($cat["site_id"], 'news', $cat["id"]);
				$this->result["category"] = true;
			}
			elseif (!empty($this->result["rows"]) && $site_id)
			{
				$this->result["name"] = DB::query_result("SELECT [name] FROM {site} WHERE id=%d", $site_id);
				$this->result["link_all"] = $this->diafan->_route->link($site_id);
				$this->result["category"] = false;
			}
			$this->diafan->_cache->save($this->result, $cache_meta, "news");
		}

		if ($this->result["rows"])
		{
			foreach ($this->result["rows"] as $i => $row)
			{
				$this->result["rows"][$i]["name"] = $this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'news', _LANG);
				
				$this->result["rows"][$i]["anons"] = $this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'news', _LANG);

				$this->result["rows"][$i]["date"] = $this->diafan->_useradmin->get($row["date"], 'created', $row["id"], 'news', _LANG);
			}
		}

		return $this->result;
	}

	/**
	 * Генерирует данные для шаблонной функции: блок связанных новостей
	 * 
	 * @param integer $count количество новостей
	 * @param integer $images количество изображений
	 * @param string $images_variation размер изображений
	 * @return array
	 */
	public function show_block_rel($count, $images, $images_variation)
	{
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		//кеширование
		$cache_meta = array(
			"name" => "block_rel",
			"count" => $count,
			"lang_id" => _LANG,
			"element_id" => $this->diafan->show,
			"images" => $images,
			"images_variation" => $images_variation,
			"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0,
			"time" => $time
		);

		if (! $this->result = $this->diafan->_cache->get($cache_meta, "news"))
		{
			$this->result["rows"] = array();

			$result = DB::query_range(
			"SELECT e.id, e.[name], e.[anons], e.cat_id, e.created, e.timeedit, e.site_id FROM {news} AS e"
			. " INNER JOIN {news_rel} AS r ON e.id=r.rel_element_id AND r.element_id=%d"
			.($this->diafan->configmodules("rel_two_sided") ? " OR e.id=r.element_id AND r.rel_element_id=".$this->diafan->show : '')
			. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='news'" : "")
			. " WHERE e.[act]='1' AND e.trash='0' AND e.created<%d"
			." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
			. " AND (e.access='0'"
			. ($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
			. ")"
			. " GROUP BY e.id"
			. ' ORDER BY e.created DESC',
			$this->diafan->show, $time, $time, $time, 0, $count
			);
			$this->result["rows"] = $this->get_elements($result, array("count" => $images, "variation" => $images_variation));
			$this->diafan->_cache->save($this->result, $cache_meta, "news");
		}

		if ($this->result["rows"])
		{
			foreach ($this->result["rows"] as $i => $row)
			{
				$this->result["rows"][$i]["name"] = $this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'news', _LANG);

				$this->result["rows"][$i]["anons"] = $this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'news', _LANG);

				$this->result["rows"][$i]["date"] = $this->diafan->_useradmin->get($row["date"], 'created', $row["id"], 'news');
			}
		}
		return $this->result;
	}

	/**
	 * Генерирует данные для шаблонной функции: календарь архива новостей
	 *
	 * @param boolean $only_news показывать только на странице новостей
	 * @param string $detail детализация: год, месяц, день
	 * @param integer $site_id страница сайта
	 * @param integer $cat_id категория новостей
	 * @param string $template шаблон
	 * @param integer $month_current выбранный месяц
	 * @param integer $year_current выбранный год
	 * @return array
	 */
	public function show_calendar($only_news, $detail, $site_id, $cat_id, $template = '', $month_current = 0, $year_current = 0)
	{
		if(! $site_id && $this->diafan->module == "news")
		{
			$site_id = $this->diafan->cid;
		}
		if ($only_news && ($site_id != $this->diafan->cid || $this->diafan->module != "news"))
		{
			return false;
		}

		$day_current = 0;
		if (! $year_current && ! $month_current && $this->diafan->module == "news" && $site_id == $this->diafan->cid)
		{
			$year_current = $this->diafan->year;
			$month_current = $this->diafan->month;
			$day_current = $this->diafan->day;
		}
		if (! $year_current && $detail == 'day')
		{
			$year_current = date("Y");
		}
		if (! $month_current && $detail == 'day')
		{
			$month_current = date("m");
		}

		//кеширование
		$cache_meta = array(
			"name" => "calendar",
			"detail" => $detail,
			"perior" => $detail == 'day' ? $year_current."_".$month_current : 0,
			"lang_id" => _LANG,
			"site_id" => $site_id,
			"cat_id" => $cat_id,
			"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0
		);
		if (! $result = $this->diafan->_cache->get($cache_meta, "news"))
		{
			if(! $site_id = $this->diafan->_route->id_module("news", $site_id))
			{
				return false;
			}
			$cats = array();
			if ($cat_id && $this->diafan->configmodules("cat", "news", $site_id))
			{
				if(DB::query_result("SELECT access FROM {news_category} WHERE id=%d", $cat_id))
				{
					if(! $this->access(0, $cat_id, "news"))
					{
						return false;
					}
				}
				if ($this->diafan->configmodules("childrens_elements", "news"))
				{
					$cats = $this->diafan->get_children($cat_id, "news_category");
				}
				$cats[] = $cat_id;
			}
			$month_arr = array(
				'12' => $this->diafan->_('Декабрь', false),
				'11' => $this->diafan->_('Ноябрь', false),
				'10' => $this->diafan->_('Октябрь', false),
				'09' => $this->diafan->_('Сентябрь', false),
				'08' => $this->diafan->_('Август', false),
				'07' => $this->diafan->_('Июль', false),
				'06' => $this->diafan->_('Июнь', false),
				'05' => $this->diafan->_('Май', false),
				'04' => $this->diafan->_('Апрель', false),
				'03' => $this->diafan->_('Март', false),
				'02' => $this->diafan->_('Февраль', false),
				'01' => $this->diafan->_('Январь', false)
			);

			if($detail == 'day')
			{
				$month_current = $month_current < 10 ? '0'.intval($month_current) : $month_current;

				$week = array();
				$news_list = array();

				$day_count = date("t", mktime(0, 0, 0, $month_current, 1, $year_current));

				$time_start = mktime(0, 0, 0,$month_current, 1, $year_current);
				$time_end = mktime(0, 0, 0, $month_current, $day_count, $year_current) + 86400;

				$rows = DB::query(
						"SELECT e.created FROM {news} AS e"
						.($cats ? "INNER JOIN {news_category_rel} as r ON r.element_id=e.id" : "")
						.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='news'" : "")
						." WHERE e.[act]='1' AND e.site_id=%d" . ($cats ? " AND r.cat_id IN (".implode(",", $cat_id).")" : "")
						." AND (e.access='0'"
						.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
						.") AND e.created>=%d AND e.created<=%d", $site_id, $time_start, $time_end
					);

				while ($row = DB::fetch_array($rows))
				{
					$day = date("j", $row["created"]);

					if (isset($news_list[$day]))
					{
						$news_list[$day]++;
					}
					else
					{
						$news_list[$day] = 1;
					}

				}

				$day = 1;
				$num = 0;
				for($i = 0; $i < 7; $i++)
				{
					$dayofweek = date('w', mktime(0, 0, 0, $month_current, $day, $year_current));
					$dayofweek = $dayofweek - 1;
					if($dayofweek == -1)
					{
						$dayofweek = 6;
					}
					if($dayofweek == $i)
					{
						$result["week"][$num][$i] = array(
							"day" => $day,
							"link" => $this->diafan->_route->link($site_id, "news") . 'year'.$year_current.'/month'.$month_current .'/day'.$day.'/',
							"count" => array_key_exists($day, $news_list) ? $news_list[$day] : 0
						);
						$day++;
					}
					else
					{
						$week[$num][$i] = "";
					}
				}

				while(true)
				{
					$num++;
					for($i = 0; $i < 7; $i++)
					{
						$result["week"][$num][$i] = array(
							"day" => $day,
							"link" => $this->diafan->_route->link($site_id, "news") . 'year'.$year_current.'/month'.$month_current .'/day'.$day.'/',
							"count" => array_key_exists($day, $news_list) ? $news_list[$day] : 0
						);
						$day++;
						if($day > $day_count)
						{
							break;
						}
					}
					if($day > $day_count)
					{
						break;
					}
				}
				$result['month_name'] = $month_arr[$month_current];
				$result["site_id"] = $site_id;
				$result["cat_id"] = $cat_id;
			}
			else
			{
				$d = DB::query_result(
						"SELECT e.created FROM {news} AS e"
						.($cats ? "INNER JOIN {news_category_rel} as r ON r.element_id=e.id" : "")
						.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='news'" : "")
						." WHERE e.[act]='1' AND e.site_id=%d" . ($cats ? " AND r.cat_id IN (".implode(",", $cat_id).")" : "")
						." AND (e.access='0'"
						.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
						.")"
						." ORDER BY e.created ASC LIMIT 1", $site_id
					);
				$nyear = 2008;

				if ($d > 0)
				{
					$nyear = date("Y", $d);
				}

				if (date("Y") - $nyear > 10)
				{
					$nyear = 2008;
				}

				for ($Ye = date("Y"); $Ye >= $nyear; $Ye--)
				{
					$result["rows"][$Ye]["year"]["link"] = $this->diafan->_route->link($site_id, "news") . 'year' . $Ye . '/';
					$result["rows"][$Ye]["year"]["name"] = $Ye;

					if ($detail != "year")
					{
						for ($num = 12; $num > 0; $num--)
						{
							if ($Ye != date("Y") || $num <= date("m"))
							{
								if ($num < 10)
								{
									$num = '0' . $num;
								}

								$val = $month_arr[$num];
								$count_news = DB::query_result(
										"SELECT COUNT(DISTINCT e.id) FROM {news} AS e"
										.($cat_id ? "INNER JOIN {news_category_rel} as r ON r.element_id=e.id" : "")
										.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='news'" : "")
										." WHERE e.[act]='1' AND e.trash='0' AND e.created>%d AND e.created<=%d AND e.site_id=%d"
										." AND (e.access='0'"
										.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
										.")"
										.($cat_id ? " AND r.cat_id=%d" : ""),
										mktime(0, 0, 0, $num, 1, $Ye),
										mktime(0, 0, 0, $num, 31, $Ye),
										$site_id, $cat_id
									);
								$result["rows"][$Ye]["months"][$num] = array(
									"link" => $count_news ? $this->diafan->_route->link($site_id, "news") . 'year' . $Ye . '/month' . $num . '/' : '',
									"name" => $val
								);
							}
						}
					}
				}
			}

			$result["link"] = $this->diafan->_route->link($site_id);

			//сохранение кеша
			$this->diafan->_cache->save($result, $cache_meta, "news");
		}

		$result["template"] = $template;
		$result["day"] = $day_current;
		$result["year"] = $year_current;
		$result["month"] = $month_current;

		if($detail == 'day')
		{
			for($i = 0; $i < count($result['week']); $i++)
			{
				for($j = 0; $j < 7; $j++)
				{
					$result['week'][$i][$j]["today"] = ($result["month"] == date("m") && $result["year"] == date("Y") && ! empty($result['week'][$i][$j]["day"]) && $result['week'][$i][$j]["day"] == date("d") ? true : false);
				}
			}
		}
		return $result;
	}

	/**
	 * Форматирует данные о новостях для списка новостей
	 *
	 * @param resource $result результат выполнения SQL-запроса
	 * @param string $images_config настройки отображения изображений
	 * @return array
	 */
	public function get_elements($result, $images_config = '')
	{
		if (empty($this->result["timeedit"]))
		{
			$this->result["timeedit"] = '';
		}
		$rows = array();
		while ($row = DB::fetch_array($result))
		{
			if (!$this->diafan->configmodules("cat", "news", $row["site_id"]))
			{
				$row["cat_id"] = 0;
			}

			if ($row["timeedit"] < $this->result["timeedit"])
			{
				$this->result["timeedit"] = $row["timeedit"];
			}
			unset($row["timeedit"]);

			$row["link"] = $this->diafan->_route->link($row["site_id"], "news", $row["cat_id"], $row["id"]);
			unset($row["cat_id"]);

			if ($this->diafan->configmodules("images", "news", $row["site_id"]))
			{
				if (is_array($images_config))
				{
					$row["img"]  = $this->diafan->_images->get(
							$images_config["variation"], $row["id"], 'news',
							$row["site_id"], $row["name"], false,
							$images_config["count"], $row["link"]
						);
				}
				elseif($this->diafan->configmodules("list_img", "news", $row["site_id"]))
				{
					$row["img"]  = $this->diafan->_images->get(
							'medium', $row["id"], 'news', $row["site_id"], $row["name"], false,
					        $this->diafan->configmodules("list_img", "news", $row["site_id"]) == 1 ? 1 : 0,
					        $row["link"]
						);
				}
			}
			$row["date"] = $this->format_date($row['created'], "news", $row["site_id"]);
			unset($row["created"]);

			$rows[] = $row;
		}
		return $rows;
	}
}