<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.1
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Photo_admin_config
 *
 * Конфигурация фотогалереи
 */
class Photo_admin_config extends Frame_admin
{
	/**
	 * @var array поля в базе данных для редактирования
	 */
	public $variables = array (
		'config'       => array (
			'nastr' => array(
				'type' => 'numtext',
				'name' => 'Количество фотографий на странице',
			),
			'hr1' => 'hr',
			'cat' => array(
				'type' => 'checkbox',
				'name' => 'Использовать альбомы',
				'help' => 'Разделение фотогалереи на альбомы-подкатегории.',
			),
			'count_list' => array(
				'type' => 'numtext',
				'name' => 'Количество фотографий в списке альбомов',
			),
			'childrens_elements' => array(
				'type' => 'checkbox',
				'name' => 'Показывать фотографии вложенных альбомов',
				'help' => 'Если отмечена, в списке фотоальбомов будут отображатся последние добавленные фотографии из всех вложенных альбомов.',
			),
			'hr2' => 'hr',
			'images' => array(
				'type' => 'module',
				'name' => 'Изображения',
			),
			'hr3' => 'hr',
			'multiupload_act'     => array(
				'type' => 'checkbox',
				'name' => 'Активировать фотографии сразу после групповой загрузки',
			),
			'page_show' => array(
				'type' => 'checkbox',
				'name' => 'Открывать фотографию на отдельной странице',
				'help' => 'Если не отмечена, фотографии из альбома будут сразу увеличиваться. Если отмечена, каждая фотография будет открываться на отдельной странице с полным текстовым описанием, ее можно будет комментировать, ставить рейтинг.',
			),
			'rel_two_sided' => array(
				'type' => 'checkbox',
				'name' => 'В блоке похожих фотографий связь двусторонняя',
			),
			'hr4' => 'hr',
			'comments' => array(
				'type' => 'module',
				'name' => 'Показывать комментарии к фотографиям',
			),
			'tags' => array(
				'type' => 'module',
				'name' => 'Подключить теги',
			),
			'rating' => array(
				'type' => 'module',
				'name' => 'Показывать рейтинг фотографий',
			),
			'themes' => array(
				'type' => 'function',
			),
			'theme_list' => array(
				'type' => 'none',
				'name' => 'Шаблон для списка элементов',
				'help' => 'Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_list' => array(
				'type' => 'none',
			),
			'theme_first_page' => array(
				'type' => 'none',
				'name' => 'Шаблон для первой страницы модуля (если подключены категории)',
				'help' => 'Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_first_page' => array(
				'type' => 'none',
			),
			'theme_id' => array(
				'type' => 'none',
				'name' => 'Шаблон для страницы элемента',
				'help' => 'Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_id' => array(
				'type' => 'none',
			),
			'hr_admin_page' => 'hr',
			'admin_page'     => array(
				'type' => 'checkbox',
				'name' => 'Отдельный пункт в меню администрирования для каждого раздела сайта',
			),
		),
	);

	/**
	 * @var array настройки модуля
	 */
	public $config = array (
		'element_site', // делит элементы по разделам (страницы сайта, к которым прикреплен модуль)
		'config', // файл настроек модуля
	);

	/**
	 * @var array зависимости между полями
	 */
	public $show_tr_click_checkbox = array(
		'cat' => array(
			'count_list',
			'childrens_elements'
		)
	);

	/**
	 * Подключение js файла
	 * 
	 * @return void
	 */
	public function edit_config_variable_view_id()
	{
		echo '<script type="text/javascript" src="' . BASE_PATH . 'modules/photo/admin/photo.admin.config.js"></script>';
	}
}