<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.1
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Photo_model
 *
 * Модель модуля "Фотогалерея"
 */
class Photo_model extends Model
{
	/**
	 * Генерирует данные для списка всех фотографий без деления на категории
	 * 
	 * @return array
	 */
	public function list_()
	{
		if ($this->diafan->cat)
		{
			include ABSOLUTE_PATH.'includes/404.php';
		}
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		$cache_meta = array(
				"name"     => "list",
				"lang_id"  => _LANG,
				"page"     => $this->diafan->page > 1 ? $this->diafan->page : 1,
				"site_id"  => $this->diafan->cid,
				"role_id"  => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0,
				"time"     => $time
			);

		//кеширование
		if (! $this->result = $this->diafan->_cache->get($cache_meta, $this->diafan->module))
		{
			$this->result = array();

			////navigation//
			$this->diafan->_paginator->page    = $this->diafan->page;
			$this->diafan->_paginator->navlink = $this->diafan->_route->current_link("page");
			$this->diafan->_paginator->navlink_tpl = $this->diafan->_route->current_link("", array("page" => "%d"));
			$this->diafan->_paginator->nen = DB::query_result(
			"SELECT COUNT(DISTINCT e.id) FROM {photo} AS e"
			.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='photo'" : "")
			." WHERE e.[act]='1' AND e.trash='0' AND e.site_id=%d"
			." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
			." AND (e.access='0'"
			.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
			.")", 
			$this->diafan->cid, $time, $time
			);
			$links = $this->diafan->_paginator->get();
			////navigation///

			$result = DB::query_range(
			"SELECT e.id, e.[name], e.[anons], e.timeedit, e.cat_id, e.site_id FROM {photo} AS e"
			.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='photo'" : "")
			." WHERE e.[act]='1' AND e.trash='0' AND e.site_id=%d"
			." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
			." AND (e.access='0'"
			.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
			.")"
			." GROUP BY e.id ORDER BY e.sort ASC, e.id ASC",
			$this->diafan->cid, $time, $time,
			$this->diafan->_paginator->polog, $this->diafan->_paginator->nastr
			);
			
			$this->result["rows"] = $this->get_elements($result);

			$this->result["paginator"] = $links;
			
			//сохранение кеша
			$this->diafan->_cache->save($this->result, $cache_meta, $this->diafan->module);
		}

		if ($this->result["rows"])
		{
			foreach ($this->result["rows"] as $i => $row)
			{
				$this->result["rows"][$i]["tags"] = $this->diafan->_tags->get($row["id"]);

				$this->result["rows"][$i]["rating"] = $this->diafan->_rating->get($row["id"]);

				$this->result["rows"][$i]["name"] = $this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'photo', _LANG);

				$this->result["rows"][$i]["anons"] = $this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'photo',  _LANG);
			}
		}
		if($this->diafan->configmodules("theme_list"))
		{
			$this->result["theme"] = $this->diafan->configmodules("theme_list");
		}
		if($this->diafan->configmodules("view_list"))
		{
			$this->result["view"] = $this->diafan->configmodules("view_list");
		}
		else
		{
			$this->result["view"] = 'list';
		}
		$this->result["paginator"] = $this->diafan->_tpl->get('get', 'paginator', $this->result["paginator"]);
		return $this->result;
	}

	/**
	 * Генерирует данные для первой страницы фотогалереи
	 * 
	 * @return array
	 */
	public function first_page()
	{
		if ($this->diafan->page)
		{
			include ABSOLUTE_PATH.'includes/404.php';
		}
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		//кеширование
		$cache_meta = array(
				"name"     => "first_page",
				"lang_id" => _LANG,
				"site_id"  => $this->diafan->cid,
				"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0,
				"time"     => $time
			);
		if (! $this->result = $this->diafan->_cache->get($cache_meta, $this->diafan->module))
		{
			$this->result = array();

			$result = DB::query(
			"SELECT c.id, c.[name], c.[anons], c.timeedit, c.site_id FROM {photo_category} AS c"
			.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.cat_id=c.id AND a.module_name='photo'" : "")
			." WHERE c.[act]='1' AND c.parent_id=0 AND c.trash='0' AND c.site_id=%d"
			." AND (c.access='0'"
			.($this->diafan->_user->id ? " OR c.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
			.")"
			." GROUP BY c.id ORDER by c.sort ASC, c.id ASC",
			$this->diafan->cid
			);

			while ($row = DB::fetch_array($result))
			{
				$cats = array();
				$cats["name"] = $row["name"];
				$cats["anons"] = $row["anons"];
				$cats["id"] = $row["id"];

				if (empty($this->result["timeedit"]) || $row["timeedit"] > $this->result["timeedit"])
				{
					$this->result["timeedit"] = $row["timeedit"];
				}

				$cats["children"] = array();
				$children = array();
				$result_children = DB::query(
				"SELECT c.id, c.[name], c.[anons], c.site_id FROM {photo_category} AS c"
				.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.cat_id=c.id AND a.module_name='photo'" : "")
				." WHERE c.[act]='1' AND c.parent_id=%d AND c.trash='0' AND c.site_id=%d"
				." AND (c.access='0'"
				.($this->diafan->_user->id ? " OR c.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
				.")"
				." GROUP BY c.id ORDER BY c.sort ASC, c.id ASC",
				$row["id"], $this->diafan->cid);

				while ($row_children = DB::fetch_array($result_children))
				{
					$child["link"]  = $this->diafan->_route->link($row_children["site_id"], 'photo', $row_children["id"]);
					if ($this->diafan->configmodules("images_cat") && $this->diafan->configmodules("list_img_cat"))
					{
						$child["img"] = $this->diafan->_images->get(
								'medium', $child["id"], $this->diafan->module, $child["site_id"],
								$child["name"], true, $this->diafan->configmodules("list_img_cat") == 1 ? 1 : 0,
						        $child["link"]);
					}
					$child["name"]  = $row_children["name"];
					$child["anons"] = $row_children["anons"];
					$cats["children"][$row_children["id"]] = $child;
					$children[] = $child["id"];
				}

				if (! $this->diafan->configmodules("childrens_elements"))
				{
					$children = array();
				}
				$children[] = $row["id"];

				$result_img = DB::query_range(
				"SELECT e.id, e.[name], e.cat_id, e.timeedit, e.[anons], e.site_id FROM {photo} AS e"
				." INNER JOIN {photo_category_rel} AS r ON e.id=r.element_id"
				.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='photo'" : "")
				." WHERE r.cat_id IN (%s) AND e.[act]='1' AND e.trash='0'"
				." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
				." AND (e.access='0'"
				.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
				.")"
				." GROUP BY e.id ORDER BY e.sort ASC, e.id ASC",
				implode(',', $children), $time, $time,
				0, $this->diafan->configmodules("count_list")
				);
				$cats["rows"] = $this->get_elements($result_img);

				$cats["link_all"] = $this->diafan->_route->link($row["site_id"], 'photo', $row["id"]);

				if ($this->diafan->configmodules("images_cat") && $this->diafan->configmodules("list_img_cat"))
				{
					$cats["img"] =
					$this->diafan->_images->get(
							'medium', $row["id"], $this->diafan->module,
							$row["site_id"], $row["name"], true,
							$this->diafan->configmodules("list_img_cat") == 1 ? 1 : 0,
							$cats["link_all"]
						);
				}
				$this->result["categories"][] = $cats;
			}

			//сохранение кеша
			$this->diafan->_cache->save($this->result, $cache_meta, $this->diafan->module);
		}

		if (! empty($this->result["categories"]))
		{
			foreach ($this->result["categories"] as $cat => $rows)
			{
				if (! $rows)
					continue;

				$this->result["categories"][$cat]["name"] = $this->diafan->_useradmin->get($rows["name"], 'name', $rows["id"], 'photo_category', _LANG);
				$this->result["categories"][$cat]["anons"] = $this->diafan->_useradmin->get($rows["anons"], 'anons', $rows["id"], 'photo_category', _LANG);
				$this->result["categories"][$cat]["rating"] = $this->diafan->_rating->get($rows["id"], '', 0, true);

				foreach ($rows["children"] as $k => $row)
				{
					$this->result["categories"][$cat]["children"][$k]["name"] =
						$this->diafan->_useradmin->get($row["name"], 'name', $k, 'photo_category', _LANG);

					$this->result["categories"][$cat]["children"][$k]["anons"] =
						$this->diafan->_useradmin->get($row["anons"], 'anons', $k, 'photo_category', _LANG);
				}

				foreach ($rows["rows"] as $k => $row)
				{
					$this->result["categories"][$cat]["rows"][$k]["tags"] = $this->diafan->_tags->get($row["id"]);

					$this->result["categories"][$cat]["rows"][$k]["rating"] = $this->diafan->_rating->get($row["id"]);

					$this->result["categories"][$cat]["rows"][$k]["name"] =
						$this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'photo', _LANG);

					$this->result["categories"][$cat]["rows"][$k]["anons"] =
						$this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'photo', _LANG);
				}
			}
		}
		if($this->diafan->configmodules("theme_first_page"))
		{
			$this->result["theme"] = $this->diafan->configmodules("theme_first_page");
		}
		if($this->diafan->configmodules("view_first_page"))
		{
			$this->result["view"] = $this->diafan->configmodules("view_first_page");
		}
		else
		{
			$this->result["view"] = 'first_page';
		}
		return $this->result;
	}

	/**
	 * Генерирует данные для списка фотографий в категории
	 * 
	 * @return array
	 */
	public function list_category()
	{
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		//кеширование
		$cache_meta = array(
				"name"     => "list",
				"cat_id"   => $this->diafan->cat,
				"lang_id" => _LANG,
				"page"     => $this->diafan->page > 1 ? $this->diafan->page : 1,
				"site_id"  => $this->diafan->cid,
				"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0,
				"time"     => $time
			);
		if (! $this->result = $this->diafan->_cache->get($cache_meta, $this->diafan->module))
		{
			$this->result = array();

			$this->result["level"] = count($this->diafan->get_parents($this->diafan->cat, 'photo_category'));

			$this->result["path"] = $this->get_path('photo');

			$result = DB::query("SELECT id, [name], timeedit, [descr], [keywords], sort, parent_id, [title_meta], access, theme, view FROM {photo_category}"
			                    ." WHERE [act]='1' and id=%d AND trash='0' AND site_id=%d"
			                    ." ORDER BY sort ASC, id ASC",
			                    $this->diafan->cat, $this->diafan->cid);

			if (! $row = DB::fetch_array($result))
			{
				include_once ABSOLUTE_PATH.'includes/404.php';
			}
			if (empty($row) || (!empty($row['access']) && !$this->access(0, $row['id'])))
			{
				include_once(ABSOLUTE_PATH.'includes/403.php');
			}

			if($row["theme"])
			{
				$this->result["theme"] = $row["theme"];
			}
			elseif($this->diafan->configmodules("theme_list"))
			{
				$this->result["theme"] = $this->diafan->configmodules("theme_list");
			}

			if($row["view"])
			{
				$this->result["view"] = $row["view"];
			}
			elseif($this->diafan->configmodules("view_list"))
			{
				$this->result["view"] = $this->diafan->configmodules("view_list");
			}
			else
			{
				$this->result["view"] = 'list';
			}
			$this->result["id"]  = $row["id"];

			if ($this->diafan->configmodules("images_cat"))
			{
				$this->result["img"] = $this->diafan->_images->get(
						'medium', $row["id"], $this->diafan->module,
						$this->diafan->cid, $row["name"], true, 0, 'large'
					);
			}

			$this->result["children"] = array();
			$children = array();
			$result_children = DB::query(
					"SELECT c.id, c.[name], c.[anons], c.site_id FROM {photo_category} AS c"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.cat_id=c.id AND a.module_name='photo'" : "")
					." WHERE c.[act]='1' AND c.parent_id=%d AND c.trash='0' AND c.site_id=%d"
					." AND (c.access='0'"
					.($this->diafan->_user->id ? " OR c.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")"
					." GROUP BY c.id ORDER BY c.sort ASC, c.id ASC", 
					$row["id"], $this->diafan->cid
				);
			while ($child= DB::fetch_array($result_children))
			{
				$child["link"]  = $this->diafan->_route->link($child["site_id"], 'photo', $child["id"]);
				if ($this->diafan->configmodules("images_cat") && $this->diafan->configmodules("list_img_cat"))
				{
					$child["img"] = $this->diafan->_images->get(
							'medium', $child["id"], $this->diafan->module, $child["site_id"],
							$child["name"], true, $this->diafan->configmodules("list_img_cat") == 1 ? 1 : 0,
							$child["link"]);
				}
				unset($child["site_id"]);
				$this->result["children"][] = $child;
				$children[] = $child["id"];
			}

			if (! $this->diafan->configmodules("childrens_elements"))
			{
				$children = array();
			}
			$children[] = $this->diafan->cat;

			////navigation//
			$this->diafan->_paginator->page    = $this->diafan->page;
			$this->diafan->_paginator->navlink = $this->diafan->_route->current_link("page");
			$this->diafan->_paginator->navlink_tpl = $this->diafan->_route->current_link("", array("page" => "%d"));
			$this->diafan->_paginator->nen = DB::query_result(
			"SELECT COUNT(DISTINCT e.id) FROM {photo} AS e"
			.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='photo'" : "")
			." INNER JOIN {photo_category_rel} AS r ON e.id=r.element_id AND r.cat_id IN (%s)"
			." WHERE e.[act]='1' AND e.trash='0'"
			." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
			." AND (e.access='0'"
			.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
			.")",
			implode(',', $children), $time, $time
			);
			$links = $this->diafan->_paginator->get();
			////navigation///

			$result_img = DB::query_range(
			"SELECT e.id, e.[name], e.cat_id, e.timeedit, e.[anons], e.site_id FROM {photo} AS e"
			.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='photo'" : "")
			." INNER JOIN {photo_category_rel} AS r ON e.id=r.element_id AND r.cat_id IN (%s)"
			." WHERE e.[act]='1' AND e.trash='0'"
			." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
			." AND (e.access='0'"
			.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
			.")"
			." GROUP BY e.id ORDER BY e.sort ASC, e.id ASC",
			implode(',', $children),  $time, $time,
			$this->diafan->_paginator->polog, $this->diafan->_paginator->nastr
			);
			$this->result["rows"] = $this->get_elements($result_img);

			$this->result["paginator"] = $links;

			$this->result["titlemodule"] = $row["name"];
			$this->result["edit_meta"]   = array("id" => $row["id"], "table" => "photo_category");
			$this->result["title_meta"]  = $row["title_meta"];
			$this->result["timeedit"]    = $row["timeedit"];
			$this->result["keywords"]    = $row["keywords"];
			$this->result["descr"]       = $row["descr"];

			$previous = DB::fetch_array(DB::query(
					"SELECT c.[name], c.id FROM {photo_category} AS c"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.cat_id=c.id AND a.module_name='photo'" : "")
					." WHERE c.[act]='1' AND c.trash='0' AND c.site_id=%d"
					." AND (c.sort<%d OR c.sort=%d AND c.id<%d) AND c.parent_id=%d"
					." AND (c.access='0'"
					.($this->diafan->_user->id ? " OR c.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")"
					." ORDER BY c.sort DESC, c.id DESC LIMIT 1",
					$this->diafan->cid, $row["sort"], $row["sort"], $this->diafan->cat, $row["parent_id"]
				));
			if ($previous)
			{
				$this->result["previous"]["text"] = $previous["name"];
				$this->result["previous"]["id"]   = $previous["id"];
				$this->result["previous"]["link"] = $this->diafan->_route->link($this->diafan->cid, "photo", $previous["id"]);
			}
			$next = DB::fetch_array(DB::query(
					"SELECT c.[name], c.id FROM {photo_category} AS c"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.cat_id=c.id AND a.module_name='photo'" : "")
					." WHERE c.[act]='1' AND c.trash='0' AND c.site_id=%d"
					." AND (c.sort>%d OR c.sort=%d AND c.id>%d) AND c.parent_id=%d"
					." AND (c.access='0'"
					.($this->diafan->_user->id ? " OR c.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")"
					." ORDER BY c.sort ASC, c.id ASC LIMIT 1",
					$this->diafan->cid, $row["sort"], $row["sort"], $this->diafan->cat, $row["parent_id"]
				));
			if ($next)
			{
				$this->result["next"]["text"] = $next["name"];
				$this->result["next"]["id"]   = $next["id"];
				$this->result["next"]["link"] = $this->diafan->_route->link($this->diafan->cid, "photo", $next["id"]);
			}

			//сохранение кеша
			$this->diafan->_cache->save($this->result, $cache_meta, $this->diafan->module);
		}

		$text = DB::query_result("SELECT [text] FROM {photo_category} WHERE id=%d", $this->diafan->cat);
		$this->result["text"] = $this->diafan->_useradmin->get($text, 'text', $this->diafan->cat, 'photo_category', _LANG);

		$this->result["comments"] = $this->diafan->_comments->get(0, '', 0, true);
		$this->result["rating"] = $this->diafan->_rating->get(0, '', 0, true);

		if ($this->result["rows"])
		{
			foreach ($this->result["rows"] as $i => $row)
			{
				$this->result["rows"][$i]["tags"] = $this->diafan->_tags->get($row["id"]);

				$this->result["rows"][$i]["rating"] = $this->diafan->_rating->get($row["id"]);

				$this->result["rows"][$i]["name"] = $this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'photo', _LANG);
				$this->result["rows"][$i]["anons"] = $this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'photo',  _LANG);
			}
			if (! empty($this->result["previous"]["text"]))
			{
				$this->result["previous"]["text"] =
					$this->diafan->_useradmin->get($this->result["previous"]["text"], 'name', $this->result["previous"]["id"], 'photo_category', _LANG);
			}
			if (! empty($this->result["next"]["text"]))
			{
				$this->result["next"]["text"] =
					$this->diafan->_useradmin->get($this->result["next"]["text"], 'name', $this->result["next"]["id"], 'photo_category', _LANG);
			}
			foreach ($this->result["children"] as $i => $row)
			{
				$this->result["children"][$i]["name"] = $this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'photo_category', _LANG);
				$this->result["children"][$i]["anons"] = $this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'photo_category', _LANG);
			}
			foreach ($this->result["path"] as $k => $path)
			{
				if ($k == 0)
					continue;
				$this->result["path"][$k]["name"] = $this->diafan->_useradmin->get($path["name"], 'name', $path["id"], 'photo_category', _LANG);
			}
		}
		$this->result["paginator"] = $this->diafan->_tpl->get('get', 'paginator', $this->result["paginator"]);
		return $this->result;
	}

	/**
	 * Генерирует данные для страницы фотографии
	 * 
	 * @return array|boolean false
	 */
	public function id()
	{
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		//кеширование
		$cache_meta = array(
				"name"     => "show",
				"cat_id"   => $this->diafan->cat,
				"show"     => $this->diafan->show,
				"lang_id" => _LANG,
				"site_id"  => $this->diafan->cid,
				"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0,
				"time"     => $time
			);
		if (! $this->result = $this->diafan->_cache->get($cache_meta, $this->diafan->module))
		{
			$row = DB::fetch_array(DB::query("SELECT id, [name], timeedit, cat_id, [keywords], [descr], sort, [title_meta], access, theme, view FROM {photo}"
			." WHERE [act]='1' AND id = %d AND trash='0' AND site_id=%d"
			." AND date_start<=%d AND (date_finish=0 OR date_finish>=%d)",
			$this->diafan->show, $this->diafan->cid, $time, $time));
			if (empty($row))
			{
				include ABSOLUTE_PATH.'includes/404.php';
				return false;
			}

			if (! $this->diafan->rewrite_module && ($this->diafan->configmodules("cat") && $this->diafan->cat != $row["cat_id"]
			  || ! $this->diafan->configmodules("cat") && $this->diafan->cat))
			{
				include ABSOLUTE_PATH.'includes/404.php';
				return false;
			}
			if (!empty($row['access']) && !$this->access($row['id']))
			{
				include ABSOLUTE_PATH . 'includes/403.php';
			}

			if($row["theme"])
			{
				$this->result["theme"] = $row["theme"];
			}
			elseif($this->diafan->configmodules("theme_id"))
			{
				$this->result["theme"] = $this->diafan->configmodules("theme_id");
			}

			if($row["view"])
			{
				$this->result["view"] = $row["view"];
			}
			elseif($this->diafan->configmodules("view_id"))
			{
				$this->result["view"] = $this->diafan->configmodules("view_id");
			}
			else
			{
				$this->result["view"] = 'id';
			}
			$this->result["id"]     = $this->diafan->show;
			$this->diafan->cat      = $this->diafan->configmodules("cat") ? $row["cat_id"] : 0;
			$this->result["cat_id"] = $this->diafan->configmodules("cat") ? $row["cat_id"] : 0;

			$images = $this->diafan->_images->get(
					'large', $row["id"], $this->diafan->module,
					$this->diafan->cid, $row["name"], false, 1
				);
			$this->result["img"]    = $images[0];

			$previous = DB::fetch_array(DB::query(
			"SELECT e.[name], e.id, e.cat_id FROM {photo} AS e"
			.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='photo'" : "")
			." WHERE e.[act]='1' AND e.trash='0' AND e.site_id=%d"
			.($this->diafan->configmodules("cat") ? " AND e.cat_id='" . $this->diafan->cat . "'" : '')
			." AND (e.sort<%d OR e.sort=%d AND e.id<%d)"
			." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
			." AND (e.access='0'"
			.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
			.")"
			." ORDER BY e.sort DESC, e.id DESC LIMIT 1",
			$this->diafan->cid, $row["sort"], $row["sort"], $this->diafan->show, $time, $time
			));
			if ($previous)
			{
				$this->result["previous"]["text"] = $previous["name"];
				if (! $this->diafan->configmodules("cat"))
				{
					$previous["cat_id"] = 0;
				}
				$this->result["previous"]["id"]   = $previous["id"];
				$this->result["previous"]["link"] = $this->diafan->_route->link($this->diafan->cid, "photo", $previous["cat_id"], $previous["id"]);
			}
			$next = DB::fetch_array(DB::query(
			"SELECT e.[name], e.id, e.cat_id FROM {photo} AS e"
			.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='photo'" : "")
			." WHERE e.[act]='1' AND e.trash='0' AND e.site_id=%d"
			.($this->diafan->configmodules("cat") ? " AND e.cat_id='" . $this->diafan->cat . "'" : '')
			." AND (e.sort>%d OR e.sort=%d AND e.id>%d)"
			." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
			." AND (e.access='0'"
			.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
			.")"
			." ORDER BY e.sort ASC, e.id ASC LIMIT 1",
			$this->diafan->cid, $row["sort"], $row["sort"], $this->diafan->show, $time, $time
			));
			if ($next)
			{
				$this->result["next"]["text"] = $next["name"];
				if (! $this->diafan->configmodules("cat"))
				{
					$next["cat_id"] = 0;
				}
				$this->result["next"]["id"]   = $next["id"];
				$this->result["next"]["link"] = $this->diafan->_route->link($this->diafan->cid, "photo", $next["cat_id"], $next["id"]);
			}

			$this->result["titlemodule"] = $row["name"];
			$this->result["edit_meta"]   = array("id" => $row["id"], "table" => "photo");
			$this->result["title_meta"]  = $row["title_meta"];
			$this->result["timeedit"]    = $row["timeedit"];

			$this->result["keywords"]    = $row["keywords"];
			$this->result["descr"]       = $row["descr"];
			
			$this->result["path"] = $this->get_path('photo');

			//сохранение кеша
			$this->diafan->_cache->save($this->result, $cache_meta, $this->diafan->module);
		}
		$this->diafan->cat = $this->result["cat_id"];

		$row = DB::fetch_array(DB::query("SELECT [text], [anons] FROM {photo} WHERE id=%d", $this->diafan->show));
		$this->result["text"]  = $this->diafan->_useradmin->get($row["text"], 'text', $this->diafan->show, 'photo', _LANG);
		$this->result["anons"] = $this->diafan->_useradmin->get($row["anons"], 'anons', $this->diafan->show, 'photo', _LANG);

		if (! empty($this->result["previous"]["text"]))
		{
			$this->result["previous"]["text"] =
				$this->diafan->_useradmin->get($this->result["previous"]["text"], 'name', $this->result["previous"]["id"], 'photo', _LANG);
		}
		if (! empty($this->result["next"]["text"]))
		{
			$this->result["next"]["text"] =
				$this->diafan->_useradmin->get($this->result["next"]["text"], 'name', $this->result["next"]["id"], 'photo', _LANG);
		}
		foreach ($this->result["path"] as $k => $path)
		{
			if ($k == 0)
				continue;
			$this->result["path"][$k]["name"] = $this->diafan->_useradmin->get($path["name"], 'name', $path["id"], 'photo_category', _LANG);
		}

		$this->result["rating"] = $this->diafan->_rating->get();
		$this->result["comments"] = $this->diafan->_comments->get();
		$this->result["tags"] = $this->diafan->_tags->get();

		if (! empty($_SERVER["HTTP_X_REQUESTED_WITH"]) && ! empty($_POST["module_ajax"]) && $_POST["module_ajax"] == "photo")
		{
			header('Content-Type: text/html; charset=utf-8');
			$this->result["ajax"] = true;
			$this->diafan->_tpl->get('id', 'photo', $this->result);
			exit;
		}

		return $this->result;
	}

	/**
	 * Генерирует данные для шаблонной функции: блок фотографий
	 *
	 * @param integer $count количество фотографий
	 * @param integer $cat_id категория
	 * @param string $sort сортировка date - по дате, rand - случайно
	 * @param integer $site_id страница сайта
	 * @param string $images_variation размер изображений
	 * @return array
	 */
	public function show_block($count, $cat_id, $sort, $site_id, $images_variation)
	{
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		//кеширование
		$cache_meta = array(
				"name"     => "block",
				"cat_id"   => $cat_id,
				"count"    => $count,
				"lang_id" => _LANG,
				"site_id"  => $site_id,
				"images_variation" => $images_variation,
				"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0,
				"time"     => $time
			);

		if ($sort == "rand" || ! $this->result = $this->diafan->_cache->get($cache_meta, "photo"))
		{
			if ( ! $site_id && $cat_id)
			{
				$site_id = DB::query_result("SELECT site_id FROM {photo_category} WHERE id=%d", $cat_id);
			}
			if (!$site_id)
			{
				$site_id = DB::query_result(
						"SELECT s.id FROM {site} AS s"
						.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=s.id AND a.module_name='site'" : "")
						." WHERE s.module_name='photo' AND s.trash='0' AND s.[act]='1' AND s.block='0'"
						." AND (s.access='0'"
						.($this->diafan->_user->id ? " OR s.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
						.") LIMIT 1"
					);
			}
			else
			{
				if(DB::query_result("SELECT access FROM {site} WHERE id=%d", $site_id))
				{
					if(! $this->access($site_id, 0, "site"))
					{
						return false;
					}
				}
			}
			if(! $site_id)
			{
				return false;
			}
			if ($cat_id && $this->diafan->configmodules("cat", "photo", $site_id))
			{
				if(DB::query_result("SELECT access FROM {photo_category} WHERE id=%d", $cat_id))
				{
					if(! $this->access(0, $cat_id, "photo"))
					{
						return false;
					}
				}
				if ($this->diafan->configmodules("childrens_elements", "photo", $site_id))
				{ 
					$children = $this->diafan->get_children($cat_id, "photo_category");
				}
				$children[] = $cat_id;
			}

			if ($sort == "rand")
			{
				$max_count = DB::query_result(
				"SELECT COUNT(DISTINCT e.id) FROM {photo} as e"
				.($cat_id && $this->diafan->configmodules("cat", "photo", $site_id)
				  ? " INNER JOIN {photo_category_rel} as c ON c.element_id=e.id"
					." AND c.cat_id IN (".implode(',', $children).")"
				  : ''
				 )
				.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='photo'" : "")
				." WHERE e.[act]='1' AND e.trash='0'"
				.($site_id ? " AND e.site_id=".$site_id : '')
				." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
				." AND (e.access='0'"
				.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
				.")", $time, $time
				);
				$rands = array();
				for ($i = 1; $i <= min($max_count, $count); $i++)
				{
					do
					{
						$rand = mt_rand(0, $max_count - 1);
					}
					while (in_array($rand, $rands));
					$rands[] = $rand;
				}
			}
			else
			{
				$rands[0] = 1;
			}
			$this->result["rows"] = array();

			switch($sort)
			{
				case 'date':
					$order = ' ORDER BY e.id DESC';
					break;

				case 'rand':
					$order = '';
					break;

				default:
					$order = ' ORDER BY e.sort ASC';
			}

			foreach ($rands as $rand)
			{
				$result = DB::query_range(
				"SELECT e.id, e.[name],e.[anons], e.cat_id, e.timeedit, e.site_id FROM {photo} AS e"
				.($cat_id && $this->diafan->configmodules("cat", "photo", $site_id)
				? " INNER JOIN {photo_category_rel} as r ON r.element_id=e.id"
					." AND r.cat_id IN (" . implode(',', $children) . ")" 
				: ''
				)
				.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='photo'" : "")
				." WHERE e.[act]='1' AND e.trash='0'"
				.($site_id ? " AND e.site_id=" . $site_id : '')
				." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
				." AND (e.access='0'"
				.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
				.")"
				." GROUP BY e.id"
				.$order,
				$time, $time,
				$sort == "rand" ? $rand : 0,
				$sort == "rand" ? 1     : $count
				);
				$this->result["rows"] = array_merge($this->result["rows"], $this->get_elements($result, $images_variation));
			}

			if (! empty($this->result["rows"]) && $cat_id && $this->diafan->configmodules("cat", "photo", $site_id))
			{
				$cat = DB::fetch_array(DB::query("SELECT [name], site_id, id FROM {photo_category} WHERE id=%d", $cat_id));
				
				$this->result["name"] = $cat["name"];
				$this->result["link_all"] = $this->diafan->_route->link($cat["site_id"], 'photo', $cat["id"]);
				$this->result["category"] = true;
			}
			elseif (! empty($this->result["rows"]) && $site_id)
			{
				$this->result["name"] = DB::query_result("SELECT [name] FROM {site} WHERE id=%d", $site_id);
				$this->result["link_all"] = $this->diafan->_route->link($site_id);
				$this->result["category"] = false;
			}
			//сохранение кеша
			if ($sort != "rand")
			{
				$this->diafan->_cache->save($this->result, $cache_meta, "photo");
			}
		}

		if ($this->result["rows"])
		{
			foreach ($this->result["rows"] as $i => $row)
			{
				$this->result["rows"][$i]["name"] = $this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'photo', _LANG);
				$this->result["rows"][$i]["anons"] = $this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'photo', _LANG);
			}
		}

		return $this->result;
	}

	/**
	 * Генерирует данные для шаблонной функции: блок связанных фотографий
	 * 
	 * @param integer $count количество фотографий
	 * @param string $images_variation размер изображений
	 * @return array
	 */
	public function show_block_rel($count, $images_variation)
	{
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		//кеширование
		$cache_meta = array(
			"name" => "block_rel",
			"count" => $count,
			"lang_id" => _LANG,
			"element_id" => $this->diafan->show,
			"images_variation" => $images_variation,
			"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0,
			"time" => $time
		);

		if (! $this->result = $this->diafan->_cache->get($cache_meta, "photo"))
		{
			$this->result["rows"] = array();

			$result = DB::query_range(
			"SELECT e.id, e.[name], e.[anons], e.cat_id, e.timeedit, e.site_id FROM {photo} AS e"
			. " INNER JOIN {photo_rel} AS r ON e.id=r.rel_element_id AND r.element_id=%d"
			.($this->diafan->configmodules("rel_two_sided") ? " OR e.id=r.element_id AND r.rel_element_id=".$this->diafan->show : '')
			. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='photo'" : "")
			. " WHERE e.[act]='1' AND e.trash='0'"
			." AND e.date_start<=%d AND (e.date_finish=0 OR e.date_finish>=%d)"
			. " AND (e.access='0'"
			. ($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=" . $this->diafan->_user->role_id : '')
			. ")"
			. " GROUP BY e.id"
			. ' ORDER BY e.sort ASC',
			$this->diafan->show, $time, $time, 0, $count
			);
			$this->result["rows"] = $this->get_elements($result, $images_variation);
			$this->diafan->_cache->save($this->result, $cache_meta, "photo");
		}

		if ($this->result["rows"])
		{
			foreach ($this->result["rows"] as $i => $row)
			{
				$this->result["rows"][$i]["name"] = $this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'photo', _LANG);

				$this->result["rows"][$i]["anons"] = $this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'photo', _LANG);
			}
		}
		return $this->result;
	}

	/**
	 * Форматирует данные о фотографии для списка фотографий
	 *
	 * @param resource $result результат выполнения SQL-запроса
	 * @param string $images_variation размер изображений
	 * @return array
	 */
	public function get_elements($result, $images_variation = 'medium')
	{
		if (empty($this->result["timeedit"]))
		{
			$this->result["timeedit"] = '';
		}
		$rows = array();
		while ($row = DB::fetch_array($result))
		{
			if (! $this->diafan->configmodules("cat", "photo", $row["site_id"]))
			{
				$row["cat_id"] = 0;
			}
			if ($row["timeedit"] < $this->result["timeedit"])
			{
				$this->result["timeedit"] = $row["timeedit"];
			}
			unset($row["timeedit"]);

			if ($this->diafan->configmodules('page_show', 'photo', $row["site_id"]))
			{
				$row["link"] = $this->diafan->_route->link($row["site_id"], "photo", $row["cat_id"], $row["id"]);
			}
			else
			{
				$row["link"] = 'large';
			}
			$images  = $this->diafan->_images->get(
					$images_variation, $row["id"], 'photo',
					$row["site_id"], $row["name"], false,
					1,
					$row["link"]
				);
			unset($row["cat_id"]);

			$row["img"] = $images ? $images[0] : '';

			$rows[] = $row;
		}
		return $rows;
	}
}