<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.1
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Shop_admin_config
 *
 * Конфигурация магазина
 */
class Shop_admin_config extends Frame_admin
{
	/**
	 * @var array поля в базе данных для редактирования
	 */
	public $variables = array (
		'base' => array (
			'not_buy' => array(
				'type' => 'checkbox',
				'name' => 'Запретить покупать товары',
				'help' => 'Если отмечена, на сайте будет запрещена корзина, а у товаров не будет кнопки "Купить"',
			),
			'security_user' => array(
				'type' => 'checkbox',
				'name' => 'Покупать могут только зарегистрированные',
				'help' => 'Если отмечена, кнопка купить будет появляться только при авторизации пользователями на сайте. Для неавторизованных кнопка "Купить" у товаров будет недоступна.',
			),
			'hr1' => 'hr',
			'nastr' => array(
				'type' => 'numtext',
				'name' => 'Количество товаров на странице',
			),
			'hr2' => 'hr',
			'use_non_material_goods' => array(
				'type' => 'checkbox',
				'name' => 'Включить возможность продажи файлов',
				'help' => 'Если отмечена, возможно продавать файлы. Тогда к каждому товару можно прикреплять файл, который будет храниться в защищенном месте и после оплаты пользователем доступен по уникальной ссылке, живущей час.',
			),
			'attachment_extensions' => array(
				'type' => 'text',
				'name' => 'Доступные типы файлов (через запятую)',
			),
			'attachments_access_admin' => array(
				'type' => 'none',
			),
			'hr3' => 'hr',
			'use_count_goods' => array(
				'type' => 'checkbox',
				'name' => 'Учитывать остатки товаров на складе',
				'help' => 'Если отмечена, у каждого товара появится поле с количеством товара и необходимо будет указывать количество товара на складе. Товар с остатком 0 нельзя купить, кнопка "Купить" будет заменена на сообщение "Товар отсутствует". При покупке товара и и выполнении заказа (статус заказа с товаром "Выполнен") количество будет отминусовываться.',
			),
			'order_redirect' => array(
				'type' => 'text',
				'name' => 'Страница окончания оформления заказа',
				'help' => 'Страница, на которую перекидывает покупателя после успешного оформления заказа',
			),
			'hr4' => 'hr',
			'cat' => array(
				'type' => 'checkbox',
				'name' => 'Использовать категории',
			),
			'count_list' => array(
				'type' => 'numtext',
				'name' => 'Количество товаров в списке категорий',
				'help' => 'Для первой страницы магазина, где выходят по несколько товаров из всех категорий.',
			),
			'childrens_elements' => array(
				'type' => 'checkbox',
				'name' => 'Показывать товары подкатегорий',
				'help' => 'Для списков товара, если перейти в категорию имеющую подкатегории. Если не отмечена, в категории будет просто список подкатегорий. Если отмечена, в категории будут показаны товары из вложенных подкатегорий.',
			),
			'hr5' => 'hr',
			'currency' => array(
				'type' => 'text',
				'name' => 'Валюта',
				'help' => 'Название основной валюты сайта. Для добавления дополнительных валют, воспользуйтесь модулем "Оплата"',
				'multilang' => true,
			),
			'format_price' => array(
				'type' => 'function',
				'name' => 'Формат цены',
			),
			'format_price_1' => array(
				'type' => 'none',
			),
			'format_price_2' => array(
				'type' => 'none',
			),
			'format_price_3' => array(
				'type' => 'none',
			),
			'hr6' => 'hr',
			'search_price' => array(
				'type' => 'checkbox',
				'name' => 'Искать по цене',
			),
			'search_text' => array(
				'type' => 'checkbox',
				'name' => 'Искать по описанию',
			),
			'search_name' => array(
				'type' => 'checkbox',
				'name' => 'Искать по названию',
			),
			'search_article' => array(
				'type' => 'checkbox',
				'name' => 'Искать по артикулу',
			),
			'hr7' => 'hr',
			'comments' => array(
				'type' => 'module',
				'name' => 'Показывать комментарии к товарам',
			),
			'tags' => array(
				'type' => 'module',
				'name' => 'Подключить теги',
			),
			'rating' => array(
				'type' => 'module',
				'name' => 'Показывать рейтинг товаров',
			),
			'rel_two_sided' => array(
				'type' => 'checkbox',
				'name' => 'В блоке похожих товаров связь двусторонняя',
			),
			'hr8' => 'hr',
			'themes' => array(
				'type' => 'function',
			),
			'theme_list' => array(
				'type' => 'none',
				'name' => 'Шаблон для списка элементов',
				'help' => 'Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_list' => array(
				'type' => 'none',
			),
			'theme_first_page' => array(
				'type' => 'none',
				'name' => 'Шаблон для первой страницы модуля (если подключены категории)',
				'help' => 'Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_first_page' => array(
				'type' => 'none',
			),
			'theme_id' => array(
				'type' => 'none',
				'name' => 'Шаблон для страницы элемента',
				'help' => 'Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_id' => array(
				'type' => 'none',
			),
			'theme_list_param' => array(
				'type' => 'none',
				'name' => 'Шаблон для списка элементов с одинаковой характеристикой',
				'help' => 'Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_list_param' => array(
				'type' => 'none',
			),
			'theme_list_compare' => array(
				'type' => 'none',
				'name' => 'Шаблон для сравнения товаров',
				'help' => 'Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_list_compare' => array(
				'type' => 'none',
			),
			'theme_list_search' => array(
				'type' => 'none',
				'name' => 'Шаблон для поиска элементов',
				'help' => 'Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_list_search' => array(
				'type' => 'none',
			),
			'hr_admin_page' => 'hr',
			'admin_page'     => array(
				'type' => 'checkbox',
				'name' => 'Отдельный пункт в меню администрирования для каждого раздела сайта',
			),
		),
		'images' => array (
			'images' => array(
				'type' => 'module',
				'name' => 'Использовать изображения',
			),
		),
		'yandex_shop' => array (
			'yandex' => array(
				'type' => 'checkbox',
				'name' => 'Подключить Яндекс Маркет',
			),
			'nameshop' => array(
				'type' => 'text',
				'name' => 'Короткое название магазина',
			),
			'currencyyandex' => array(
				'type' => 'function',
				'name' => 'Валюта',
			),
			'currencyratesel' => array(
				'type' => 'none',
				'name' => 'Курс к рублю',
			),
			'currencyrate' => array(
				'type' => 'none',
			),
			'show_yandex_category' => array(
				'type' => 'select',
				'name' => 'Выгружать категории в Яндекс.Маркет',
			),
			'show_yandex_element' => array(
				'type' => 'select',
				'name' => 'Выгружать товары в Яндекс.Маркет',
			),
			'bid' => array(
				'type' => 'numtext',
				'name' => 'Основная ставка',
			),
			'cbid' => array(
				'type' => 'numtext',
				'name' => 'Ставка для карточек',
			),
		),
		'send_mails' => array (
			'emailconf' => array(
				'type' => 'function',
				'name' => 'E-mail, указываемый в обратном адресе пользователю',
			),
			'email' => array(
				'type' => 'none',
				'name' => 'впишите e-mail',
			),
			'hr7' => 'hr',
			'subject_waitlist' => array(
				'type' => 'text',
				'name' => 'Тема письма пользователю о поступлении товара',
				'multilang' => true,
			),
			'message_waitlist' => array(
				'type' => 'textarea',
				'name' => 'Сообщение пользователю о поступлении товара',
				'multilang' => true,
			),
			'hr8' => 'hr',
			'mes' => array(
				'type' => 'textarea',
				'name' => 'Сообщение о совершенном заказе',
				'multilang' => true,
			),
			'desc_order' => array(
				'type' => 'text',
				'name' => 'Описание платежа',
				'multilang' => true,
			),
			'payment_success_text' => array(
				'type' => 'textarea',
				'name' => 'Платеж успешно принят',
			),
			'payment_fail_text' => array(
				'type' => 'textarea',
				'name' => 'Платеж не принят',
			),
			'hr9' => 'hr',
			'subject' => array(
				'type' => 'text',
				'name' => 'Тема письма пользователю о новом заказе',
				'multilang' => true,
			),
			'message' => array(
				'type' => 'textarea',
				'name' => 'Сообщение пользователю о новом заказе',
				'multilang' => true,
			),
			'subject_change_status' => array(
				'type' => 'text',
				'name' => 'Тема письма пользователю об изменении статуса заказа',
				'multilang' => true,
			),
			'message_change_status' => array(
				'type' => 'textarea',
				'name' => 'Сообщение пользователю об изменении статуса заказа',
				'multilang' => true,
			),
			'hr10' => 'hr',
			'subject_admin' => array(
				'type' => 'text',
				'name' => 'Тема письма администратору о новом заказе',
			),
			'message_admin' => array(
				'type' => 'textarea',
				'name' => 'Текст письма администратору о новом заказе',
			),
			'emailconfadmin' => array(
				'type' => 'function',
				'name' => 'E-mail для уведомлений администратора',
			),
			'email_admin' => array(
				'type' => 'none',
				'name' => 'впишите e-mail',
			),
			'hr11' => 'hr',
			'file_sale_message' => array(
				'type' => 'textarea',
				'name' => 'Сообщение пользователю о купленных файлах',
			),
		),
	);

	/**
	 * @var array названия табов
	 */
	public $tabs_name = array(
		'base' => 'Основные настройки',
		'images' => 'Изображения',
		'yandex_shop' => 'Яндекс Маркет',
		'send_mails' => 'Сообщения и уведомления',
	);

	/**
	 * @var array настройки модуля
	 */
	public $config = array (
		'tab_card', 
		'element_site', // делит элементы по разделам (страницы сайта, к которым прикреплен модуль)
		'config', // файл настроек модуля
	);

	/**
	 * @var array зависимости между полями
	 */
	public $show_tr_click_checkbox = array(
		'cat' => array(
			'count_list',
		),
		'yandex' => array(
			'nameshop',
			'currencyyandex',
			'bid',
			'cbid',
			'show_yandex_category',
			'show_yandex_element',
		),
		'use_non_material_goods' => array(
			'attachment_extensions',
		),
	);

	/**
	 * @var array значения списков
	 */
	public $select_arr = array(
		'currencyyandex' => array(
			'RUR' => 'RUR',
			'USD' => 'USD',
			'EUR' => 'EUR',
			'UAH' => 'UAH',
		),
		'show_yandex_category' => array(
			0 => 'все',
			1 => 'только помеченные',
		),
		'show_yandex_element' => array(
			0 => 'все',
			1 => 'только помеченные',
		),
		'currencyratesel' => array(
			1 => 'свой курс',
			2 => 'ЦБ РФ',
			3 => 'ЦБ РФ+%:',
		),
	);

	/**
	 * Редактирование поля "Формат цены"
	 * 
	 * @return void
	 */
	function edit_config_variable_format_price()
	{
		echo '
		<tr>
			<td class="td_first">' . $this->diafan->variable_name() . '</td>
			<td>
				'
		. sprintf(
				$this->diafan->_('количество знаков после запятой: %s разделитель целых: %s разделитель десятков: %s'), '<input type="text" name="format_price_1" size="2" value="' . $this->diafan->values["format_price_1"] . '" class="inpnum">'
				. '<br>', '<input type="text" name="format_price_2" size="2" value="' . $this->diafan->values["format_price_2"] . '">'
				. '<br>', '<input type="text" name="format_price_3" size="2" value="' . $this->diafan->values["format_price_3"] . '">'
		)
		. $this->diafan->help() . '
			</td>
		</tr>';
	}

	/**
	 * Редактирование поля "Валюта для Яндекс.Маркета"
	 * 
	 * @return void
	 */
	public function edit_config_variable_currencyyandex()
	{
		echo '
		<tr valign="top">
			<td class="td_first">' . $this->diafan->variable_name() . '</td>
			<td>
				<select name="' . $this->diafan->key . '">
					' . $this->diafan->select_option($this->diafan->key, '', '', '', $this->diafan->value) . '
				</select>
				<div class="currencyratesel">
					<br>
					<select name="currencyratesel">
						' . $this->diafan->select_option('currencyratesel', '', '', '', $this->diafan->values['currencyratesel']) . '
					</select>
					<div class="currencyrate">
						<br>
						<input type="text" name="currencyrate" size="20" value="' . $this->diafan->values["currencyrate"] . '">
						' . $this->diafan->variable_name("currencyrate") . '
					</div>
				</div>';
		?>
		<script language="javascript" type="text/javascript">
			$(document).ready(function() {
				$("select[name=currencyyandex]").change(function(){
					show_currency($(this));
				});
				$("select[name=currencyratesel]").change(function(){
					show_currencysel($(this));
				});
					
				show_currency($("select[name=currencyyandex]"));
				show_currencysel();
								
				function show_currency(th)
				{
					if (th && th.val() == 'RUR')
					{
						$(".currencyratesel").hide();
					}
					else
					{
						$(".currencyratesel").show();
					}
				}
				function show_currencysel(th)
				{
					if (th && th.val() == '2')
					{
						$(".currencyrate").hide();
					}
					else
					{
						$(".currencyrate").show();
					}
				}
			});
		</script>
		<?php

		echo $this->diafan->help() . '
			</td>
		</tr>';
	}

	/**
	 * Выводит вкладку "Название магазина для Яндекс.Маркета"
	 * 
	 * @return void
	 */
	public function edit_config_variable_nameshop()
	{
		echo '
		<tr>
			<td class="td_first">' . $this->diafan->variable_name() . '</td>
			<td>
				<input type="text" name="' . $this->diafan->key . '" size="40" value="'
		. (!$this->diafan->addnew ? str_replace('"', '&quot;', $this->diafan->value) : '')
		. '" maxlength="20" class="inp_maxlength"> <span class="maxlength">' . (20 - utf::strlen($this->diafan->value)) . '</span>
				' . $this->diafan->help() . '
			</td>
		</tr>';
	}
	
	public function edit_config_variable_order_redirect()
	{
		echo '
			<script type="text/javascript" src="'.BASE_PATH.'modules/shop/admin/shop.admin.config.js"></script>
			<tr id="order_redirect">
				<td class="td_first">'.$this->diafan->variable_name().'</td>
				<td>';
		if(preg_match("/^[0-9]+$/", $this->diafan->value))
		{
			$value = $this->diafan->value;
		}
		else
		{
			$value = DB::query_result("SELECT site_id FROM {rewrite} WHERE rewrite='%h' AND module_name='site'", $this->diafan->value);
		}
		$name = DB::query_result("SELECT [name] FROM {site} WHERE [act]='1' AND trash='0' AND id=%d", $value);

		if($name)
		{
			echo '<a href="'.BASE_PATH_HREF.'site/edit'.$value.'/" class="menu_base_link">'.$name.'</a>';
		}
		echo ' <a href="javascript:void(0)"><img src="'.BASE_PATH.'adm/img/edit.gif" width="12" height="14" alt="'.$this->diafan->_('Редактировать').'" class="order_redirect_select"></a>';

		echo $this->diafan->help().'
			<input name="order_redirect" value="'.$value.'" type="hidden">
			<div id="inline" class="hide"></div>
			</td>
		</tr>';
	}

	/**
	 * Редактирование поля "Шаблон страницы для разных ситуаций"
	 * @return void
	 */
	public function edit_config_variable_themes()
	{
		$themes = array();
		if ($dir = opendir(ABSOLUTE_PATH."themes"))
		{
			while (($file = readdir($dir)) !== false)
			{
				if ($file != '.' && $file != '..' && $file != 'site.php')
				{
					$themes[] = $file;
				}
			}
		}
		arsort($themes);
		closedir($dir);

		$views = array();
		if ($dir = opendir(ABSOLUTE_PATH."modules/".$this->diafan->module."/views"))
		{
			while (($file = readdir($dir)) !== false)
			{
				if ($file != '.' && $file != '..')
				{
					if(! preg_match('/'.$this->diafan->module.'\.view\.([^\.]+)\.php/', $file, $match))
						continue;
					$views[$match[1]] = $file;
				}
			}
		}
		closedir($dir);

		echo '<tr>
			<td class="td_first">
				'.$this->diafan->variable_name("theme_list").'
			</td>
			<td>
				<select name="theme_list">
					<option value="">site.php</option>';
				foreach ($themes as $theme)
				{
					echo '<option value="'.$theme.'"'.($this->diafan->values["theme_list"] == $theme ? ' selected' : '').'>'.$theme.'</option>';
				}
				echo '
				</select>
				<select name="view_list">
					<option value="">'.$this->diafan->module.'.view.list.php</option>';
				foreach ($views as $key => $view)
				{
					if($view == $this->diafan->module.".view.list.php")
						continue;
					echo '<option value="'.$key.'"'.($this->diafan->values["view_list"] == $key ? ' selected' : '').'>'.$view.'</option>';
				}
				echo '
				</select>
				'.$this->diafan->help("theme_list").'
			</td>
		</tr>

		<tr>
			<td class="td_first">
				'.$this->diafan->variable_name("theme_first_page").'
			</td>
			<td>
				<select name="theme_first_page">
					<option value="">site.php</option>';
				foreach ($themes as $theme)
				{
					echo '<option value="'.$theme.'"'.($this->diafan->values["theme_first_page"] == $theme ? ' selected' : '').'>'.$theme.'</option>';
				}
				echo '
				</select>
				<select name="view_first_page">
					<option value="">'.$this->diafan->module.'.view.first_page.php</option>';
				foreach ($views as $key => $view)
				{
					if($view == $this->diafan->module.".view.first_page.php")
						continue;
					echo '<option value="'.$key.'"'.($this->diafan->values["view_first_page"] == $key ? ' selected' : '').'>'.$view.'</option>';
				}
				echo '
				</select>
				'.$this->diafan->help("theme_first_page").'
			</td>
		</tr>

		<tr>
			<td class="td_first">
				'.$this->diafan->variable_name("theme_id").'
			</td>
			<td>
				<select name="theme_id">
					<option value="">site.php</option>';
				foreach ($themes as $theme)
				{
					echo '<option value="'.$theme.'"'.($this->diafan->values["theme_id"] == $theme ? ' selected' : '').'>'.$theme.'</option>';
				}
				echo '
				</select>
				<select name="view_id">
					<option value="">'.$this->diafan->module.'.view.id.php</option>';
				foreach ($views as $key => $view)
				{
					if($view == $this->diafan->module.".view.id.php")
						continue;
					echo '<option value="'.$key.'"'.($this->diafan->values["view_id"] == $key ? ' selected' : '').'>'.$view.'</option>';
				}
				echo '
				</select>
				'.$this->diafan->help("theme_id").'
			</td>
		</tr>
		
		<tr>
			<td class="td_first">
				'.$this->diafan->variable_name("theme_list_param").'
			</td>
			<td>
				<select name="theme_list_param">
					<option value="">site.php</option>';
				foreach ($themes as $theme)
				{
					echo '<option value="'.$theme.'"'.($this->diafan->values["theme_list_param"] == $theme ? ' selected' : '').'>'.$theme.'</option>';
				}
				echo '
				</select>
				<select name="view_list_param">
					<option value="">'.$this->diafan->module.'.view.list.php</option>';
				foreach ($views as $key => $view)
				{
					if($view == $this->diafan->module.".view.list.php")
						continue;
					echo '<option value="'.$key.'"'.($this->diafan->values["view_list_param"] == $key ? ' selected' : '').'>'.$view.'</option>';
				}
				echo '
				</select>
				'.$this->diafan->help("theme_list_param").'
			</td>
		</tr>
		
		<tr>
			<td class="td_first">
				'.$this->diafan->variable_name("theme_list_search").'
			</td>
			<td>
				<select name="theme_list_search">
					<option value="">site.php</option>';
				foreach ($themes as $theme)
				{
					echo '<option value="'.$theme.'"'.($this->diafan->values["theme_list_search"] == $theme ? ' selected' : '').'>'.$theme.'</option>';
				}
				echo '
				</select>
				<select name="view_list_search">
					<option value="">'.$this->diafan->module.'.view.list.php</option>';
				foreach ($views as $key => $view)
				{
					if($view == $this->diafan->module.".view.list.php")
						continue;
					echo '<option value="'.$key.'"'.($this->diafan->values["view_list_search"] == $key ? ' selected' : '').'>'.$view.'</option>';
				}
				echo '
				</select>
				'.$this->diafan->help("theme_list_search").'
			</td>
		</tr>
		
		<tr>
			<td class="td_first">
				'.$this->diafan->variable_name("theme_list_compare").'
			</td>
			<td>
				<select name="theme_list_compare">
					<option value="">site.php</option>';
				foreach ($themes as $theme)
				{
					echo '<option value="'.$theme.'"'.($this->diafan->values["theme_list_compare"] == $theme ? ' selected' : '').'>'.$theme.'</option>';
				}
				echo '
				</select>
				<select name="view_list_compare">
					<option value="">'.$this->diafan->module.'.view.compare.php</option>';
				foreach ($views as $key => $view)
				{
					if($view == $this->diafan->module.".view.list_compare.php")
						continue;
					echo '<option value="'.$key.'"'.($this->diafan->values["view_list_compare"] == $key ? ' selected' : '').'>'.$view.'</option>';
				}
				echo '
				</select>
				'.$this->diafan->help("theme_list_compare").'
			</td>
		</tr>';
	}

	/**
	 * Сохранение поля "Валюта"
	 * 
	 * @return void
	 */
	public function save_config_variable_currency()
	{
		$this->diafan->set_query("currency='%s'");
		$this->diafan->set_value($_POST["currency"]);
	}
}