<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.1
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN')) {
    include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Shop_admin_delivery
 *
 * Способы доставки
 */
class Shop_admin_delivery extends Frame_admin
{
    /**
     * @var string таблица в базе данных
     */
    public $table = 'shop_delivery';

	/**
	 * @var array поля в базе данных для редактирования
	 */
	public $variables = array (
		'main' => array (
			'name' => array(
				'type' => 'text',
				'name' => 'Название',
				'multilang' => true,
			),
			'price' => array(
				'type' => 'floattext',
				'name' => 'Стоимость',
			),
			'amount' => array(
				'type' => 'floattext',
				'name' => 'Бесплатно от суммы',
			),
			'act' => array(
				'type' => 'checkbox',
				'name' => 'Показывать на сайте',
				'default' => true,
				'multilang' => true,
			),
			'sort' => array(
				'type' => 'function',
				'name' => 'Сортировка: установить перед',
			),
			'text' => array(
				'type' => 'textarea',
				'name' => 'Описание',
				'multilang' => true,
			),
		),
	);

	/**
	 * @var array настройки модуля
	 */
	public $config = array (
		'del', // удалить
		'act', // показать/скрыть
		'trash', // использовать корзину
		'order', // сортируется
	);

    /**
     * Выводит список способов доставки
     * @return void
     */
    public function show()
	{
        $this->diafan->addnew_init('Добавить');
        $this->diafan->list_row();
    }
}