<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.1
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Update_admin_install
 *
 * Установка/удаление модулей
 */
class Update_admin_install extends Frame_admin
{
	/**
	 * Выводит контент модуля
	 * @return void
	 */
	public function show()
	{
		if(! defined('DEMO_PATH'))
		{
			define('DEMO_PATH', 'http://cms.diafan.ru/files4.2/');
		}
		$rows = $this->get_rows();
		$module_rows = array('news', 'clauses', 'feedback', 'faq', 'shop', 'ads', 'files', 'comments', 'rating',
				     'tags', 'photo', 'votes', 'subscribtion', 'users', 'forum', 'search', 'map');

		foreach ($rows as $k => $v)
		{
			if (! in_array($k, $module_rows))
			{
				$module_rows[] = $k;
			}
		}
		foreach ($module_rows as $k => $val)
		{
			if (!in_array($val, array_keys($rows)))
			{
				unset($module_rows[$k]);
			}
		}

		if ($this->diafan->page == 2)
		{
			echo '<font color="red">'.$this->diafan->_('Все модули установлены!').'</font>';
		}
		echo '<form action="'.$this->diafan->get_admin_url().'save1/" method="POST">
		<p><input type="checkbox" name="example_yes" value="1"> '.$this->diafan->_('Заполнить сайт примерами (может занять время)').'</p>';
		echo '<p>'.$this->diafan->_('Доступны следующие модули для установки/удаления').':</p>
		<input type="hidden" name="check_hash_user" value="'.$this->diafan->_user->get_hash().'">';
		foreach ($module_rows as $row)
		{
			$name  = $rows[$row];
			echo '<p><input type="checkbox" name="'.$row.'" '.(DB::where("modules", "module_name='".$row."'", "id") ? 'checked' : '').'> <b>'.$name.'</b></p>';
			$k = 1;
		}
		echo '<input type="submit" value="'.$this->diafan->_('Установить').'" class="button" onmouseover="this.style.cursor=\'hand\';">';
		echo '
		</form>';
	}

	/**
	 * Установка/удаление модулей
	 * @return void
	 */
	public function save()
	{
		// Прошел ли пользователь проверку идентификационного хэша
		if (! $this->diafan->_user->checked)
		{
			$this->diafan->redirect(URL);
			return;
		}

		$rows = $this->get_rows(false);
		if (! $rows)
		{
			$this->diafan->redirect($this->diafan->get_admin_url('page').'page2/');
		}
		$tables = array();
		$url = parse_url(DB_URL);
		$result = DB::query("SHOW TABLES FROM ".substr($url['path'], 1));
		while ($row = DB::fetch_array($result))
		{
			foreach($row as $r)
			{
				$tables[] = preg_replace('/^'.DB_PREFIX.'/', '', $r);
				continue;
			}
		}

		global $langs;
		$langs = $this->diafan->languages;
		
		define('IS_INSTALL', 1);
		foreach ($rows as $module)
		{
			$ins = DB::where("modules", "module_name='".$module."'", "id");

			if (empty($_POST[$module]) && ! $ins || ! empty($_POST[$module]) && $ins)
				continue;

			include_once ABSOLUTE_PATH."modules/".$module.'/'.$module.".install.php";

			// удаление модуля
			if (empty($_POST[$module]) && $ins)
			{
				$func = 'module_basic_uninstall_'.$module;
				if (function_exists($func))
				{
					$func();
				}
				$this->diafan->_cache->delete('', $module);
				$this->diafan->_cache->delete('', "menu");

				if($module == "users")
					continue;
				
				foreach($tables as $table)
				{
					if(preg_match('/^'.$module.'/', $table))
					{
						DB::query("DROP TABLE {".$table."};");
					}
				}

				$site_ids = DB::query_result("SELECT GROUP_CONCAT(id SEPARATOR ',') FROM {site} WHERE module_name IN (SELECT name FROM {modules} WHERE module_name='".$module."')");
				if ($site_ids)
				{
					DB::query("DELETE FROM {site} WHERE id IN (".$site_ids.")");
					DB::query("DELETE FROM {site_parents} WHERE element_id IN (".$site_ids.")");
					DB::query("DELETE FROM {rewrite} WHERE module_name='site' AND site_id IN (".$site_ids.");");
					$menu_ids = DB::query_result("SELECT GROUP_CONCAT(id SEPARATOR ',') FROM {menu} WHERE site_id IN ('".$site_ids."')");
					if ($menu_ids)
					{
						DB::query("DELETE FROM {menu} WHERE id IN (".$menu_ids.")");
						$menu_child_ids = DB::query_result("SELECT GROUP_CONCAT(element_id SEPARATOR ',') FROM {menu_parents} WHERE parent_id IN (".$menu_ids.")");
						if ($menu_child_ids)
						{
							DB::query("DELETE FROM {menu_parents} WHERE element_id IN (".$menu_child_ids.")");
						}
						DB::query("DELETE FROM {menu_parents} WHERE element_id IN (".$menu_ids.")");
					}
				}
				$menu_ids = DB::query_result("SELECT GROUP_CONCAT(id SEPARATOR ',') FROM {menu} WHERE module_name='".$module."'");
				if ($menu_ids)
				{
					DB::query("DELETE FROM {menu} WHERE id IN (".$menu_ids.")");
					$menu_child_ids = DB::query_result("SELECT GROUP_CONCAT(element_id SEPARATOR ',') FROM {menu_parents} WHERE parent_id IN (".$menu_ids.")");
					if ($menu_child_ids)
					{
						DB::query("DELETE FROM {menu_parents} WHERE element_id IN (".$menu_child_ids.")");
					}
					DB::query("DELETE FROM {menu_parents} WHERE element_id IN (".$menu_ids.")");
				}
				DB::query("DELETE FROM {rewrite} WHERE module_name='".$module."';");
				$result_admin = DB::query("SELECT id FROM {adminsite} WHERE rewrite='".$module."' OR rewrite LIKE '".$module."/%%' AND parent_id=0");
				while($row_admin = DB::fetch_array($result_admin))
				{
					$admin_ids = $this->diafan->get_children($row_admin["id"], "adminsite");
					$admin_ids[] = $row_admin["id"];
					DB::query("DELETE FROM {adminsite} WHERE id IN (".implode(",", $admin_ids).")");
					DB::query("DELETE FROM {adminsite_parents} WHERE element_id IN (".implode(",", $admin_ids).")");
				}
				DB::query("DELETE FROM {users_role_perm} WHERE rewrite='%s' OR rewrite LIKE '%s%%'", $module, $module);
				DB::query("DELETE FROM {config} WHERE module_name='".$module."';");
				DB::query("DELETE FROM {images} WHERE module_name='".$module."';");
				DB::query("DELETE FROM {attachments} WHERE module_name='".$module."';");
				if(! in_array('rating',  $tables))
				{
					DB::query("DELETE FROM {rating} WHERE module_name='".$module."';");
				}
				if(! in_array('comments',  $tables))
				{
					DB::query("DELETE FROM {comments} WHERE module_name='".$module."';");
					DB::query("DELETE FROM {comments} WHERE module_name='".$module."_category';");
				}
				if(! in_array('tags',  $tables))
				{
					DB::query("DELETE FROM {tags} WHERE module_name='".$module."';");
				}
				if(! in_array('log_note',  $tables))
				{
					DB::query("DELETE FROM {log_note} WHERE module_name='".$module."';");
				}
				$trash_ids = DB::query_result("SELECT GROUP_CONCAT(id SEPARATOR ',') FROM {trash} WHERE module_name='".$module."'");
				if ($trash_ids)
				{
					DB::query("DELETE FROM {trash} WHERE id IN (".$trash_ids.")");
					$trash_child_ids = DB::query_result("SELECT GROUP_CONCAT(element_id SEPARATOR ',') FROM {trash_parents} WHERE parent_id IN (".$trash_ids.")");
					if ($trash_child_ids)
					{
						DB::query("DELETE FROM {trash_parents} WHERE element_id IN (".$trash_child_ids.")");
					}
					DB::query("DELETE FROM {trash_parents} WHERE element_id IN (".$trash_ids.")");
				}
				$folders = array($module.'/small', $module.'/medium', $module.'/files', $module.'/imgs', $module.'/imgs/small', $module);
				foreach ($folders as $folder)
				{
					if ($dirr = @opendir(ABSOLUTE_PATH.USERFILES.'/'.$folder))
					{
						while (($file = readdir($dirr)) !== false)
						{
							@unlink(ABSOLUTE_PATH.USERFILES.'/'.$folder.'/'.$file);
						}
						closedir($dirr);
					}
					rmdir(ABSOLUTE_PATH.USERFILES.'/'.$folder);
				}
				DB::query("DELETE FROM {modules} WHERE module_name='%s'", $module);
				continue;
			}

			//установка модуля
			foreach ($sql as $s)
			{
				DB::query($s);
			}

			if(! empty($adminsite)) 
			{
				foreach($adminsite as $v) 
				{
					adminsite($v); 
				}
			}
			$func = 'module_basic_'.$module;
			if (function_exists($func))
			{
				$func();
			}
			if (!empty($_POST["example_yes"]))
			{
				foreach ($example as $e)
				{
					if ($e)
					{
						DB::query($e);
					}
				}
				$func = 'module_example_'.$module;
				if (function_exists($func))
				{
					$func();
				}
			}
			//установка прав на административную часть установленного модуля текущему пользователю
			if(! $this->diafan->_user->roles('all', 'all'))
			{
				$result = DB::query("SELECT rewrite FROM {adminsite} WHERE rewrite='%s' OR rewrite LIKE '%s%%'", $module, $module);
				while ($row = DB::fetch_array($result))
				{
					DB::query("INSERT INTO {users_role_perm} (role_id, perm, rewrite, type) VALUES (%d, 'all', '%s', 'admin')", $this->diafan->_user->role_id, $row["rewrite"]);
				}
			}
		}

		$this->diafan->redirect($this->diafan->get_admin_url('page').'page2/');
	}

	/**
	 * Получает список всех модулей которые можно установить
	 *
	 * @param boolean $add_title добавить в массив информацию о названии модуля
	 * @return array
	 */
	private function get_rows($add_title = true)
	{
		$rows = array();
		if (! $dirr = @opendir(ABSOLUTE_PATH.'modules'))
		{
			return $rows;
		}
		while (($row = readdir($dirr)) !== false)
		{	  
			if (file_exists(ABSOLUTE_PATH.'modules/'.$row.'/'.$row.'.install.php'))
			{
				if($add_title)
				{
					include(ABSOLUTE_PATH.'modules/'.$row.'/'.$row.'.install.php');
					$rows[$row] = ! empty($title) ? $title : $row;
				}
				else
				{
					$rows[] = $row;
				}
			}
		}
		return $rows;
	}
}

/**
 * Адаптирует SQL запрос под текущее количество языковых версий сата
 *
 * @param string $str часть SQL-запроса
 * @return string
 */
function multilang($str)
{
	global $langs;
	if(! $langs)
		return;

	$result = '';

	$arg = func_get_args();
	$i = 0;

	foreach($langs as $lang)
	{
		if (! isset($arg[$i]))
		{
			$arg[$i] = $arg[$i - 1];
		}
		$str = $arg[$i];
		$result .= str_replace('LANG', $lang["id"], $str).' ';
		$i++;
	}
	return $result;
}


/**
 * Добавляет записи о модуле в таблицу {adminsite} - страницы админки
 *
 * @param array $values значения полей
 * @param integer $parent_id номер страницы админки - родителя
 * @return integer
 */
function adminsite($values, $parent_id = 0)
{
	if(empty($values["sort"]))
	{
		$values["sort"] = 0;
	}

    if (!empty($parent_id)) 
	{
        DB::query("UPDATE {adminsite} SET count_children=count_children+1 WHERE id=%d", $parent_id);
    }

	if (empty($parent_id))
	{
		DB::query("INSERT INTO {adminsite} (group_id, name, rewrite, numrow, act, sort) VALUES ('%s', '%s', '%s', %d, '%s', %d)", $values['group_id'], $values['name'], $values['rewrite'], $values['numrow'], $values['act'], $values['sort']);
		$last_id = DB::last_id("adminsite");
	}
	else 
	{
		DB::query("INSERT INTO {adminsite} (parent_id, group_id, name, rewrite, numrow, act, sort) VALUES (%d, %d, '%s', '%s', %d, '%s', %d)", $parent_id, $values['group_id'], $values['name'], $values['rewrite'], $values['numrow'], $values['act'], $values['sort']);
		$last_id = DB::last_id("adminsite");
		DB::query("INSERT INTO {adminsite_parents} (element_id, parent_id) VALUES (%d, %d)", $last_id, $parent_id);
	}

	if(!empty($values['child']))
	{
		foreach ($values['child'] as $k => $v)
		{
			$v["sort"] = $k;
			adminsite($v, $last_id);
		}
	}

    return $last_id;
}